package com.ssi.config;

import ch.qos.logback.classic.Level;
import ch.qos.logback.classic.spi.ILoggingEvent;
import ch.qos.logback.core.filter.Filter;
import ch.qos.logback.core.spi.FilterReply;

/**
 * @author SunnyHotz
 * @PackageName:com.ssi.config
 * @ClassName:LogbackConfig
 * @Description:
 * @date 2022/12/16 19:24
 */
public class LogbackConfig extends Filter<ILoggingEvent> {


    @Override
    public FilterReply decide(ILoggingEvent event) {
        String loggerName = event.getLoggerName();
        if(loggerName.startsWith("com.ssi.utils.grid")||loggerName.startsWith("com.ssi.kafka.listener.VehicleRealTimeInfoListener")){
            return FilterReply.DENY;
        }
        Level level = event.getLevel();
        if(level.levelInt<level.INFO_INT){
            return FilterReply.DENY;
        }
        return FilterReply.NEUTRAL;
    }
}
