package com.ssi.config;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.SchedulingConfigurer;
import org.springframework.scheduling.config.ScheduledTaskRegistrar;

import java.util.concurrent.ExecutorService;

/**
 * 任务调度配置
 * 默认的线城池为SingleThreadScheduledExecutor,所以为单线程
 */
@Configuration
public class ScheduleConfig implements SchedulingConfigurer {

    @Value("${spring.schedule.tasks:12}")
    private int tasks;

    @Autowired
    private ExecutorService executorService;

    /**
     * 配置多线程任务调度
     * @param scheduledTaskRegistrar
     */
    @Override
    public void configureTasks(ScheduledTaskRegistrar scheduledTaskRegistrar) {
        scheduledTaskRegistrar.setScheduler(executorService);
    }
}
