package com.ssi.constant;

import lombok.Getter;

/**
 * redis key 前缀常量
 *
 * @author 成东
 * @since 2020-03-20 9:44
 */
public enum RedisKey {

  CRANE_LOCATION("harbor:crane:location:"),
  CRANE_INFO("harbor:crane:info:"),
  ERROR_V2X_INFO("ivccs:vms:v2x:event:"),
  ERROR_TOS_INFO("ivccs:vms:tos:event:"),
  EMERGENCY_PARKING("harbor:remote:emergency_parking:"),
  VMS_TOS_ORDER("harbor:command:status:"),
  VEHICLE_TO_CRANE("harbor:crane:bridge_no:"),
  DYNAMIC_FENCE_SWITCH("ivccs:vms:dynamic:fence:switch"),
  DYNAMIC_FENCE_ALERT ("DYNAMIC_FENCE_ALERT"),
  DYNAMIC_FENCE_ORDER_ERROR ("DYNAMIC_FENCE_ORDER_ERROR"),
  VMS_CHARGING_ACTION("VMS_CHARGING_ACTION")
  ;


  public static String getPortMachineryLocation(String no) {
    return CRANE_LOCATION.getKeyPrefix() + no;
  }

  @Getter
  private String keyPrefix;

  RedisKey(String keyPrefix) {
    this.keyPrefix = keyPrefix;
  }

}
