package com.ssi.constant.enums;

import lombok.Getter;

/**
 * 终端指令执行结果枚举
 */
public enum CommandResultEnum {

    SUCCESS(1, "成功"),

    FAIL(2, "失败"),

    WRONG_COMMAND(3, "指令错误"),

    NOT_SUPPORTED(4, "不支持");


    @Getter
    private int code;
    @Getter
    private String description;

    CommandResultEnum(int code, String description) {
        this.code = code;
        this.description = description;
    }

    public static boolean isExecuteSuccess(int code){
        if(code == SUCCESS.code){
            return true;
        }
        return false;
    }

    public static CommandResultEnum find(int code){
        CommandResultEnum[] values = CommandResultEnum.values();
        for (CommandResultEnum anEnum : values){
            if(anEnum.getCode() == code){
                return anEnum;
            }
        }
        return null;
    }
}
