package com.ssi.constant.enums;

import lombok.Getter;

/**
 * 指令类型枚举类
 */
public enum CommandTypeEnum {

    START_ENGINE(1, "启动"),

    STOP_ENGINE(2, "熄火"),

    PARK(3, "停车"),

    FORWARD(4, "前移"),

    BACKWARD(5, "后退"),

    LEFT_TURN(6, "左转"),

    RIGHT_TURN(7, "右转");


    @Getter
    private int code;
    @Getter
    private String description;

    CommandTypeEnum(int code, String description) {
        this.code = code;
        this.description = description;
    }

    public static CommandTypeEnum find(int code){
        CommandTypeEnum[] values = CommandTypeEnum.values();
        for (CommandTypeEnum anEnum : values){
            if(anEnum.getCode() == code){
                return anEnum;
            }
        }
        return null;
    }
}
