package com.ssi.constant.enums;

import lombok.Getter;
import org.apache.http.HttpStatus;

/**
 * 响应状态枚举类
 */
public enum Status {

    SUCCESS(1, "成功"),//交易/请求成功

    ERROR(-1, "失败"),//交易/请求失败,未知错误

    UNAUTHORIZED(HttpStatus.SC_UNAUTHORIZED, "用户资源未授权无法访问"),
    NOTFOUND(HttpStatus.SC_NOT_FOUND, "路径不存在，请检查路径是否正确"),
    FILEUPLOADERROR(500, "文件上传失败");


    @Getter
    private int code;
    @Getter
    private String descript;

    Status(int code, String descript) {
        this.code = code;
        this.descript = descript;
    }

}
