package com.ssi.constant.enums;

import lombok.Getter;

/**
 * 任务地点类型枚举类
 */
public enum TaskLocationTypeEnum {

    TO_YARD(1, "去堆场"),

    TO_PARK(2, "去停车点"),

    TO_FIXED_PARK(3, "去固定停车区"),

    TO_TEMPORARY_PARK(4, "去零时停车区"),

    TO_PORT(5, "去桥吊"),

    TO_CHARGE(6, "充电");


    @Getter
    private int code;
    @Getter
    private String description;

    TaskLocationTypeEnum(int code, String description) {
        this.code = code;
        this.description = description;
    }

    public static TaskLocationTypeEnum find(int code){
        TaskLocationTypeEnum[] values = TaskLocationTypeEnum.values();
        for (TaskLocationTypeEnum anEnum : values){
            if(anEnum.getCode() == code){
                return anEnum;
            }
        }
        return null;
    }

}
