package com.ssi.constant.enums;

import lombok.Getter;

/**
 * 任务类型枚举类
 */
public enum TaskTypeEnum {

    LOAD(1, "装箱"),

    UNLOAD(2, "卸箱"),

    CHARGE(3, "充电"),

    LOCK(4, "上扭锁"),

    UNLOCK(5, "解扭锁"),

    PARK(6, "停车"),

    TURN_AROUND(7, "掉头");


    @Getter
    private int code;
    @Getter
    private String description;

    TaskTypeEnum(int code, String description) {
        this.code = code;
        this.description = description;
    }

    public static TaskTypeEnum find(int code){
        TaskTypeEnum[] values = TaskTypeEnum.values();
        for (TaskTypeEnum anEnum : values){
            if(anEnum.getCode() == code){
                return anEnum;
            }
        }
        return null;
    }

}
