package com.ssi.constant.enums;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

public enum TrafficLightEnum {
    LAMP_01(1,"turnRight","北向"),
    LAMP_05(5,"straight","北向"),
    LAMP_15(15,"turnLeft","北向"),
    LAMP_03(3,"turnRight","南向"),
    LAMP_13(13,"straight","南向"),
    LAMP_17(17,"turnLeft","南向"),
    LAMP_04(4,"turnRight","东向"),
    LAMP_14(14,"straight","东向"),
    LAMP_18(18,"turnLeft","东向"),
    LAMP_02(2,"turnRight","西向"),
    LAMP_06(6,"straight","西向"),
    LAMP_16(16,"turnLeft","西向"),
    ;
    private Integer phaseNo;
    private String directName;
    private String flagName;

    TrafficLightEnum(Integer phaseNo,String directName,String flagName){
        this.phaseNo = phaseNo;
        this.directName = directName;
        this.flagName =flagName;
    }

    public Integer getPhaseNo() {
        return phaseNo;
    }

    public String getDirectName() {
        return directName;
    }

    public String getFlagName() {
        return flagName;
    }

    public static TrafficLightEnum getEnumByPhaseNo(Integer phaseNo){
        TrafficLightEnum trafficLightEnum = Arrays.stream(TrafficLightEnum.values()).filter(e -> e.getPhaseNo().equals(phaseNo)).findAny().orElse(null);
        return trafficLightEnum;
    }

    public static List<TrafficLightEnum> getEnumsByPhaseNoFlagName(String flagName){
        List<TrafficLightEnum> enums = Arrays.stream(TrafficLightEnum.values()).filter(e -> e.getFlagName().equals(flagName)).collect(Collectors.toList());
        return enums;
    }
            

}
