package com.ssi.controller;

import com.dfssi.dataplatform.service.annotation.LogAudit;
import com.ssi.entity.CraneInfo;
import com.ssi.response.SSIResponse;
import com.ssi.service.CraneInfoService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.MimeTypeUtils;
import org.springframework.web.bind.annotation.*;

/**
 * 吊具信息控制器
 *
 * @author liheng
 * @email
 * @date 2020-09-01 16:29:29
 */
@Api
@RestController
@RequestMapping("/craneInfo")
public class CraneInfoController {

    @Autowired
    private CraneInfoService craneInfoService;

    /**
     * 获取桥吊、场吊信息列表
     */
    @LogAudit
    @PostMapping("/queryCraneList")
    @ApiOperation(value = "获取桥吊、场吊信息列表", response = SSIResponse.class, produces = MimeTypeUtils.APPLICATION_JSON_VALUE)
    public SSIResponse queryCraneList(@RequestBody(required = false) CraneInfo craneInfo) {
        return craneInfoService.queryCraneList(craneInfo);
    }

    /**
     * 获取桥吊、场吊、龙锁装卸区信息列表
     */
    @LogAudit
    @PostMapping("/queryCraneLockAreaList")
    @ApiOperation(value = "获取桥吊、场吊、龙锁装卸区信息列表", response = SSIResponse.class, produces = MimeTypeUtils.APPLICATION_JSON_VALUE)
    public SSIResponse queryCraneLockAreaList(@RequestBody(required = false) CraneInfo craneInfo) {
        return craneInfoService.queryCraneLockAreaList(craneInfo);
    }

    @GetMapping("/craneColor")
    @ApiOperation(value = "获取桥吊颜色配置", response = SSIResponse.class, produces = MimeTypeUtils.APPLICATION_JSON_VALUE)
    public SSIResponse queryCraneColor(@RequestParam(required = false) String craneNo) {
        return craneInfoService.queryCraneColor(craneNo);
    }

}
