package com.ssi.controller;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.dfssi.dataplatform.service.annotation.LogAudit;
import com.ssi.entity.VmsVehicleOperateTask;
import com.ssi.mapper.VmsVehicleOperateTaskMapper;
import com.ssi.response.SSIResponse;
import com.ssi.task.TaskOperateExecutor;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.MimeTypeUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.io.IOException;

/**
 * @author ZhangLiYao
 * @version 1.0
 * @date 2020/8/8 8:31
 */
@Api
@RestController
@RequestMapping("/screen")
public class OperateExecuteController {

    @Autowired
    private TaskOperateExecutor taskOperateExecutor;
    @Autowired
    private VmsVehicleOperateTaskMapper vmsVehicleOperateTaskMapper;

    /**
     * 执行任务
     */
    @LogAudit
    @ApiOperation(value = "执行任务", response = SSIResponse.class, produces = MimeTypeUtils.APPLICATION_JSON_VALUE)
    @GetMapping("/submitTask")
    public SSIResponse info(@RequestParam String vin,Long startTime,Long stopTime) throws IOException {
        VmsVehicleOperateTask vmsVehicleOperateTask = taskOperateExecutor.getVehicleOpreateByTime(vin, startTime, stopTime);
        int count = vmsVehicleOperateTaskMapper.selectCount(new LambdaQueryWrapper<VmsVehicleOperateTask>()
                .eq(VmsVehicleOperateTask::getVin,vin)
                .eq(VmsVehicleOperateTask::getTaskDate, vmsVehicleOperateTask.getTaskDate()));
        if(count <= 0){
            vmsVehicleOperateTaskMapper.insert(vmsVehicleOperateTask);
        }
        return SSIResponse.ok();
    }




}
