package com.ssi.controller;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.dfssi.dataplatform.service.annotation.LogAudit;
import com.ssi.constant.URL;
import com.ssi.entity.dto.VmsTosOrdersDto;
import com.ssi.model.RedisDataModel;
import com.ssi.response.SSIResponse;
import com.ssi.utils.RestTemplateUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.collections.map.HashedMap;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.util.Assert;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.util.MimeTypeUtils;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.*;

@Api(tags = "人工干预", description = "命令")
//@Slf4j
@RestController
@RequestMapping("/TaskToSend/data")
public class TaskTosSendController {

	@Value("${command-url}")
	private String odbuUrl;
	@Value("${gear-url}")
	private String gearUrl;
	@Autowired
	private RedisDataModel redisDataModel;
	@Value("${map-edit-url}")
	private String mapEditUrl;
//	@Autowired
//	private KafkaTemplate<String, String> kafkaTemplate;
//	private int tempResult = 0;

	/**
	 * tos 指令下发
	 */
	@LogAudit
	@ApiOperation(value = "去堆场", response = SSIResponse.class, produces = MimeTypeUtils.APPLICATION_JSON_VALUE)
	@PostMapping("/gotoHeap")
	public SSIResponse<?> sendHeap(@RequestBody VmsTosOrdersDto dto) {
		JSONObject param = new JSONObject();
		Date date = new Date();

//		param.put("seq", UUID.randomUUID().toString().replace("-", ""));// 序号
		param.put("taskAssociation", "");// 任务关联
		param.put("vin", dto.getVin());// 车辆编号
		param.put("taskLocationType", dto.getTaskLocationType());// 任务类型 作业位置类型
																	// 1-去堆场（装箱或卸箱）;2-去停车点（上扭锁，解扭锁，停车）;3-去固定停车区;4-去临时停车区;5-去桥吊（装箱或卸箱）；6-去充电
		param.put("taskType", dto.getTaskType());// 作业类型 1-装箱，2-卸箱
		param.put("cartonConditon", "0");// 辆当前装箱状态
		param.put("vehicleTaskType", dto.getVehicleTaskType());// 车辆任务类型 对应着前台 集装箱类型
		param.put("vehicleLocation", dto.getVehicleLocation());// 车辆任务目标地点 对应前台 堆场贝位
		param.put("portType", 2);// 港机类型
		if(null!=dto.getContainerWeight()) {
			param.put("containerWeight", dto.getContainerWeight());// 集装箱重量
		}else {
			param.put("containerWeight",5);// 集装箱重量
		}
		
		param.put("taskSource", 2);// 1-TOS下发;2-手动下发;3-VMS下发
		param.put("collectTime", date);// 作业时间
//        param.put("voyuageNo","");//艘次编号
		param.put("lockLabel", 1);// 扭锁标签
		if (dto.getTaskLocationType().equals(1)) {
			param.put("containerLabel", 1);
		} else {
			param.put("containerLabel", 2);
		}

//		if (dto.getTaskType().equals(1)) {
//			param.put("vehicleTaskLabel", 1);
//		}
//		if (dto.getTaskType().equals(2)) {
//			param.put("vehicleTaskLabel", 2);
//		}
		param.put("vehicleTaskLabel", dto.getVehicleTaskLabel());//车辆任务标签,1:装船；2：卸船；3：堆场间搬移；4：停车，5：充电，6：临时停车
		// 如果车辆任务类型 为装船，那么作业类型必须为装箱
		if(dto.getVehicleTaskLabel()==1) {
			if(dto.getTaskType()==2) {
				return SSIResponse.no("车辆任务类型为装船，作业类型必须为装箱");
			}
		}
		if(null!=dto.getVoyageNo()) {
			param.put("voyageNo", dto.getVoyageNo());// 艘次编号 对应前台朝向 朝东16855朝西 16844
		}
		
		String result = "";
		// 双小箱
		if (dto.getVehicleTaskType() == 2) {
			param.put("containerNum", 2);// 集装箱个数
			String parentTaskNo = "";
			param.put("containerType", "20");// 集装箱类型
			for (int i = 0; i < 2; i++) {
				param.put("taskNo", UUID.randomUUID().toString().replace("-", ""));// 任务编号
				if (i == 0) {
					param.put("containerId", dto.getContainerId());// 前集装箱ID
					param.put("vehicleLocation", dto.getVehicleLocation());// 车辆任务目标地点 对应前台 堆场贝位
					param.put("portCode", dto.getPortCode());// 对应前台轮胎吊编号
					param.put("containerPosition", 01);// 集装箱位置
					parentTaskNo = param.getString("taskNo");
					param.put("parentTaskNo",parentTaskNo);
				}
				if (i == 1) {
					param.put("containerId", dto.getContainerIdT());// 后集装箱ID
					param.put("vehicleLocation", dto.getVehicleLocationT());// 车辆任务目标地点 对应前台 后堆场贝位
					param.put("portCode", dto.getPortCodeT());// 港机编码 对应前台轮胎吊编号
					param.put("containerPosition", 03);// 集装箱位置
					param.put("parentTaskNo",parentTaskNo);
				}
				param.put("containerSize", "20");
				
//        		  temp+=sendTos(dto.getVin(),param.toString());// 推送kafa
				if(i==0) {
					redisDataModel.del("harbor:command:twenty_foot:order:" + dto.getVin());//双小箱任务之前 先把这个key清掉
				}
				result = RestTemplateUtil.post(String.format("%s%s", odbuUrl, URL.To_ODBU_URL), param.toString(), null);

			}
		} else {
			if (dto.getVehicleTaskType()==1) { // 1-大箱;2-双小箱;3-单小箱;0-其它
				param.put("containerType", "40");// 集装箱类型
				param.put("containerSize", "40");
				// 集装箱车上位置, 1-前;2-中;3-后 (传给车端的数据 0x01: 中心 0x02: 前端 0x03: 后端)
				param.put("containerPosition", 02);// 集装箱类型

			} else {//单小箱
				// 集装箱车上位置, 1-前;2-中;3-后 (传给车端的数据 0x01: 中心 0x02: 前端 0x03: 后端)
				param.put("containerPosition", 03);
				param.put("containerType", "20");// 集装箱类型
				param.put("containerSize", "20");
			}
			param.put("containerNuber", 1);// 集装箱个数
			param.put("portCode", dto.getPortCode());// 港机编码 对应前台轮胎吊编号
			param.put("containerId", dto.getContainerId());// 集装箱ID
			param.put("taskNo", UUID.randomUUID().toString().replace("-", ""));// 任务编号
			param.put("parentTaskNo",param.getString("taskNo"));
//        	 temp= sendTos(dto.getVin(),param.toString());// 推送kafa
			result = RestTemplateUtil.post(String.format("%s%s", odbuUrl, URL.To_ODBU_URL), param.toString(), null);
		}
//        if(temp==-1 || temp==-2 || temp==0) {
//   		 return SSIResponse.no("推送失败");
//   	 }else {
//   		 return SSIResponse.ok();
//   	 }
		JSONObject jsonObject = JSONObject.parseObject(result);
		return SSIResponse.ok(jsonObject);
	}

	/**
	 * tos 指令下发
	 */
	@LogAudit
	@ApiOperation(value = "去桥吊", response = SSIResponse.class, produces = MimeTypeUtils.APPLICATION_JSON_VALUE)
	@PostMapping("/goBridgeCrane")
	public SSIResponse<?> goBridgeCrane(@RequestBody VmsTosOrdersDto dto) {
		JSONObject param = new JSONObject();
		Date date = new Date();
		param.put("seq", UUID.randomUUID().toString().replace("-", ""));// 序号
		param.put("taskAssociation", "");// 任务关联
		param.put("vin", dto.getVin());// 车辆编号 ，
		param.put("taskLocationType", dto.getTaskLocationType());// 任务类型 作业位置类型
		param.put("taskSource", 2);// 1-TOS下发;2-手动下发;3-VMS下发											// 1-去堆场（装箱或卸箱）;2-去停车点（上扭锁，解扭锁，停车）;3-去固定停车区;4-去临时停车区;5-去桥吊（装箱或卸箱）；6-去充电
		param.put("taskType", dto.getTaskType());// 作业类型 1-装箱，2-卸箱
		param.put("cartonConditon", "0");// 辆当前装箱状态
		param.put("vehicleTaskType", dto.getVehicleTaskType());// 车辆任务类型 对应着前台 集装箱类型
		String tempvehicleLocation=""; 
		if(dto.getPortCode().length()<3) {
			if(dto.getPortCode().length()==2) {
				tempvehicleLocation=dto.getVehicleLocation()+"0"+dto.getPortCode();
			}
			if(dto.getPortCode().length()==1) {
				tempvehicleLocation=dto.getVehicleLocation()+"00"+dto.getPortCode();
			}
			
		}else {
			tempvehicleLocation=dto.getVehicleLocation()+dto.getPortCode();
		}
		param.put("vehicleLocation", tempvehicleLocation);// 车辆任务目标地点 对应前台 桥吊编号
		param.put("portCode", dto.getPortCode());// 港机编码 对应前台车吊编号
		param.put("portType", 1);// 港机类型

		if(null!=dto.getContainerWeight()) {
			param.put("containerWeight", dto.getContainerWeight());// 集装箱重量
		}else {
			param.put("containerWeight",5);// 集装箱重量
		}
		
		param.put("voyageNo", dto.getVoyageNo());// 艘次编号 对应前台朝向 朝东16855朝西 16844
		param.put("collectTime", date);// 作业时间
//         param.put("voyuageNo","");//艘次编号
		param.put("lockLabel", 1);// 扭锁标签
		if(null !=dto.getContainerLabel()) {
			param.put("containerLabel",dto.getContainerLabel());
		}else {
			param.put("containerLabel",1);
		}
//		if (dto.getTaskLocationType().equals(1)) {
//			param.put("containerLabel", "1");
//		} else {
//			param.put("containerLabel", "2");
//		}
//		if (dto.getTaskType().equals(1)) {
//		 
		param.put("vehicleTaskLabel", dto.getVehicleTaskLabel());
//			param.put("vehicleTaskLabel", 2);// 车辆任务标签
//		}
//		if (dto.getTaskType().equals(2)) {
//			param.put("vehicleTaskLabel", 1);
//		}
//		int temp = 0;
		String result = "";
		// 双小箱
		if (dto.getVehicleTaskType() == 2) {
			param.put("containerType", "20");// 集装箱类型
			param.put("containerNuber", 2);// 集装箱个数
			for (int i = 0; i < 2; i++) {
				param.put("taskNo", UUID.randomUUID().toString().replace("-", ""));// 任务编号
				if (i == 0) {
					param.put("containerId", dto.getContainerId());// 前集装箱ID
					param.put("containerPosition", 01);// 集装箱位置
				}
				if (i == 1) {
					param.put("containerId", dto.getContainerIdT());// 后集装箱ID
					param.put("containerPosition", 03);// 集装箱位置
				}
				param.put("containerSize", "20");
//         		   temp+=sendTos(dto.getVin(),param.toString());// 推送kafa
				result = RestTemplateUtil.post(String.format("%s%s", odbuUrl, URL.To_ODBU_URL), param.toString(), null);
			}
		} else {
			param.put("taskNo", UUID.randomUUID().toString().replace("-", ""));// 任务编号
			if (dto.getVehicleTaskType()==1) { // 1-大箱;2-双小箱;3-单小箱;0-其它
				param.put("containerType", "40");// 集装箱类型
				param.put("containerSize", "40");
				// 集装箱车上位置, 1-前;2-中;3-后 (传给车端的数据 0x01: 中心 0x02: 前端 0x03: 后端)
				param.put("containerPosition", 02);// 集装箱位置

			} else {
				// 集装箱车上位置, 1-前;2-中;3-后 (传给车端的数据 0x01: 中心 0x02: 前端 0x03: 后端)
				param.put("containerPosition", 02); // 集装箱位置
				param.put("containerType", "20");// 集装箱类型
				param.put("containerSize", "20");
			}
//              param.put("containerId",dto.getContainerId());//集装箱ID
			param.put("containerNuber", 1);// 集装箱个数
//			param.put("taskNo", UUID.randomUUID().toString().replace("-", ""));// 任务编号
//         	  temp= sendTos(dto.getVin(),param.toString());// 推送kafa
			System.out.print(param.toString());
			result = RestTemplateUtil.post(String.format("%s%s", odbuUrl, URL.To_ODBU_URL), param.toString(), null);

		}
//         if(temp==-1 || temp==-2 || temp==0) {
//    		 return SSIResponse.no("推送失败");
//    	 }else {
//    		 return SSIResponse.ok();
//    	 }
		JSONObject jsonObject = JSONObject.parseObject(result);
		return SSIResponse.ok(jsonObject);
	}

	/**
	 * tos 指令下发, 去停车场，去缓存区，去充电,取消充电，取消当前任务
	 */
	@LogAudit
	@ApiOperation(value = "去停车场,去充电，去临时停车区，取消", response = SSIResponse.class, produces = MimeTypeUtils.APPLICATION_JSON_VALUE)
	@PostMapping("/gospace")
	public SSIResponse<?> gospace(@RequestBody VmsTosOrdersDto dto) {

		JSONArray resultMsg = new JSONArray();
		String vin = dto.getVin();
		String[] vins = vin.split(",");
		List<Map>  parkList = new ArrayList();
		if ("6".equals(dto.getTaskType()) && vins.length>1) {
			//如果是批量去停车区  需要查询空闲的停车区
			parkList = getParkList();
			if(parkList==null || (parkList!=null && parkList.size()<vins.length)){
				return SSIResponse.ok(parkErrorInfo());
			}

		}
		for (int i = 0; i < vins.length; i++) {
			String tmpVin = vins[i];
			JSONObject param = new JSONObject();
//    	  Date date =new Date();
			String temp = URL.To_ODBU_URL;
			param.put("vin", tmpVin);// 车辆编号
			param.put("taskSource", 2);// 1-TOS下发;2-手动下发;3-VMS下发
//    	  param.put("taskLocationType",dto.getTaskLocationType());// 任务类型 作业位置类型 1-去堆场（装箱或卸箱）;2-去停车点（上扭锁，解扭锁，停车）;3-去固定停车区;4-去临时停车区;5-去桥吊（装箱或卸箱）；6-去充电 7 取消充电 8 取消当前任务
			param.put("taskNo", UUID.randomUUID().toString().replace("-", ""));// 任务编号
			param.put("seq", param.getString("taskNo"));// 序号
			if (null != dto.getTaskType()) {
				param.put("taskType", dto.getTaskType());// 任务编号 6 停车 3 充电
				if (dto.getTaskType().equals(3)) {
					// 车辆任务标签,1:装船；2：卸船；3：堆场间搬移；4：停车，5：充电，6：临时停车
					param.put("vehicleTaskLabel", 5); //
				}
				if (dto.getTaskType().equals(6)) {
					// 车辆任务标签,1:装船；2：卸船；3：堆场间搬移；4：停车，5：充电，6：临时停车
					param.put("vehicleTaskLabel", 4); //
				}
				if (dto.getTaskType().equals(4)) {
					// 车辆任务标签,1:装船；2：卸船；3：堆场间搬移；4：停车，5：充电，6：临时停车
					param.put("vehicleTaskLabel", 6); //
				}

			}
			if (null != dto.getTaskLocationType()) {
				// "任务类型, 1-去堆场（装箱或卸箱）;2-去停车点（上扭锁，解扭锁，停车）;3-去固定停车区;4-去临时停车区;5-去桥吊（装箱或卸箱）；6-去充电"
				param.put("taskLocationType", dto.getTaskLocationType()); //
//			if(dto.getTaskLocationType().equals("4")) {
//				temp=URL.To_ODBU_EDIT_POSITION;
//			}
			}
//		if (null != dto.getStatus()) {
//			//  49 停车锁死， 65 开始行驶
//			param.put("status", dto.getStatus()); //
//			if(dto.getStatus().equals("49")) {
//				temp=URL.To_ODBU_EDIT_STATUS;
//			}
//		}
			if (null != dto.getVehicleLocation()) {
//    		 param.put("portCode", dto.getPortCode());// 停车场编号
				param.put("vehicleLocation", dto.getVehicleLocation());// 车辆任务目标地点 对应前台 车道编号
			}
			if (null != dto.getTaskOperation()) {
				param.put("taskOperation", dto.getTaskOperation()); // 任务操作：0-开始，1-取消，2-强制取消
				if (dto.getTaskOperation().equals(2)) {
					temp = URL.To_ODBU_Cancle;
				}
			}
			if (null != dto.getParkingAreaNo()&&vins.length==1) {//批量停车不支持指定停车区
				param.put("parkingAreaNo", dto.getParkingAreaNo());// 停车区编号，缓冲区编号，充电位编号
			}
			if(vins.length>1 && dto.getTaskType().equals(6)){
				param.put("parkingAreaNo", parkList.get(i).get("name"));// 停车区编号，缓冲区编号，充电位编号
			}
			if (null != dto.getVoyageNo()) {
				param.put("voyageNo", dto.getVoyageNo());// 艘次编号 对应前台朝向 朝东16855朝西 16844
			}

			if (null != dto.getLatitude()) {
				param.put("latitude", dto.getLatitude());// 目的地维度
			}
			if (null != dto.getLongitude()) {
				param.put("longitude", dto.getLongitude());// 目的地经度
			}
			if (null != dto.getPointList()) {
				if (dto.getPointList().size() > 1) {

					param.put("pointList", dto.getPointList());// 目的地经度
				}
			}
			param.put("backHeading", StringUtils.isNotBlank(dto.getBackHeading())?dto.getBackHeading():0);
			param.put("forwardHeading",StringUtils.isNotBlank(dto.getForwardHeading())?dto.getForwardHeading():0);
			String result = RestTemplateUtil.post(String.format("%s%s", odbuUrl, temp), param.toString(), null);
//    	 int temp= sendTos(dto.getVin(),param.toString());

//    	 if(temp==-1) {
//    		 return SSIResponse.no("推送失败");
//    	 }else {
//    		 return SSIResponse.ok();
//    	 }
//
			JSONObject jsonObject = JSONObject.parseObject(result);
			JSONObject statusObj = jsonObject.getJSONObject("status");
			if(statusObj.getInteger("code") == 9999){
				resultMsg.add(tmpVin+statusObj.getString("details"));
			}
		}
		JSONObject result = new JSONObject();
		result.put("data","");
		JSONObject status = new JSONObject();
		result.put("status",status);
		status.put("msg","成功");
		status.put("code","0000");
		if(resultMsg.size()>0){
			status.put("msg","失败");
			status.put("code","9999");
			status.put("details",resultMsg.toJSONString());
		}
		return SSIResponse.ok(result);
	}

	private  List<Map>  getParkList(){
		Map param  = new HashedMap();
		param.put("state",0);// 状态。0可用；1不可用（初始状态）;2已计划;3有车
		param.put("type", 2);// 类型。1缓冲区；2停车区;3:充电区
		String paramData = JSONObject.toJSONString(param);
		String parkResult = RestTemplateUtil.post(String.format("%s%s", mapEditUrl, URL.MAP_QUERY_URL), paramData, null);
		Map  map = JSONObject.parseObject(parkResult,Map.class);
		List <Map>  parkList  =  JSONArray.parseArray(map.get("data")+"",Map.class);
		return parkList;
	}

	private Map  parkErrorInfo(){
		Map result = new HashMap();
		JSONObject status = new JSONObject();
		result.put("status",status);
		status.put("msg","可用停车区不足");
		status.put("code","9999");
		status.put("details","");
		return result;
	}

	@LogAudit
	@ApiOperation(value = "强制上档", response = SSIResponse.class, produces = MimeTypeUtils.APPLICATION_JSON_VALUE)
	@PostMapping("/forceGoShipCraneLane")
	public SSIResponse<?> upshift(@RequestBody VmsTosOrdersDto dto) {
		JSONObject param = new JSONObject();
		param.put("vin", dto.getVin());// 车辆编号
		String result = RestTemplateUtil.post(String.format("%s%s", gearUrl, URL.upshift_URL), param.toString(), null);
		JSONObject jsonObject = JSONObject.parseObject(result);
		return SSIResponse.ok(jsonObject);
	}

	@LogAudit
	@ApiOperation(value = "更改车辆位置", response = SSIResponse.class, produces = MimeTypeUtils.APPLICATION_JSON_VALUE)
	@PostMapping("/updatePosition")
	public SSIResponse<?> updatePosition(@RequestBody VmsTosOrdersDto dto) {
		JSONObject param = new JSONObject();
	
		param.put("vin", dto.getVin());// 车辆编号
		param.put("seq", UUID.randomUUID().toString().replace("-", ""));// 序号
		param.put("taskNo", UUID.randomUUID().toString().replace("-", ""));// 任务编号
		param.put("taskSource", 2);// 1-TOS下发;2-手动下发;3-VMS下发
		if (null != dto.getTaskLocationType()) {
			// "任务类型, 1-去堆场（装箱或卸箱）;2-去停车点（上扭锁，解扭锁，停车）;3-去固定停车区;4-去临时停车区;5-去桥吊（装箱或卸箱）；6-去充电"
			param.put("taskLocationType", dto.getTaskLocationType()); //
 
		}
//		if (null != dto.getStatus()) {
//			//  49 停车锁死， 65 开始行驶
//			param.put("status", dto.getStatus()); //
//			if(dto.getStatus().equals("49")) {
//				temp=URL.To_ODBU_EDIT_STATUS;
//			}
//		}
		if (null != dto.getVehicleLocation()) {
//    		 param.put("portCode", dto.getPortCode());// 停车场编号
			param.put("vehicleLocation", dto.getVehicleLocation());// 车辆任务目标地点 对应前台 车道编号
		}
		String result = RestTemplateUtil.post(String.format("%s%s", odbuUrl, URL.To_ODBU_EDIT_POSITION), param.toString(), null);
		JSONObject jsonObject = JSONObject.parseObject(result);
		return SSIResponse.ok(jsonObject);
	}

	@LogAudit
	@ApiOperation(value = "更改任务状态", response = SSIResponse.class, produces = MimeTypeUtils.APPLICATION_JSON_VALUE)
	@PostMapping("/updateStatus")
	public SSIResponse<?> updataStatus(@RequestBody VmsTosOrdersDto dto) {
		JSONObject param = new JSONObject();
		param.put("vin", dto.getVin());// 车辆编号
		param.put("seq", UUID.randomUUID().toString().replace("-", ""));// 序号
		param.put("taskNo", UUID.randomUUID().toString().replace("-", ""));// 任务编号
		param.put("taskSource", 2);// 1-TOS下发;2-手动下发;3-VMS下发
		if (null != dto.getTaskLocationType()) {
			// "任务类型, 1-去堆场（装箱或卸箱）;2-去停车点（上扭锁，解扭锁，停车）;3-去固定停车区;4-去临时停车区;5-去桥吊（装箱或卸箱）；6-去充电"
			param.put("taskLocationType", dto.getTaskLocationType()); //
 
		}
		if (null != dto.getStatus()) {
			//  49 停车锁死， 65 开始行驶
			param.put("status", dto.getStatus()); //
		
		}
 
		String result = RestTemplateUtil.post(String.format("%s%s", odbuUrl, URL.To_ODBU_EDIT_STATUS), param.toString(), null);
		JSONObject jsonObject = JSONObject.parseObject(result);
		return SSIResponse.ok(jsonObject);
	}
//    public  int sendTos(String key,String param) {
//        ListenableFuture<SendResult<String, String>> send=
//        		kafkaTemplate.send(topic,key,param);
//        send.addCallback(result -> {
//        	tempResult=1;
//            log.info(String.format("推送成功：%s", result));
//          }, ex -> {
//            if (ex != null) {
//              log.error("推送失败!", ex);
//              tempResult=-1;
//            }
//          });
//        kafkaTemplate.flush();
//        return tempResult;
//    }

	@LogAudit
	@ApiOperation(value = "紧急停止", response = SSIResponse.class, produces = MimeTypeUtils.APPLICATION_JSON_VALUE)
	@PostMapping("/emergeStop")
	public SSIResponse<?> emergeStop(@RequestBody JSONObject req) {
		Assert.notNull(req.getString("vin"),"vin 不能为null");
		Assert.notNull(req.getString("emergencyType"),"emergencyType 不能为null");

		String result = RestTemplateUtil.post(String.format("%s%s", odbuUrl, URL.EMERGENCY_COMMAND), req.toString(), null);
		JSONObject jsonObject = JSONObject.parseObject(result);
		return SSIResponse.ok(jsonObject);
		
	}
}
