package com.ssi.controller;

import com.dfssi.dataplatform.service.annotation.LogAudit;
import com.ssi.constant.enums.V2xEventTypeEnums;
import com.ssi.entity.V2xEvent;
import com.ssi.response.SSIResponse;
import com.ssi.service.V2xEventService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.stream.Collectors;

/**
 *  车路协调接口控制器
 */
@Api(tags = "车路协调接口控制器",description = "车路协调接口控制器")
@RestController
@RequestMapping("/v2xEvent")
public class V2xEventController {

    @Autowired
    private V2xEventService v2xEventService;

    @LogAudit
    @ApiOperation(value = "车路协同历史数据")
    @GetMapping("/select")
    public SSIResponse select() {
       List<V2xEvent>   list =  v2xEventService.selectHistory();
       list = list.stream().map(x->{x.setTypeName(V2xEventTypeEnums.find(x.getType()).getDescript()); return x;}).collect(Collectors.toList());
       return SSIResponse.ok(list);
    }
}
