package com.ssi.controller;

import com.alibaba.fastjson.JSONObject;
import com.ssi.constant.RedisKey;
import com.ssi.model.RedisDataModel;
import com.ssi.model.VehicleSocketDataCacheQueueModel;
import com.ssi.response.SSIResponse;
import com.ssi.utils.RestTemplateUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.util.MimeTypeUtils;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@Api(tags = "检查服务", description = "命令")
@RestController
@Slf4j
@RequestMapping("/CheckService")
public class VmsCheckServiceController {

	@Value("${BridgeCrane-url}")
	private String bcUrl;// 桥吊 url

	@Value("${Shift-url}")
	private String shiftUrl;// 上档url

	@Value("${tos-url}")
	private String tosUrl;// 上档url

	@Value("${PathPlanning-url}")
	private String PathPlanningUrl;// 路径规划url

	@Value("${command-url}") // 车辆服务url
	private String vehicleUrl;
	@Autowired
	private RedisDataModel redisDataModel;
	@Value("${harbor.command.info_key:harbor:command:vin:info}")
	private String infoKey;
	@Autowired(required = false)
	private VehicleSocketDataCacheQueueModel vehicleSocketDataCacheQueueModel;

	@Value("${vehicle.status.redis.keyPrefix:harbor:vehicle:online}")
	private String statusRedisKeyPrefix;

	@ApiOperation(value = "检查服务", response = SSIResponse.class, produces = MimeTypeUtils.APPLICATION_JSON_VALUE)
	@PostMapping("/CheckAllService")
	public SSIResponse<?> CheckService() {
		JSONObject result = new JSONObject();
		Map<String, String> tempCheckShiftUrl = new HashMap<String, String>();
		Map<String, String> tempCheckPathPlanning = new HashMap<String, String>();
//		String tempCheckPathPlanning = "";
		List<Map> checkBridgeCraneStr = new ArrayList<Map>();
		Set<String> portcodekes = redisDataModel.keys(RedisKey.CRANE_INFO.getKeyPrefix() + "*");

		portcodekes.stream().forEach(key -> {
//			System.out.println(key);
			String str1 = redisDataModel.get(key);
			if (null != str1) {
				JSONObject strJson = JSONObject.parseObject(str1);
				if (null != strJson.get("portType")) {
					if (Integer.parseInt(strJson.get("portType").toString()) == 1) {
						String tempResult = CheckBridgeCrane(strJson.get("portCode").toString());
						Map<String, String> temp = new HashMap<String, String>();
						if (null != tempResult) {
							if (tempResult.equals("服务异常,未开启")) {
//									tempCheckBridgeCrane1 = "101桥吊服务运行异常,未开启";
								temp.put("depict", strJson.get("portCode").toString() + "桥吊服务运行异常,未开启");
								temp.put("status", "1");
								temp.put("portCode", strJson.get("portCode").toString());
								checkBridgeCraneStr.add(temp);
							} else {
								JSONObject CheckBridgeCrane = JSONObject.parseObject(tempResult);
								if (null != CheckBridgeCrane.get("latitude")
										&& null != CheckBridgeCrane.get("longitude")) {
//										tempCheckBridgeCrane1 = "101桥吊服务运行正常";
									temp.put("depict", strJson.get("portCode").toString() + "桥吊服务运行正常");
									temp.put("status", "0");
									temp.put("portCode", strJson.get("portCode").toString());
									checkBridgeCraneStr.add(temp);
								} else {
									temp.put("depict", strJson.get("portCode").toString() + "桥吊服务运行异常");
									temp.put("status", "1");
									temp.put("portCode", strJson.get("portCode").toString());
									checkBridgeCraneStr.add(temp);
//										tempCheckBridgeCrane1 = "101桥吊服务运行异常";
								}
							}

						} else {
							temp.put("depict", strJson.get("portCode").toString() + "桥吊服务运行异常,未开启");
							temp.put("status", "1");
							temp.put("portCode", strJson.get("portCode").toString());
							checkBridgeCraneStr.add(temp);
//						checkBridgeCraneStr.add(strJson.get("portCode").toString() + "桥吊服务运行异常,未开启");
//								tempCheckBridgeCrane1 = "101桥吊服务运行异常";
						}
					}
				}
			}

		});

		// 检查上档服务
	/*	String tempResult2 = CheckShiftUrl();
		if (null != tempResult2) {
			if (tempResult2.equals("服务异常,未开启")) {
				tempCheckShiftUrl.put("depict", "上档服务运行异常,未开启");
				tempCheckShiftUrl.put("status", "1");
			} else {
				tempCheckShiftUrl.put("depict", "上档服务运行正常");
				tempCheckShiftUrl.put("status", "0");
			}

		} else {
			tempCheckShiftUrl.put("depict", "上档服务运行异常");
			tempCheckShiftUrl.put("status", "1");

		}*/
		// 检查路径规划服务
		String tempResult3 = CheckPathPlanning();
		if (null != tempResult3) {
			if (tempResult3.equals("服务异常,未开启")) {
				tempCheckPathPlanning.put("depict", "路径规划服务运行异常,未开启");
				tempCheckPathPlanning.put("status", "1");

			} else {
				JSONObject CheckPath = JSONObject.parseObject(tempResult3);
				if (CheckPath.get("code").equals(1)) {
					tempCheckPathPlanning.put("depict", "路径规划服务运行正常");
					tempCheckPathPlanning.put("status", "0");
//					tempCheckPathPlanning = "路径规划服务运行正常";
				} else {
					tempCheckPathPlanning.put("depict", "路径规划服务运行异常");
					tempCheckPathPlanning.put("status", "1");

				}
			}

		} else {
			tempCheckPathPlanning.put("depict", "路径规划服务运行异常");
			tempCheckPathPlanning.put("status", "1");
//			tempCheckPathPlanning = "路径规划服务运行异常";
		}
		// 检查车管平台服务
		List<Map> vehiclelist = CheckVehicle();

		//检查TOS服务
		JSONObject tosService = checkTosService();
		result.put("CheckBridgeCrane", checkBridgeCraneStr);
		result.put("CheckShiftUrl", tosService);
		result.put("CheckPathPlanning", tempCheckPathPlanning);
		result.put("CheckVehicle", vehiclelist);
//		result.put("CheckTosService", tosService);
		return SSIResponse.ok(result);
	}

	private JSONObject checkTosService() {
		JSONObject jsonObject = new JSONObject();
		jsonObject.put("status","1");
		jsonObject.put("depict","TOS服务异常");
		try {
			String depict = RestTemplateUtil.getInstance().getForObject(tosUrl, String.class);
			jsonObject.put("status","0");
			jsonObject.put("depict",depict);
		} catch (Exception e) {
			log.info("TOS服务异常",e);
		}
		return jsonObject;
	}

	/**
	 * 检查桥吊服务
	 * 
	 * @param number
	 * @return
	 */
	public String CheckBridgeCrane(String number) {
		JSONObject jsonObject = new JSONObject();
		jsonObject.put("craneNum", number);
		jsonObject.put("laneNum", 4);
		jsonObject.put("containerSize", 1);
		jsonObject.put("containerPosition", 2);
		String result = "";
		try {
			result = RestTemplateUtil.post(bcUrl, jsonObject.toString(), null);
		} catch (Exception e) {
			result = "服务异常,未开启";
		}
		return result;
	}

	/**
	 * 检查上档服务
	 * 
	 * @return
	 */

	public String CheckShiftUrl() {
		JSONObject jsonObject = new JSONObject();
		jsonObject.put("cntr_id", "BMOU2866464");
		String result = "";
		try {
			result = RestTemplateUtil.post(shiftUrl, jsonObject.toString(), null);
		} catch (Exception e) {
			result = "服务异常,未开启";
		}

		return result;
	}

	/**
	 * 检查路径规划服务
	 * 
	 * @return
	 */
	public String CheckPathPlanning() {
		JSONObject jsonObject = new JSONObject();
		jsonObject.put("sourceLat", 24.45724154);
		jsonObject.put("vehicleTaskLabel", "3");
		jsonObject.put("isBeforehand", false);
		jsonObject.put("targetLng", 117.96814939);
		jsonObject.put("berthWay", 0);
		jsonObject.put("targetType", 1);
		jsonObject.put("vin", "LGAS4P659LD000050");
		jsonObject.put("targetLat", 24.45795811);
		jsonObject.put("sourceLng", 117.96904188);
		jsonObject.put("voyageNo", "16844");
		String result = "";
		try {
			result = RestTemplateUtil.post(PathPlanningUrl, jsonObject.toString(), null);
		} catch (Exception e) {
			result = "服务异常,未开启";
		}
		return result;

	}

	/**
	 * 检查车管平台服务
	 * 
	 * @return
	 */
	public List<Map> CheckVehicle() {
//		JSONObject jsonObject = new JSONObject();
//		String tempResult = "";
//		String result="";
		List<Map> resultlist = new ArrayList<Map>();
		Map<String, Map<String, Object>> messages = vehicleSocketDataCacheQueueModel.getAllVehicleData();
		if (!messages.isEmpty()) {
			// 大屏列表推送
			// log.info(String.format("进入无人集卡判断: %s", JSON.toJSONString(messages)));
			for (Map.Entry<String, Map<String, Object>> entry : messages.entrySet()) {
//                 String key="harbor:command:vin:info";
				String keys = String.format("%s:%s", infoKey, entry.getKey());
				String vehicleMap = redisDataModel.get(keys);
				if (vehicleMap != null) {// 判断redis是否存在，不存在则查询数据库
					JSONObject jsonObject = JSONObject.parseObject(vehicleMap);
					Integer vehicleType = (Integer) jsonObject.get("vehicleType");// 1:X69B ,2:X69C,3:有人集卡两秒
					if (vehicleType != 3) {
						Map tempmap = new HashMap();

//                    	  JSONObject json = JSONObject.parseObject(entry.getValue().toString());
						tempmap.put("vehicleNum", entry.getValue().get("vehicleNum"));
						tempmap.put("soc", entry.getValue().get("soc"));
						tempmap.put("isOnline", entry.getValue().get("isOnline"));
						resultlist.add(tempmap);
					}
				}
			}
		}

		Collections.sort(resultlist, new Comparator<Map>() {
			@Override
			public int compare(Map s1, Map s2) {
				return s1.get("vehicleNum").toString().compareTo(s2.get("vehicleNum").toString());
			}
		});

//		  for(Map obj:resultlist) {
//		
//
//		  }

//		List<Map> vehicle = vmsVehicleServiceImpl.getVmsVehicle();
//		for (Map<?, ?> map : vehicle) {
//			map.get("vin");
//			jsonObject.put("taskOperation", 2); // 任务操作：0-开始，1-取消，2-强制取消
//			jsonObject.put("vin", map.get("vin")); // 任务操作：0-开始，1-取消，2-强制取消
//			try {
//				tempResult = RestTemplateUtil.post(String.format("%s%s", vehicleUrl, URL.To_ODBU_Cancle),
//						jsonObject.toString(), null);
//			} catch (Exception e) {
//				tempResult = "服务异常,未开启";
//			}
//			if (null != tempResult) {
//				if (tempResult.equals("服务异常,未开启")) {
////					result = ;
//					resultlist.add(map.get("vehicleNum") + "车服务运行异常;");
//				} else {
//					JSONObject tmp = JSONObject.parseObject(tempResult);
//					JSONObject tmp1 = JSONObject.parseObject(tmp.get("status").toString());
//					if (tmp1.get("details").equals("车辆下线，任务执行失败")) {
////						result+=map.get("vehicleNum")+"车辆下线;";
//						resultlist.add(map.get("vehicleNum") + "车辆下线;");
//					}
//					if (tmp1.get("details").equals("没有可取消的任务") || tmp1.get("details").equals("任务已完成，取消失败")
//							|| tmp1.get("code").equals("0000")) {
////						result+=map.get("vehicleNum")+"车辆在线;";
//						resultlist.add(map.get("vehicleNum") + "车辆在线;");
//					}
//				}
//			} else {
////				result = map.get("vehicleNum")+"车管平台服务运行异常;";
//				resultlist.add(map.get("vehicleNum") + "车服务运行异常;");
//			}
//			System.out.println(map.get("vehicleNum") + tempResult);
//		}

		return resultlist;

	}

}
