package com.ssi.controller;

import com.dfssi.dataplatform.service.annotation.LogAudit;
import com.ssi.entity.VmsIndividuationConfig;
import com.ssi.response.SSIPage;
import com.ssi.response.SSIResponse;
import com.ssi.service.VmsIndividuationConfigService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.MimeTypeUtils;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * @author SunnyHotz
 * @PackageName:com.ssi.controller
 * @ClassName:VmsIndividuationController
 * @Description:
 * @date 2022/7/20 11:46
 */
@Api
@RestController
@RequestMapping("/individuation")
public class VmsIndividuationController {

    @Autowired
    private VmsIndividuationConfigService individuationConfigService;

    @LogAudit
    @ApiOperation(value = "获得列表", response = SSIResponse.class, produces = MimeTypeUtils.APPLICATION_JSON_VALUE)
    @PostMapping("/list")
    public SSIResponse list(@RequestBody VmsIndividuationConfig config) {
        SSIPage page = individuationConfigService.queryPage(config);
        return SSIResponse.ok(page);
    }

    @LogAudit
    @ApiOperation(value = "更新数据", response = SSIResponse.class, produces = MimeTypeUtils.APPLICATION_JSON_VALUE)
    @PostMapping("/update")
    public SSIResponse update(@RequestBody VmsIndividuationConfig config) {
        individuationConfigService.updateById(config);
        return SSIResponse.ok();
    }

    @LogAudit
    @ApiOperation(value = "删除数据", response = SSIResponse.class, produces = MimeTypeUtils.APPLICATION_JSON_VALUE)
    @GetMapping("/delete")
    public SSIResponse delete(@RequestParam("ids") List<Integer> ids) {
        individuationConfigService.removeByIds(ids);
        return SSIResponse.ok();
    }

    @ApiOperation(value = "获得列表", response = SSIResponse.class, produces = MimeTypeUtils.APPLICATION_JSON_VALUE)
    @GetMapping("/listByParent")
    public SSIResponse listByParent(@RequestParam("name") String name) {
        List<VmsIndividuationConfig> vmsIndividuationConfigs = individuationConfigService.listByParent(name);
        return SSIResponse.ok(vmsIndividuationConfigs);
    }

}
