package com.ssi.controller;


import com.ssi.entity.vo.KpiCostTimeVo;
import com.ssi.response.SSIResponse;
import com.ssi.service.VmsKpiAnalysisService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;

@RestController
@RequestMapping("/kpiData")
public class VmsKPIDataController {

    @Autowired
    private VmsKpiAnalysisService vmsKpiAnalysisService;


    @PostMapping("/staticsWorkTime")
    public SSIResponse staticsWorkTime(@RequestBody KpiCostTimeVo kpiCostTimeVo){

        return SSIResponse.ok(vmsKpiAnalysisService.staticsWorkTime(kpiCostTimeVo));

    }

    @PostMapping("/taskAnalysis")
    public SSIResponse taskAnalysis(@RequestBody KpiCostTimeVo kpiCostTimeVo){
        return SSIResponse.ok(vmsKpiAnalysisService.taskAnalysis(kpiCostTimeVo));
    }

    @PostMapping("/exportExcel")
    public void exportExcel(@RequestBody KpiCostTimeVo kpiCostTimeVo, HttpServletResponse response){
        vmsKpiAnalysisService.exportExcel(kpiCostTimeVo,response);
    }


    @GetMapping("/getVoyageNo")
    public SSIResponse getVoyageNo(){
        return SSIResponse.ok(vmsKpiAnalysisService.getVoyageNo());
    }

}
