package com.ssi.controller;

import com.dfssi.dataplatform.service.annotation.LogAudit;
import com.ssi.response.SSIResponse;
import com.ssi.service.VmsTosOrdersAnalysisService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.MimeTypeUtils;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;

import java.time.LocalDate;
import java.time.ZoneId;
import java.util.Date;

/**
 * 任务分析控制器
 *
 * @author hli
 * @email
 * @date 2021-01-11 14:00:36
 */
@Api
@RestController
@RequestMapping("/vmsTosOrdersAnalysis")
public class VmsTosOrdersAnalysisController {

    @Autowired
    private VmsTosOrdersAnalysisService vmsTosOrdersAnalysisService;

    /**
     * 重新计算任务数据
     */
    @LogAudit
    @ApiOperation(value = "重新计算任务数据", response = SSIResponse.class, produces = MimeTypeUtils.APPLICATION_JSON_VALUE)
    @GetMapping("/reAnalysis")
    public SSIResponse reAnalysis(Date date) {
        LocalDate localDate = date.toInstant().atZone(ZoneId.systemDefault()).toLocalDate();
        vmsTosOrdersAnalysisService.reAnalysis(localDate);
        return SSIResponse.ok();
    }

}
