package com.ssi.controller;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.dfssi.dataplatform.service.annotation.LogAudit;
import com.ssi.constant.URL;
import com.ssi.entity.VmsVehicleAlertProcess;
import com.ssi.response.SSIResponse;
import com.ssi.service.VmsVehicleAlertProcessService;
import com.ssi.utils.RestTemplateUtil;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.Date;
import java.util.Objects;

/**
 * @author SunnyHotz
 * @PackageName:com.ssi.controller
 * @ClassName:VmsVehicleFaultProcessController
 * @Description:
 * @date 2022/10/31 15:58
 */
@Api
@RestController
@RequestMapping("/faultProcess")
public class VmsVehicleFaultProcessController {

    @Autowired
    private VmsVehicleAlertProcessService vmsVehicleAlertProcessService;
    @Value("${command-url}")
    private String commandUrl;


    @LogAudit
    @GetMapping("/continueTask")
    public SSIResponse<?> continueTask(@RequestParam("id") String id, @RequestParam("vin")String vin){

        VmsVehicleAlertProcess byId = vmsVehicleAlertProcessService.getById(id);
        if(Objects.isNull(byId)||Objects.nonNull(byId.getResolveStatus())){
            return SSIResponse.no("请确认记录是否存在or已处理");
        }

        JSONObject jsonObject = new JSONObject();
        jsonObject.put("vin",vin);
        jsonObject.put("status",56);
        String result = RestTemplateUtil.post(commandUrl.concat(URL.To_CPS_TASK_STOP), jsonObject.toJSONString(), null);
        //成功更新数据
        JSONObject resultObject = JSONObject.parseObject(result);
        if(Objects.nonNull(resultObject)&&resultObject.getInteger("code")==1){
            byId.setResolveAlarmTime(new Date());
            byId.setResolveStatus(1);
            vmsVehicleAlertProcessService.updateById(byId);
            return SSIResponse.ok();
        }
        return SSIResponse.no(resultObject.getString("msg"));
    }

    @LogAudit
    @GetMapping("/stopTask")
    public SSIResponse<?> stopTask(@RequestParam("id") String id, @RequestParam("vin")String vin){

        VmsVehicleAlertProcess byId = vmsVehicleAlertProcessService.getById(id);
        if(Objects.isNull(byId)||Objects.nonNull(byId.getResolveStatus())){
            return SSIResponse.no("请确认记录是否存在or已处理");
        }
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("vin",vin);
        String result = RestTemplateUtil.post(commandUrl.concat(URL.To_CPS_TASK_STOP), jsonObject.toJSONString(), null);
        //成功更新数据
        JSONObject resultObject = JSONObject.parseObject(result);
        if(Objects.nonNull(resultObject)&&resultObject.getInteger("code")==1){
            byId.setResolveAlarmTime(new Date());
            byId.setResolveStatus(0);
            vmsVehicleAlertProcessService.updateById(byId);
            return SSIResponse.ok();
        }
        return SSIResponse.no(resultObject.getString("msg"));
    }

}
