package com.ssi.controller;

import com.ssi.entity.dto.VmsVehicleVinFreeTimeDto;
import com.ssi.response.SSIResponse;
import com.ssi.service.VmsVehicleFreeTimeService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.util.MimeTypeUtils;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @description: 车辆 controller 层
 * @author: dt
 * @create: 2022-11-10 13:36
 */
@Api(tags = "查询车辆空闲时间")
@RestController
@RequestMapping("/vehicleFreeTime")
@Slf4j
public class VmsVehicleFreeTimeController {

    private VmsVehicleFreeTimeService vmsVehicleFreeTimeService;

    public VmsVehicleFreeTimeController(VmsVehicleFreeTimeService vmsVehicleFreeTimeService) {
        this.vmsVehicleFreeTimeService = vmsVehicleFreeTimeService;
    }

    /**
     * 查询车辆时间范围内的空闲时间
     * @param vmsVehicleVinFreeTimeDto
     * @return
     */
    @PostMapping("/getVehicleFreeTime")
    @ApiOperation(value = "查询车辆时间范围内的空闲时间", response = SSIResponse.class, produces = MimeTypeUtils.APPLICATION_JSON_VALUE)
    SSIResponse<VmsVehicleVinFreeTimeDto> getVehicleFreeTime(@RequestBody VmsVehicleVinFreeTimeDto vmsVehicleVinFreeTimeDto) {

        VmsVehicleVinFreeTimeDto vehicleFreeTime = vmsVehicleFreeTimeService.getVehicleFreeTime(vmsVehicleVinFreeTimeDto);
        return SSIResponse.ok(vehicleFreeTime);

    }
}
