package com.ssi.controller.platform;

import com.ssi.task.ChargingManageTask;
import com.ssi.task.TELDStationSyncTask;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author SunnyHotz
 * @PackageName:com.ssi.controller.platform
 * @ClassName:ChargingManualController
 * @Description:
 * @date 2022/8/31 13:16
 */
@Api(tags = "充电手动调用", description = "充电手动调用")
@RestController
@RequestMapping("/chargingManual")
@Slf4j
public class ChargingManualController {

    @Autowired
    private ChargingManageTask chargingManageTask;

    @Autowired
    private TELDStationSyncTask teldStationSyncTask;


    @GetMapping("/invokeForCharging")
    public void invokeForCharging() throws Exception {
        chargingManageTask.invokeForCharging();
    }

    @GetMapping("/syncEquipment")
    public void syncEquipment() throws Exception {
        teldStationSyncTask.syncEquipmentInfo();
    }

    @GetMapping("/syncConnectorStatus")
    public void syncConnectorStatus() throws Exception {
        teldStationSyncTask.syncConnectorStatus();
    }

    @GetMapping("/getWorkableVehicle")
    public String getWorkableVehicle(@RequestParam("taskNo") String taskNo) throws Exception {
       return chargingManageTask.getWorkableVehicle(taskNo);
    }
}
