package com.ssi.controller.platform;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.ssi.entity.dto.RtkLocationDto;
import com.ssi.response.SSIResponse;
import com.ssi.utils.RestTemplateUtil;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.util.MimeTypeUtils;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/api/rtk")
@Slf4j
public class RtkLocationController {

    /**
     * 接收RTK定位
     */
    @PostMapping("/location")
    @ApiOperation(value = "缓冲区车位新增", response = SSIResponse.class, produces = MimeTypeUtils.APPLICATION_JSON_VALUE)
    public SSIResponse location(@RequestBody RtkLocationDto dto) {
        log.info("接收RTK定位请求：{}", JSON.toJSONString(dto));
        String url = "http://10.11.10.33:8030/api/rtk/location";
        String result = RestTemplateUtil.post(url, JSON.toJSONString(dto),null);
        log.info("返回结果：{}",result);
        JSONObject resultJson = JSONObject.parseObject(result);
        Integer code = resultJson.getInteger("code");
        if (code == 1) {
            return SSIResponse.ok();
        }
        return SSIResponse.no("保存定位失败");
    }
}
