package com.ssi.controller.platform;

import com.ssi.entity.dto.SwitchAutoParamDto;
import com.ssi.entity.dto.TelecontrolParamDto;
import com.ssi.model.TelecontrolModel;
import com.ssi.response.SSIResponse;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.RandomUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.MimeTypeUtils;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;

/**
 * APP指令控制器
 * @author ZhangLiYao
 * @version 1.0
 * @date 2020/9/01 10:20
 */
@Api
@RestController
@RequestMapping("/telecontrol")
public class TelecontrolTakeOverController {

    @Autowired
    private TelecontrolModel telecontrolModel;

    /**
     * APP接管指令下发
     */
    @PostMapping("/vehicleTelecontrol")
    @ApiOperation(value = "指令下发", response = SSIResponse.class, produces = MimeTypeUtils.APPLICATION_JSON_VALUE)
    public SSIResponse vehicleTelecontrol(@RequestBody @Valid TelecontrolParamDto telecontrolParamDto) {
        return telecontrolModel.vehicleTelecontrol(telecontrolParamDto);
    }

    @PostMapping("/testResult")
    @ApiOperation(value = "", response = SSIResponse.class, produces = MimeTypeUtils.APPLICATION_JSON_VALUE)
    public String testResult() {
        String result = "{\"data\": {\"result\":1,\"ADCUStatus\":1}," +
                "\"status\": {\"msg\": \"成功\",\"code\": \"0000\",\"details\": \"\"}}";
        String result2 = "{\"data\": {\"result\":2,\"ADCUStatus\":1}," +
                "\"status\": {\"msg\": \"成功\",\"code\": \"0000\",\"details\": \"\"}}";
        String result3 = "{\"data\": {\"result\":1,\"ADCUStatus\":2}," +
                "\"status\": {\"msg\": \"成功\",\"code\": \"0000\",\"details\": \"\"}}";
        String result4 = "{\"data\": {\"result\":1,\"ADCUStatus\":2}," +
                "\"status\": {\"msg\": \"成功\",\"code\": \"9999\",\"details\": \"\"}}";
        int i = RandomUtils.nextInt(1,5);
        if(i == 1){
            return result;
        }else if(i == 2){
            return result2;
        }else if(i == 3){
            return result3;
        }else if(i == 4){
            return result4;
        }
        return result;
    }

    /**
     * 切换自动驾驶下发
     */
    @PostMapping("/switch/autopilot")
    @ApiOperation(value = "切换自动驾驶下发", response = SSIResponse.class, produces = MimeTypeUtils.APPLICATION_JSON_VALUE)
    public SSIResponse switchAutopilot(@RequestBody @Valid SwitchAutoParamDto paramDto) {
        return telecontrolModel.switchAutopilot(paramDto);
    }
}
