package com.ssi.dcvp;

import com.ssi.response.SSIPage;
import com.ssi.response.SSIResponse;
import lombok.Data;

import java.util.List;

@Data
public class DcvpResponse {

  /**
   * 1表示成功、0失败
   */
  private Integer code;

  private String error;

  private Object data;

  public DcvpResponse(SSIResponse ssiResponse) {
    Object data = ssiResponse.getData();
    if (data != null && data instanceof SSIPage) {
      SSIPage originPage = (SSIPage) data;
      int total = originPage.getTotalCount();
      DcvpPage dcvpPage = new DcvpPage();
      dcvpPage.setTotal(total);
      dcvpPage.setData(originPage.getList());
      this.data = dcvpPage;
    } else {
      this.data = data;
    }
    int code = ssiResponse.getCode();
    if (code == 1) {
      this.code = 1;
    } else {
      this.code = 0;
      this.error = ssiResponse.getMsg();
    }
  }

  public DcvpResponse() {
  }

  @Data
  class DcvpPage {

    private int total;
    private List data;
  }
}
