package com.ssi.entity;


import java.io.Serializable;
import java.util.Date;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

/**
 * 船舶任务配置信息
 * @TableName cargo_ship_config_info
 */
@TableName(value ="cargo_ship_config_info")
@Data
public class CargoShipConfigInfo implements Serializable {
    /**
     * 
     */
    @TableId(type = IdType.ASSIGN_UUID)
    private String id;

    private String code;

    /**
     * 船舶名称
     */
    private String name;

    /**
     * 入场时间
     */
    private Date enterTime;

    /**
     * 出场时间
     */
    private Date exitTime;

    /**
     * 船头朝向
     */
    private String headDirection="R";

    /**
     * 桥吊编号：a,b
     */
    private String bridgeNo;

    /**
     * 车道编号：a,b
     */
    private String laneNo;

    /**
     * 必经区域，json
     */
    private String passArea;

    /**
     * 扭锁站：a,b
     */
    private String lockArea;

    /**
     * 堆场贝位，json
     */
    private String yardBay;

    /**
     * 场吊编号
     */
    private String craneNo;


    private Byte loadMode;

    /**
     * 0：配置未激活，1配置已激活
     */
    private Byte isActive;

    /**
     * 0：正常，1：已删除
     */
    private Byte isDelete;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}