package com.ssi.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import lombok.ToString;

import java.util.List;

/**
 * 桥吊场吊信息
 */
@Getter
@Setter
@ToString
@ApiModel("桥吊场吊信息")
public class CraneInfo {

    /**
     * 港机编码，tos写法
     */
    @ApiModelProperty("港机编码，tos写法")
    private String portCode;
    /**
     * 港机编码
     */
    @ApiModelProperty("港机编码")
    private String craneNo;

    /**
     * 港机类型 1是桥吊 2是场吊
     */
    @ApiModelProperty("港机类型 1是桥吊 2是场吊")
    private Integer craneType;

    /**
     * 港机类型 1是桥吊 2是场吊，tos写法
     */
    @ApiModelProperty("港机类型 1是桥吊 2是场吊，tos写法")
    private Integer portType;

    @ApiModelProperty("任务类型 1是桥上 2 桥下")
    private Integer taskType;

    @TableField(exist = false)
    private List<Integer> taskTypes;
}
