package com.ssi.entity;


import java.io.Serializable;
import java.util.Date;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

/**
 * 电子围栏信息表
 * @TableName vms_area_barrier
 */
@TableName(value ="vms_area_barrier")
@Data
public class VmsAreaBarrier implements Serializable {
    /**
     * 
     */
    @TableId(type = IdType.AUTO)
    private Integer id;

    /**
     * 电子围栏名称
     */
    private String name;

    /**
     * 经纬度坐标集合
     */
    private String locations;

    /**
     * 试验区域类型（0：多边形；1：线段加宽描述的矩形；）
     */
    private Integer type;

    /**
     * 备注
     */
    private String remark;

    /**
     * 宽度
     */
    private Double width;

    /**
     * 半径（如果区域是圆形才有数值）
     */
    private Double radius;

    /**
     * 中心点（如果区域是圆形才有数值）
     */
    private String centralPointLocations;

    /**
     * 道路类型（0：高速，1：国道，2：省道，3：城市道路）
     */
    private Integer roadType;

    /**
     * 工况起点经纬度
     */
    private String startPoint;

    /**
     * 工况终点经纬度
     */
    private String endPoint;

    /**
     * 区域类型，0：用于报警和工况计算的区域；1：用于报警的区域；2：用于工况计算的区域；3：用户山路计算的区域
     */
    private Integer areaType;

    /**
     * 地图类型（0：高德，1：百度）
     */
    private Byte mapType;

    /**
     * 逻辑删除,0已删除,1未删除
     */
    private Integer dr;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 修改时间
     */
    private Date updateTime;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}