package com.ssi.entity;


import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 区域业务表
 * @TableName vms_area_business_info
 */
@TableName(value ="vms_area_business_info")
@Data
public class VmsAreaBusinessInfo implements Serializable {
    /**
     * 图形id
     */
    @TableId(type = IdType.AUTO)
    private Integer id;


    @TableId
    private String areaId;
    /**
     * 图形编号
     */
    private String areaNo;

    /**
     * 图形类型 1缓冲区；2停车区;3:充电区;4:禁闭区
     */
    private String areaType;

    /**
     * 1:桥下去堆场,2:堆场去桥下
     */
    private Integer taskType;


    private String placetype;

    /**
     * 1桥下，2桥后，等等
     */
    private String bridge;
    /**
     * 更新时间
     */
    private Date updateTime;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}