package com.ssi.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.Size;
import java.util.Date;


/**
 * 龙锁装卸区表
 *
 * @author zhang liyao
 * @email
 * @date 2020-07-16 09:32:59
 */
@Getter
@Setter
@ApiModel(value = "VmsAreaPosition")
public class VmsAreaPosition {

    /**
     *
     */
    @ApiModelProperty(value = "id")
    @TableId(type = IdType.AUTO)
    private Integer id;
    /**
     * 装卸位编号
     */
    @ApiModelProperty(value = "装卸位编号")
    @Size(max = 20,min = 1,message = "位置编号最多20位")
    private String areaNum;
    /**
     * 装卸位经纬度:经度和纬度用","号隔开,下个点用":"号隔开
     */
    @ApiModelProperty(value = "装卸位经纬度:经度和纬度用','号隔开,下个点用':;号隔开")
    private String coordination;
    /**
     * 中心点位置（停车区）
     */
    @ApiModelProperty(value = "中心点位置（停车区）")
    private String centerPoint;
    /**
     * 偏移量 x轴，y轴，z轴（停车区）
     */
    @ApiModelProperty(value = "偏移量 x轴，y轴，z轴（停车区）")
    private String offset;
    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 修改时间
     */
    @ApiModelProperty(value = "修改时间")
    private Date updateTime;

    /**
     * 类型 1 龙锁 2 停车
     */
    @ApiModelProperty(value = "类型 1 龙锁 2 停车")
    private Integer areaType;

    /**
     * 停车区位置：1 桥吊处 2 堆场处 3 转弯处
     */
    @ApiModelProperty(value = "停车区位置：1 桥吊处 2 堆场处 3 转弯处")
    private Integer areaPosition;
    /**
     * 充电桩id
     */
    @ApiModelProperty(value = "充电桩id")
    private String chargingInterfaceIds;
}
