package com.ssi.entity;

import cn.afterturn.easypoi.excel.annotation.Excel;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.Date;


/**
 * 远程控车指令表
 *
 * @author liheng
 * @email
 * @date 2020-07-24 10:14:56
 */
@Getter
@Setter
@ApiModel(value = "VmsCarControlCommand")
public class VmsCarControlCommand {

    /**
     *
     */
    @ApiModelProperty(value = "id")
    @TableId(type = IdType.AUTO)
    private Integer id;
    /**
     * 指令
     */
    @ApiModelProperty(value = "指令，1-启动 2-熄火 3-停车 4-前移 5-后退 6-换向行驶 7-充电")
    @Excel(name = "远程指令", orderNum = "2", replace = {"启动_1","熄火_2","停车_3","前移_4","后退_5","换向_6","充电_7"}, width = 10)
    private Integer command;
    /**
     * 操作人id
     */
    @ApiModelProperty(value = "操作人id")
    private Integer operatorId;
    /**
     * 操作人姓名
     */
    @ApiModelProperty(value = "操作人姓名")
    @Excel(name = "操作人", orderNum = "4", width = 10)
    private String operatorName;
    /**
     * 指令执行状态  1：成功，2：失败，3：指令错误，4：不支持
     */
    @ApiModelProperty(value = "指令执行状态  1：成功，2：失败，3：指令错误，4：不支持 ")
    @Excel(name = "执行状态", orderNum = "6", replace = {"成功_1", "失败_2","指令错误_3", "不支持_4"}, width = 10)
    private Integer executeStatus;
    /**
     * 指令执行结果描述
     */
    @ApiModelProperty(value = "指令执行结果描述")
    private String executeMessage;
    /**
     * 车辆vin
     */
    @ApiModelProperty(value = "车辆vin")
    @Excel(name = "车辆vin", orderNum = "1", width = 20)
    private String vin;
    /**
     * 车辆编号
     */
    @ApiModelProperty(value = "车辆编号")
    @Excel(name = "车辆编号", orderNum = "1", width = 20)
    private String vehicleNum;
    /**
     * 指令创建时间
     */
    @ApiModelProperty(value = "指令创建时间")
    @Excel(name = "下发时间", orderNum = "3", width = 20, exportFormat = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;
    /**
     * 更新时间
     */
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;

}
