package com.ssi.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @author hli
 * @email
 * @date 2020-12-28 10:24:34
 */
@Getter
@Setter
@ApiModel(value = "VmsCarryCapacityAnalysis")
public class VmsCarryCapacityAnalysis {

    /**
     *
     */
    @ApiModelProperty(value = "id")
    @TableId(type = IdType.UUID)
    private String id;
    /**
     *
     */
    @ApiModelProperty(value = "")
    private String vin;
    /**
     * 分析日期
     */
    @ApiModelProperty(value = "分析日期")
    private String analysisDate;
    /**
     * 无任务里程
     */
    @ApiModelProperty(value = "无任务里程")
    private BigDecimal freeMile;
    /**
     * 无任务能耗
     */
    @ApiModelProperty(value = "无任务能耗")
    private BigDecimal freeEnergy;
    /**
     * 无任务时间
     */
    @ApiModelProperty(value = "无任务时间")
    private Long freeTime;
    /**
     * 任务里程
     */
    @ApiModelProperty(value = "任务里程")
    private BigDecimal workMile;
    /**
     * 任务能耗
     */
    @ApiModelProperty(value = "任务能耗")
    private BigDecimal workEnergy;
    /**
     * 任务时间
     */
    @ApiModelProperty(value = "任务时间")
    private Long workTime;
    /**
     * 停车等待时间
     * 判断标准：
     * 1、正在执行任务；
     * 2、速度为0
     * <p>
     * 执行的是装卸船或者理货任务，不是挺稳锁死状态或者，停车超过5分钟后开始计算超时时间
     * 车辆任务标签,1:装船；2：卸船；3：堆场间搬移；4：停车，5：充电，6：临时停车
     * 对应标签123，超5分钟开始计时
     */
    @ApiModelProperty(value = "停车等待时间 判断标准：1、正在执行任务；2、速度为0 执行的是装卸船或者理货任务，不是挺稳锁死状态或者，停车超过5分钟后开始计算超时时间 车辆任务标签,1:装船；2：卸船；3：堆场间搬移；4：停车，5：充电，6：临时停车 对应标签123，超5分钟开始计时")
    private Long stopWaitTime;
    /**
     * 最后修改时间
     */
    @ApiModelProperty(value = "最后修改时间")
    private Date lastModifiedDate;

}
