package com.ssi.entity;


import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.util.Date;
import lombok.Data;

/**
 * 充电设备接口信息
 * @TableName vms_charging_connector_info
 */
@TableName(value ="vms_charging_connector_info")
@Data
public class VmsChargingConnectorInfo implements Serializable {
    /**
     * 设备接口编码
     */
    @TableId
    private String connectorId;

    /**
     * 设备id
     */
    private String equipmentId;

    /**
     * 充电站id
     */
    private String stationId;

    /**
     * 设备接口类型
     */
    private Integer connectorType;

    /**
     * 额定电压上限
     */
    private Integer voltageUpperLimits;

    /**
     * 额定电压下限
     */
    private Integer voltageLowerLimits;

    /**
     * 额定电流
     */
    private Integer current;

    /**
     * 额定功率
     */
    private Double power;

    /**
     * 国家标准
     */
    private Byte nationalStandard;

    /**
     * 
     */
    private Byte status;

    /**
     * 车位状态
     */
    private Byte parkStatus;

    /**
     * 地锁状态
     */
    private Byte lockStatus;

    /**
     * 更新时间
     */
    private Date updateTime;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}