package com.ssi.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.util.Date;

import lombok.Builder;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

/**
 * 充电订单信息表
 * @TableName vms_charging_order_info
 */
@TableName(value ="vms_charging_order_info")
@Data
public class VmsChargingOrderInfo implements Serializable {
    /**
     * 充电订单号
     */
    @TableId(type = IdType.INPUT)
    private String startChargeSeq;

    /**
     * 车架号
     */
    private String vin;

    /**
     * 任务编号
     */
    private String taskNo;

    /**
     * 充电站id
     */
    private String stationId;

    /**
     * 充电订单状态 1：启动中2：充电中 3：停止中4：已结束5：未知
     */
    private Integer startChargeSeqStat;

    /**
     * 充电设备接口编码
     */
    private String connectorId;

    /**
     * 充电设备接口状态 1：空闲2：占用（未充电）3：占用（充电中）4：占用（预约锁定）255：故障
     */
    private Integer connectorStatus;

    /**
     * 开始充电时间
     */
    private Date startTime;

    /**
     * 结束充电时间
     */
    private Date endTime;

    /**
     * 充电电量
     */
    private Double elect;

    /**
     * 更新时间
     */
    private Date updateTime;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}