package com.ssi.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.math.BigDecimal;
import java.util.Date;

/**
 * 充电桩表
 *
 * @author zhang liyao
 * @email
 * @date 2020-07-17 11:14:34
 */
@Getter
@Setter
@ApiModel(value = "VmsChargingPile")
public class VmsChargingPile {

    /**
     *
     */
    @ApiModelProperty(value = "id")
    @TableId(type = IdType.AUTO)
    private Integer id;
    /**
     * 充电枪编号
     */
    @ApiModelProperty(value = "充电枪编号")
    private String gunNum;
    /**
     * 设备编号
     */
    @ApiModelProperty(value = "设备编号")
    private String pileNum;
    /**
     * 上下线标记 (1  在线  0 离线)
     */
    @ApiModelProperty(value = "上下线标记 (1  在线  0 离线)")
    private Integer onlineStatus;
    /**
     * 故障状态 （1 故障 0 空闲）
     */
    @ApiModelProperty(value = "故障状态 （1 故障 0 空闲）")
    private Integer faultStatus;
    /**
     * 工作状态标记 (1  充电中  0 空闲 2 异常)
     */
    @ApiModelProperty(value = "工作状态标记 (1  充电中  0 空闲 2 异常)")
    private Integer workStatus;
    /**
     * 经度
     */
    @ApiModelProperty(value = "经度")
    private Double lon;
    /**
     * 纬度
     */
    @ApiModelProperty(value = "纬度")
    private Double lat;
    /**
     * 所在地址
     */
    @ApiModelProperty(value = "所在地址")
    private String address;
    /**
     * 今日耗电
     */
    @ApiModelProperty(value = "今日耗电")
    private BigDecimal consumeDay;
    /**
     * 累计耗电
     */
    @ApiModelProperty(value = "累计耗电")
    private BigDecimal consumeTotal;
    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 修改时间
     */
    @ApiModelProperty(value = "修改时间")
    private Date updateTime;

    /**
     * 预计结束时间
     */
    @ApiModelProperty(value = "预计结束时间")
    @TableField(exist = false)
    private Long expectEndTime;
    /**
     * 充电车辆
     */
    @ApiModelProperty(value = "充电车辆")
    @TableField(exist = false)
    private String chargingVehicleNum;
    /**
     * 充电电量
     */
    @ApiModelProperty(value = "充电电量")
    @TableField(exist = false)
    private Integer chargingPer;
}
