package com.ssi.entity;


import java.io.Serializable;
import java.util.Date;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

/**
 * 充电站信息表
 * @TableName vms_charging_station
 */
@TableName(value ="vms_charging_station")
@Data
public class VmsChargingStation implements Serializable {
    /**
     * 充电站id
     */
    @TableId
    private String stationId;

    /**
     * 设备所属方id
     */
    private String equipmentOwnerId;

    /**
     * 运营商id
     */
    private String operatorId;

    /**
     * 充电站名称
     */
    private String stationName;

    /**
     * 国家代码
     */
    private String countryCode;

    /**
     * 省市区编码
     */
    private String areaCode;

    /**
     * 详细地址
     */
    private String address;

    /**
     * 站点电话
     */
    private String stationTel;

    /**
     * 服务电话
     */
    private String serviceTel;

    /**
     * 站点类型
     */
    private Integer stationType;

    /**
     * 站点状态
     */
    private Integer stationStatus;

    /**
     * 车位数量
     */
    private Integer parkNums;

    /**
     * 经度
     */
    private Double stationLng;

    /**
     * 纬度
     */
    private Double stationLat;

    /**
     * 站点引导
     */
    private String siteGuide;

    /**
     * 建设场所
     */
    private Integer construction;
    
    private Date updateTime;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}