package com.ssi.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.sun.org.apache.xpath.internal.operations.Bool;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.util.Date;
import java.util.List;
import java.util.Map;


/**
 * 港机pad绑定表
 *
 * @author liheng
 * @email
 * @date 2020-08-10 16:29:29
 */
@Getter
@Setter
@ApiModel(value = "VmsCranePadBind")
public class VmsCranePadBind {

    /**
     *
     */
    @ApiModelProperty(value = "id")
    @TableId(type = IdType.AUTO)
    private Integer id;
    /**
     * 港机类型
     */
    @ApiModelProperty(value = "港机类型")
    @NotNull(message = "港机类型不能为空")
    private Integer craneType;
    /**
     * 桥吊编号
     */
    @ApiModelProperty(value = "港机编号")
    @NotBlank(message = "港机编号不能为空")
    private String craneNo;
    /**
     * pad设备编号
     */
    @ApiModelProperty(value = "pad设备编号")
//    @NotBlank(message = "pad设备编号不能为空")
    private String padNo;
    /**
     * pad mac地址
     */
    @ApiModelProperty(value = "pad mac地址")
    private String padMac;

    @ApiModelProperty(value = "扭锁区ID")
    private String lockAreaId;

    @ApiModelProperty(value = "扭锁区ID")
    private String lockAreaNo;

    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 更新时间
     */
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
    /**
     * 桥吊任务列表
     */
    @ApiModelProperty(value = "桥吊任务列表")
    @TableField(exist = false)
    private List<Map<String,Object>> ordersList;

    @TableField(exist = false)
    private int inUsing;


}
