package com.ssi.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.Size;
import java.util.Date;


/**
 * 调试APP表
 *
 * @author zhang liyao
 * @email
 * @date 2020-09-01 08:36:06
 */
@Getter
@Setter
@ApiModel(value = "VmsDebugApp")
public class VmsDebugApp {

    /**
     *
     */
    @ApiModelProperty(value = "id")
    @TableId(type = IdType.AUTO)
    private Integer id;
    /**
     * mac地址
     */
    @ApiModelProperty(value = "mac地址")
    @Size(max = 64, min = 10, message = "mac地址应在{min}-{max}字内")
    private String appMac;
    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    @Size(max = 20, min = 0, message = "备注应在20字内")
    private String remark;
    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 修改时间
     */
    @ApiModelProperty(value = "修改时间")
    private Date updateTime;

    /**
     * 控车vin
     */
    @TableField(exist = false)
    @ApiModelProperty(value = "控车vin")
    private String vin;

    /**
     * 控车状态，1接管状态，17取消接管成功
     */
    @TableField(exist = false)
    @ApiModelProperty(value = "控车状态")
    private Integer appControl;

    /**
     * 遥控车辆编号
     */
    @TableField(exist = false)
    @ApiModelProperty(value = "遥控车辆编号")
    private String vehicleNum;

}
