package com.ssi.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.ssi.constant.enums.EventTypeEnums;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.Date;


/**
 * 事件表
 *
 * @author zhang liyao
 * @email
 * @date 2020-07-20 13:12:42
 */
@Getter
@Setter
@ApiModel(value = "VmsEvent")
public class VmsEvent {

    /**
     *
     */
    @ApiModelProperty(value = "id")
    @TableId(type = IdType.AUTO)
    private Integer id;
    /**
     * 事件类型
     */
    @ApiModelProperty(value = "事件类型")
    private String eventType;
    /**
     * 事件来源 0 下发 1 V2X分析
     */
    @ApiModelProperty(value = "事件来源 0 下发 1 V2X分析")
    private Integer eventSource;
    /**
     * 事件状态 0 未来事件 1 活动事件 2 过期事件
     */
    @ApiModelProperty(value = "事件状态 0 未来事件 1 活动事件 2 过期事件")
    private Integer eventStatus;
    /**
     * 事件地点
     */
    @ApiModelProperty(value = "事件地点(经纬度)")
    private String coordinate;
    /**
     * 事件半径
     */
    @ApiModelProperty(value = "事件半径")
    private Integer eventRadius;
    /**
     * 事件开始时间
     */
    @ApiModelProperty(value = "事件开始时间")
    private Date eventStartTime;
    /**
     * 事件结束时间
     */
    @ApiModelProperty(value = "事件结束时间")
    private Date eventStopTime;
    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 修改时间
     */
    @ApiModelProperty(value = "修改时间")
    private Date updateTime;

}
