package com.ssi.entity;

import cn.afterturn.easypoi.excel.annotation.Excel;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import java.util.Date;


/**
 * 故障码表
 *
 * @author zhang liyao
 * @email
 * @date 2020-07-16 13:36:49
 */
@Getter
@Setter
@ApiModel(value = "VmsFaultCode")
public class VmsFaultCode {

    /**
     *
     */
    @ApiModelProperty(value = "id")
    @TableId(type = IdType.AUTO)
    private Integer id;
    /**
     * 故障编码
     */
    @ApiModelProperty(value = "故障编码")
    @Excel(name = "故障编码", orderNum = "0")
    private String faultCode;
    /**
     * 故障名称
     */
    @ApiModelProperty(value = "故障名称")
    @Excel(name = "故障名称", orderNum = "1")
    private String faultName;
    /**
     * 故障解决方案
     */
    private String faultSolution;

    /**
     * 故障类型
     */
    @ApiModelProperty(value = "故障类型")
    @Excel(name = "故障类型", orderNum = "1")
    private String faultType;
    /**
     * 故障等级 1 一级 2 二级 3 三级 4 事件
     */
    @ApiModelProperty(value = "故障等级")
    @Excel(name = "故障等级", orderNum = "2")
    private String faultGrade;
    /**
     * SPN
     */
    @ApiModelProperty(value = "SPN")
    @Excel(name = "SPN", orderNum = "3")
    @NotBlank
    private String spn;
    /**
     * FMI
     */
    @ApiModelProperty(value = "FMI")
    @Excel(name = "FMI", orderNum = "4")
    @NotBlank
    private String fmi;
    /**
     * SA
     */
    @ApiModelProperty(value = "SA")
    @Excel(name = "SA", orderNum = "5")
    @NotBlank
    private String sa;
    /**
     * 描述
     */
    @ApiModelProperty(value = "故障描述")
    @Excel(name = "故障描述", orderNum = "6")
    @Size(max = 200,min = 0,message = "描述应在200字内")
    private String describition;
    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 修改时间
     */
    @ApiModelProperty(value = "修改时间")
    private Date updateTime;
    
    @ApiModelProperty(value = "故障源类别")
    @Excel(name = "故障源类别", orderNum = "7")
    private String faultSourceType;

    @ApiModelProperty(value = "故障源类别名称")
    @Excel(name = "故障源类别名称", orderNum = "8")
    private String faultSourceTypeName;
    
    @ApiModelProperty(value = "故障源识别码")
    @Excel(name = "故障源识别码", orderNum = "9")
    private String faultLabel;

    @ApiModelProperty(value = "故障诊断仪码")
    @Excel(name = "故障诊断仪码", orderNum = "10")
    private String faultDmCode;

    @ApiModelProperty(value = "故障模块")
    @Excel(name = "故障模块", orderNum = "11")
    private String faultModule;

    @ApiModelProperty(value = "故障原因")
    @Excel(name = "故障原因", orderNum = "12")
    private String faultReason;
}
