package com.ssi.entity;

import java.io.Serializable;
import java.util.Date;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

/**
 * 个性化配置
 * @TableName vms_individuation_config
 */
@TableName(value ="vms_individuation_config")
@Data
public class VmsIndividuationConfig implements Serializable {
    /**
     * 
     */
    @TableId
    private Integer id;

    /**
     * key
     */
    private String configKey;

    /**
     * value
     */
    private String configValue;

    /**
     * 所属模块
     */
    private String modelId;

    /**
     * 所属模块名
     */
    private String modelName;

    /**
     * 值的类型 0：整数 1：自定义 2：颜色 3：是否
     */
    private Integer valueType;

    /**
     * 状态   0：停用   1：启用
     */
    private Integer status;

    /**
     * 备注
     */
    private String remark;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 更新时间
     */
    private Date updateTime;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
    @TableField(exist = false)
    private Integer pageSize;
    @TableField(exist = false)
    private Integer pageIndex;
}