package com.ssi.entity;

import cn.afterturn.easypoi.excel.annotation.Excel;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

import lombok.Data;

/**
 * @TableName vms_kpi_analysis
 */
@TableName(value ="vms_kpi_analysis")
@Data
public class VmsKpiAnalysis implements Serializable {

    private Integer id;

    @Excel(name = "vin", orderNum = "1", width = 20)
    private String vin;

    @Excel(name = "任务标签" , orderNum = "2", width = 10,replace = {"装船_1", "卸船_2", "堆场间搬移_3", "停车_4", "充电_5", "停车_6"})
    private Integer vehicleTaskLabel;

    @Excel(name = "船舶编号", orderNum = "3", width = 10)
    private String voyageNo;

    @Excel(name = "桥吊编号", orderNum = "4", width = 10)
    private String portCode;

    @Excel(name = "港机类型" , orderNum = "5", width = 10,replace = {"桥吊_1", "场吊_2"})
    private Integer portType;
    @Excel(name = "集装箱尺寸", orderNum = "6", width = 10)
    private Integer containerSize;
    @Excel(name = "集装箱类型", orderNum = "7", width = 10,replace = {"大箱_1", "双小箱_2", "单小箱_3"})
    private String containerType;
    @Excel(name = "开始时间", orderNum = "8", width = 16,format = "yyyy-MM-dd HH:mm:ss")
    private Date startTime;
    @Excel(name = "结束时间", orderNum = "9", width = 16,format = "yyyy-MM-dd HH:mm:ss")
    private Date endTime;
    @Excel(name = "里程(m)", orderNum = "10", width = 10)
    private Double mileage;
    @Excel(name = "耗电量(kw.h)", orderNum = "11", width = 10)
    private Double energyConsumption;
    @Excel(name = "作业总时长(min)", orderNum = "12", width = 10)
    private Long workTime;

    private Date createTime;

    private String containerId;
    @Excel(name = "作业类型", orderNum = "13", width = 10,replace = {"装箱_1", "卸箱_2", "充电_3","上扭锁_4","解扭锁_5","停车_6","掉头_7"})
    private Integer taskType;

    private String parentTaskNo;
    @Excel(name = "任务编号", orderNum = "14", width = 10)
    private String taskNo;

    private String taskNoMapping;
    @Excel(name = "标准箱数量", orderNum = "15", width = 10)
    private Double standardBoxNum;
    @Excel(name = "对位时间(min)", orderNum = "16", width = 10)
    private Long alignmentTime;
    @Excel(name = "锁站作业时间(min)", orderNum = "17", width = 10)
    private Long lockingOperationTime;
    @Excel(name = "缓冲区等待时间(min)", orderNum = "18", width = 16)
    private Long bufferWaitTime;
    @Excel(name = "其他等待时间(min)", orderNum = "19", width = 10)
    private Long otherWaitingTime;
    @Excel(name = "指令等待时间(min)", orderNum = "20", width = 10)
    private Long commandWaitingTime;
    @Excel(name = "工作点作业时间(min)", orderNum = "21", width = 16)
    private Long workPointTime;
    @Excel(name = "工作点等待时间(min)", orderNum = "22", width = 10)
    private Long waitingPointTime;

    private Long movePointTime;
    @Excel(name = "TOS下发指令时间戳", orderNum = "23", width = 10)
    private Long collectTime;

    private static final long serialVersionUID = 1L;
}