package com.ssi.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.util.Date;
import java.util.List;


/**
 * 路测设备表
 *
 * @author zhang liyao
 * @email
 * @date 2020-07-09 13:37:13
 */
@Data
@ApiModel(value = "VmsroadDevice")
public class VmsRoadDevice implements Serializable {

    /**
     *
     */
    @ApiModelProperty(value = "id")
    @TableId(type = IdType.AUTO)
    private Long id;
    /**
     * 设备编号
     */
    @ApiModelProperty(value = "设备编号")
    private String deviceNum;
    /**
     * 设备名称
     */
    @ApiModelProperty(value = "设备名称")
    private String deviceName;
    /**
     * 设备类型
     */
    @ApiModelProperty(value = "设备类型")
    private String deviceType;
    /**
     * 设备型号
     */
    @ApiModelProperty(value = "设备型号")
    private String deviceTypeNum;
    /**
     * 上下线标记 (2 异常 1  在线  0 离线)
     */
    @ApiModelProperty(value = "上下线标记 (2 异常 1  在线  0 离线)")
    private Integer onlineStatus;
    /**
     * 故障状态标记 (2 其他 1  故障  0 正常)
     */
    @ApiModelProperty(value = "故障状态标记 (2 其他 1  故障  0 正常)")
    private Integer workStatus;
    /**
     * 经度
     */
    @ApiModelProperty(value = "经度")
    private Double lon;
    /**
     * 纬度
     */
    @ApiModelProperty(value = "纬度")
    private Double lat;
    /**
     * 所在地址
     */
    @ApiModelProperty(value = "所在地址")
    private String address;
    /**
     * 视频监控地址
     */
    @ApiModelProperty(value = "视频监控地址")
    private String videoAddress;
    /**
     * rsm设备id
     */
    @ApiModelProperty(value = "rsm设备id")
    private String rsmDeviceId;
    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 修改时间
     */
    @ApiModelProperty(value = "修改时间")
    private Date updateTime;

    /**
     * 摄像头是否在线
     */
    @ApiModelProperty(value = "摄像头是否在线")
    @TableField(exist = false)
    private Boolean videoOnline;
    /**
     * 视频播放地址
     */
    @ApiModelProperty(value = "视频播放地址")
    @TableField(exist = false)
    private List<String> playVideoAddress;

    /**
     *  类型 0或者null 固定ip地址;C开头桥吊
     */
    @ApiModelProperty(value = "类型")
    private String  type;
}
