package com.ssi.entity;


import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Objects;


/**
 * 箱体信息
 *
 * @author zhang liyao
 * @email
 * @date 2020-07-08 15:38:37
 */
@Data
@ApiModel(value = "VmsShipInfo")
public class VmsShipInfo implements Serializable {

 

	private static final long serialVersionUID = 1L;
	 @ApiModelProperty(value = "艘次编号")
	 private String voyageNo;  //	艘次编号
	 private String shipCod;  //    船名代码
	 private String shipNam;  //    船名
	 private String berthCod;  //	泊位代码
	 private String berthWay;  //	停靠方式
	 private String begCable;  //	起始缆桩号
	 private String endCable;  //	终止缆桩号
	 private String begMeter;  //	起始米数
	 private String endMeter;  //	结束米数
	 private String voyageLength;
	 private String eta;  //    预计抵港时间
	 private String etaa;  //	预计抵锚时间
	 private String etb;  //    预计靠泊时间
	 private String etd;  //    预计离港时间
	 private String rtaa;  //	实际抵锚时间
	 private String rta;  //    实际抵港时间
	 private String rtb;  //    实际靠泊时间
	 private String rtd;  //    实际离港时间
	 private String pLoadingNum;  //		预计装卸量
	 private String shipStatId;  //	船舶状态
	 private String vesselLockId;  //		船舶锁标志
	 private String endBerthCod;  //		后泊位
	 private String etaBerth;  //	预抵泊位
	 private String etaPlace;  //	预抵地点
	 private String recTim;  //操作时间
	 private String begCabSeq;  //	开始揽桩号
	 private String endCabSeq;  //	结束揽桩号
	 private String autoId;  //自动化作业标志
     private String begcoor;
     private String endcoor;
     private String centercoor;// 中间缆装号坐标
     private String cenCable;
	 private String workingBay;
	 private String iVoyage;//进口航次
	 private String eVoyage; //出口航次
	@TableField(exist = false)
	 private Integer hasConfig; //是否存在默认配置，1存在，0不存在

	public String getVoyageLength() {
		if(Objects.isNull(this.voyageLength)&&Objects.nonNull(this.endMeter)&&Objects.nonNull(this.begMeter)){
			double ab = Double.parseDouble(this.endMeter) - Double.parseDouble(this.begMeter);
			this.voyageLength = String.format("%.2f",Math.abs(ab));

		}
		return this.voyageLength;
	}
}
