package com.ssi.entity;

import cn.afterturn.easypoi.excel.annotation.Excel;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.math.BigDecimal;
import java.util.Date;


/**
 * @author zhang liyao
 * @email
 * @date 2020-07-11 13:12:01
 */
@Getter
@Setter
@ApiModel(value = "VmsTosOrders")
public class VmsTosOrders {

    /**
     *
     */
    @ApiModelProperty(value = "id")
    @TableId(type = IdType.UUID)
    private Integer id;
    /**
     *
     */
    @ApiModelProperty(value = "vin")
    @Excel(name = "vin", orderNum = "4", width = 18)
    private String vin;
    /**
     * 序号
     */
    @ApiModelProperty(value = "序号")
    private String seq;
    /**
     * 任务编号
     */
    @ApiModelProperty(value = "父任务编号")
    private String parentTaskNo;
    /**
     * 任务编号
     */
    @ApiModelProperty(value = "任务编号")
    @Excel(name = "任务编号", orderNum = "1", width = 35)
    private String taskNo;
    /**
     * 任务编号映射值
     */
    @ApiModelProperty(value = "任务编号映射值")
    @Excel(name = "任务关联", orderNum = "3", width = 10)
    private String taskNoMapping;
    /**
     * 任务类型, 1-去堆场（装箱或卸箱）;2-去停车点（上扭锁，解扭锁，停车）;3-去固定停车区;4-去临时停车区;5-去桥吊（装箱或卸箱）；6-去充电
     */
    @ApiModelProperty(value = "任务类型, 1-去堆场（装箱或卸箱）;2-去停车点（上扭锁，解扭锁，停车）;3-去固定停车区;4-去临时停车区;5-去桥吊（装箱或卸箱）；6-去充电")
    @Excel(name = "作业位置类型", orderNum = "5", replace = {"去堆场_1", "去停车点_2","去固定停车区_3","去临时停车区_4","去桥吊_5","去充电_6"}, width = 10)
    private Integer taskLocationType;
    /**
     * 作业类型,1:装箱，2:卸箱，3:充电，4:上扭锁，5:解扭锁,6:停车，7掉头
     */
    @ApiModelProperty(value = "作业类型,1:装箱，2:卸箱，3:充电，4:上扭锁，5:解扭锁,6:停车，7掉头")
    @Excel(name = "作业类型", orderNum = "12", replace = {"装箱_1", "卸箱_2", "充电_3", "上扭锁_4", "解扭锁_5", "停车_6", "掉头_7"}, width = 10)
    private Integer taskType;
    /**
     * 任务操作：1-开始，2-暂停，3-结束
     */
    @ApiModelProperty(value = "任务操作：1-开始，2-暂停，3-结束")
    private Integer taskOperation;
    /**
     * 港机类型1-桥吊;2-场吊
     */
    @ApiModelProperty(value = "港机类型1-桥吊;2-场吊")
    @Excel(name = "港机类型", orderNum = "9", replace = {"桥吊_1", "场吊_2", "_null"}, width = 10)
    private Integer portType;
    /**
     * 港机编码
     */
    @ApiModelProperty(value = "港机编码")
    @Excel(name = "港机编码", orderNum = "9", width = 10)
    private String portCode;
    /**
     * 车辆任务目标地点
     */
    @ApiModelProperty(value = "车辆任务目标地点")
    @Excel(name = "车辆任务目标点", orderNum = "6", width = 10)
    private String vehicleLocation;
    /**
     * 车辆任务类型, 1-大箱;2-双小箱;3-单小箱;0-其它
     */
    @ApiModelProperty(value = "车辆任务类型, 1-大箱;2-双小箱;3-单小箱;0-其它")
    @Excel(name = "车辆任务类型", orderNum = "7", replace = {"大箱_1", "双小箱_2", "单小箱_3", "其它_0", "_null"}, width = 10)
    private Integer vehicleTaskType;
    /**
     * 集装箱编号
     */
    @ApiModelProperty(value = "集装箱编号")
    @Excel(name = "集装箱ID", orderNum = "10", width = 10)
    private String containerId;
    /**
     * 集装箱类型
     */
    @ApiModelProperty(value = "集装箱类型")
    @Excel(name = "集装箱类型", orderNum = "11", width = 10)
    private String containerType;
    /**
     * 集装箱数量
     */
    @ApiModelProperty(value = "集装箱数量")
    private Integer containerNum;
    /**
     * 集装箱重量
     */
    @ApiModelProperty(value = "集装箱重量")
    private Float containerWeight;
    /**
     * 集装箱位置，1-前;2-中;3-后
     */
    @ApiModelProperty(value = "集装箱位置，1-前;2-中;3-后")
    private Integer containerPosition;
    /**
     * 集装箱尺寸
     */
    @ApiModelProperty(value = "集装箱尺寸")
    private Integer containerSize;
    /**
     * 车辆当前装箱状态:0-空;1-大箱;2-双小箱;3-前小箱;4-中小箱;5-后小箱
     */
    @ApiModelProperty(value = "车辆当前装箱状态:0-空;1-大箱;2-双小箱;3-前小箱;4-中小箱;5-后小箱")
    private Integer cartonCondition;
    /**
     * 途经点数量（最大为2）
     */
    @ApiModelProperty(value = "途经点数量（最大为2）")
    private Integer passPointNum;
    /**
     * 到达途径点1时间
     */
    @ApiModelProperty(value = "到达途径点1时间")
    private Date passPointTime1;
    /**
     * 到达途径点2时间
     */
    @ApiModelProperty(value = "到达途径点2时间")
    private Date passPointTime2;
    /**
     * 途经点经纬度
     */
    @ApiModelProperty(value = "途经点经纬度")
    private String passPointLocations;
    /**
     * 艘次编号
     */
    @ApiModelProperty(value = "艘次编号")
    private String voyageNo;
    /**
     * 任务状态， 1-到达途径点1，2-到达途径点2，3-到达目的地，16-开始精准定位，17-开始装箱，18-开始卸箱，19-开始充电，33-完成装箱，34-完成卸箱，35-完成充电，36-完成停车（固定停车区任务），37-三重确认完成，41-任务终止，42-平台接受，43-车辆接受，49-车辆停稳锁死，50-车辆解除锁死
     */
    @ApiModelProperty(value = "任务状态 41-任务终止，42-平台接受，43-车辆接受，1-到达途径点1，2-到达途径点2，3-到达目的地，11-开始装箱，12-开始卸箱，13-开始充电，21-完成装箱，22-完成卸箱，23-完成充电，31-车辆停稳锁死，32-车辆解除锁死")
    @Excel(name = "作业状态", orderNum = "13", replace = {"到达途径点1_1","到达途径点2_2","到达目的地_3","开始精准定位_16","开始装箱_17","开始卸箱_18","开始充电_19","完成装箱_33","完成卸箱_34","完成充电_35","完成停车（固定停车区任务）_36","三重确认完成_37","任务终止_41","平台接受_42","车辆接受_43","车辆停稳锁死_49","车辆解除锁死_50","_null"}, width = 10)
    private Integer status;
    /**
     * 任务开始时间
     */
    @ApiModelProperty(value = "任务开始时间")
    @Excel(name = "任务开始时间", orderNum = "2", width = 25,format="yyyy-MM-dd HH:mm:ss")
    private Date startTime;
    /**
     * 任务结束时间
     */
    @ApiModelProperty(value = "任务结束时间")
    private Date endTime;
    /**
     * 任务分析状态 0：未完成，1：完成
     */
    @ApiModelProperty(value = "任务分析状态 0：未完成，1：完成")
    private Integer analysisStatus;
    /**
     * TOS下发指令时间
     */
    @ApiModelProperty(value = "TOS下发指令时间")
    private Long collectTime;
    /**
     * 接收时间
     */
    @ApiModelProperty(value = "接收时间")
    private Date receiveTime;
    /**
     * 状态更新时间
     */
    @ApiModelProperty(value = "状态更新时间")
    private Date updateTime;
    /**
     * 逻辑删除，0-有效，1-无效
     */
    @ApiModelProperty(value = "逻辑删除，0-有效，1-无效")
    @TableField(value = "`deleted`")
    private Integer deleted;
    /**
     * 版本号
     */
    @ApiModelProperty(value = "版本号")
    private Integer version;

    /**
     * 车辆任务标签
     */
    @ApiModelProperty(value = "车辆任务标签：1:装船；2：卸船；3：堆场间搬移； 4：停车，5：充电")
    private Integer vehicleTaskLabel;

    /**
     * 任务里程能耗信息
     */
    @ApiModelProperty(value = "任务里程能耗信息")
    @TableField(exist = false)
    private VmsTaskJourneyInfo vmsTaskJourneyInfo;

    /**
     * 作业时间
     */
    @ApiModelProperty(value = "作业时间")
    @TableField(exist = false)
    @Excel(name = "作业时间", orderNum = "14")
    private String costTime;

    /**
     * 车辆编号
     */
    @ApiModelProperty(value = "车辆编号")
    @TableField(exist = false)
    @Excel(name = "车辆编号", orderNum = "4")
    private String vehicleNum;

    /**
     * 任务来源，1-TOS下发;2-手动下发;3-VMS下发
     */
    @ApiModelProperty(value = "任务来源，1-TOS下发;2-手动下发;3-VMS下发")
    @Excel(name = "指令来源", orderNum = "15")
    private Integer taskSource;


    /**
     * 目的地维度
     */
    private BigDecimal latitude;

    /**
     * 目的地经度
     */
    private BigDecimal longitude;

    /**
     * 车辆任务点描述
     */
    @TableField(exist = false)
    private String locationDescription;

    @TableField(exist = false)
    private Integer costTimeSeconds;

    @TableField(exist = false)
    private Long startTimeStamp;

    @TableField(exist = false)
    private Integer lockLabel;

    @TableField(exist = false)
    private Integer overSign;

    @TableField(exist = false)
    private String taskAssociation;

    @TableField(exist = false)
    @Excel(name = "APP介入", orderNum = "16")
    private Integer appControl;

}
