package com.ssi.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.time.LocalDate;
import java.util.Date;


/**
 * 任务分析表
 *
 * @author hli
 * @email
 * @date 2021-01-11 14:00:36
 */
@Getter
@Setter
@ApiModel(value = "VmsTosOrdersAnalysis")
public class VmsTosOrdersAnalysis {

    /**
     *
     */
    @ApiModelProperty(value = "id")
    @TableId(type = IdType.AUTO)
    private Long id;
    /**
     *
     */
    @ApiModelProperty(value = "车辆vin")
    private String vin;
    /**
     * 分析日期
     */
    @ApiModelProperty(value = "分析日期")
    private LocalDate analysisDate;
    /**
     * 装船数量
     */
    @ApiModelProperty(value = "装船数量")
    private Integer loadContainerNum;
    /**
     * 卸船数量
     */
    @ApiModelProperty(value = "卸船数量")
    private Integer unloadContainerNum;
    /**
     * 理货数量
     */
    @ApiModelProperty(value = "理货数量")
    private Integer handleContainerNum;
    /**
     * 装船总时间
     */
    @ApiModelProperty(value = "装船总时间")
    private Long loadContainerTime;
    /**
     * 卸船总时间
     */
    @ApiModelProperty(value = "卸船总时间")
    private Long unloadContainerTime;
    /**
     * 理货总时间
     */
    @ApiModelProperty(value = "理货总时间")
    private Long handleContainerTime;
    /**
     * 修改时间
     */
    @ApiModelProperty(value = "修改时间")
    private Date updateTime;
    /**
     * 逻辑删除，0-未删除，1-删除
     */
    @ApiModelProperty(value = "逻辑删除，0-未删除，1-删除")
    private Integer deleted;

}
