package com.ssi.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.Date;


/**
 * @author hli
 * @email
 * @date 2021-02-04 11:00:44
 */
@Getter
@Setter
@ApiModel(value = "VmsTosOrdersOee")
public class VmsTosOrdersOee {

    /**
     *
     */
    @ApiModelProperty(value = "id")
    @TableId(type = IdType.AUTO)
    private Integer id;
    /**
     *
     */
    @ApiModelProperty(value = "")
    private String vin;
    /**
     * 车辆编号
     */
    @ApiModelProperty(value = "车辆编号")
    private String vehicleNum;
    /**
     * 任务编号
     */
    @ApiModelProperty(value = "任务编号")
    private String taskNo;
    /**
     * 任务类型, 1-去堆场（装箱或卸箱）;2-去停车点（上扭锁，解扭锁，停车）;3-去固定停车区;4-去临时停车区;5-去桥吊（装箱或卸箱）；6-去充电
     */
    @ApiModelProperty(value = "任务类型, 1-去堆场（装箱或卸箱）;2-去停车点（上扭锁，解扭锁，停车）;3-去固定停车区;4-去临时停车区;5-去桥吊（装箱或卸箱）；6-去充电")
    private Integer taskLocationType;
    /**
     * 作业类型,1:装箱，2:卸箱，3:充电，4:上扭锁，5:解扭锁,6:停车，7掉头
     */
    @ApiModelProperty(value = "作业类型,1:装箱，2:卸箱，3:充电，4:上扭锁，5:解扭锁,6:停车，7掉头")
    private Integer taskType;
    /**
     * 1-桥吊;2-场吊
     */
    @ApiModelProperty(value = "1-桥吊;2-场吊")
    private Integer portType;
    /**
     * 港机编码
     */
    @ApiModelProperty(value = "港机编码")
    private String portCode;
    /**
     * 车辆任务类型, 1-大箱;2-双小箱;3-单小箱;0-其它
     */
    @ApiModelProperty(value = "车辆任务类型, 1-大箱;2-双小箱;3-单小箱;0-其它")
    private Integer vehicleTaskType;
    /**
     * 车辆任务标签,1:装船；2：卸船；3：堆场间搬移；4：停车，5：充电，6：临时停车
     */
    @ApiModelProperty(value = "车辆任务标签,1:装船；2：卸船；3：堆场间搬移；4：停车，5：充电，6：临时停车")
    private Integer vehicleTaskLabel;
    /**
     * 集装箱类型,1-大箱 ;2-双小箱;3-单小箱
     */
    @ApiModelProperty(value = "集装箱类型,1-大箱 ;2-双小箱;3-单小箱")
    private String containerType;
    /**
     * 集装箱数量
     */
    @ApiModelProperty(value = "集装箱数量")
    private Integer containerNum;
    /**
     * 集装箱重量
     */
    @ApiModelProperty(value = "集装箱重量")
    private Float containerWeight;
    /**
     * 集装箱尺寸
     */
    @ApiModelProperty(value = "集装箱尺寸")
    private Integer containerSize;
    /**
     * 任务开始时间
     */
    @ApiModelProperty(value = "任务开始时间")
    private Date startTime;
    /**
     * 任务当前状态变更时间
     */
    @ApiModelProperty(value = "任务当前状态变更时间")
    private Date endTime;
    /**
     * TOS下发指令时间戳
     */
    @ApiModelProperty(value = "TOS下发指令时间戳")
    private Long collectTime;
    /**
     *
     */
    @ApiModelProperty(value = "")
    private Date receiveTime;
    /**
     * 艘次编号
     */
    @ApiModelProperty(value = "艘次编号")
    private String voyageNo;
    /**
     * 指令等待时间
     */
    @ApiModelProperty(value = "指令等待时间")
    private Long instructionWaitingTime;
    /**
     * 作业准备时间
     */
    @ApiModelProperty(value = "作业准备时间")
    private Long homeworkPreparationTime;
    /**
     * 移动到取箱点时间
     */
    @ApiModelProperty(value = "移动到取箱点时间")
    private Long moveTheBoxTime;
    /**
     * 取箱点等待时间
     */
    @ApiModelProperty(value = "取箱点等待时间")
    private Long pickingTime;
    /**
     * 逻辑删除，0-未删除，1-删除
     */
    @ApiModelProperty(value = "逻辑删除，0-未删除，1-删除")
    private Integer deleted;

}
