package com.ssi.entity;

import cn.afterturn.easypoi.excel.annotation.Excel;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.util.Date;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 
 * @TableName vms_tos_original_orders
 */
@TableName(value ="vms_tos_original_orders")
@Data
public class VmsTosOriginalOrders implements Serializable {
    /**
     * 
     */
    @TableId
    private Integer id;

    /**
     * 
     */
    private String vin;

    /**
     * 任务编号
     */
    private String taskNo;

    /**
     * 任务类型, 1-去堆场（装箱或卸箱）;2-去停车点（上扭锁，解扭锁，停车）;3-去固定停车区;4-去临时停车区;5-去桥吊（装箱或卸箱）；6-去充电
     */
    private Byte taskLocationType;

    /**
     * 作业类型,1:装箱，2:卸箱，3:充电，4:上扭锁，5:解扭锁,6:停车，7掉头
     */
    private Byte taskType;

    /**
     * 车辆任务标签,1:装船；2：卸船；3：堆场间搬移；4：停车，5：充电，6：临时停车
     */
    private Byte vehicleTaskLabel;

    /**
     * 集装箱编号
     */
    private String containerId;

    /**
     * 集装箱尺寸
     */
    private Byte containerSize;

    /**
     * 集装箱车上位置, 1-前;2-中;3-后
     */
    private Byte containerPosition;

    /**
     * 双小箱装卸标签 0：非小箱，1：一吊一箱，2：一吊双箱
     */
    private Byte containerLabel;

    /**
     * 车辆任务类型, 1-大箱;2-双小箱;3-单小箱;0-其它
     */
    private Byte vehicleTaskType;

    /**
     * 辆任务目标地点
     */
    private String vehicleLocation;

    /**
     * 父任务编号
     */
    private String parentTaskNo;

    /**
     * 序号,双小箱任务seq相同
     */
    private String seq;

    /**
     * 艘次编号
     */
    private String voyageNo;

    /**
     * TOS下发指令时间戳
     */
    private Long collectTime;

    /**
     * 集装箱类型,1-大箱 ;2-双小箱;3-单小箱
     */
    private String containerType;

    /**
     * 集装箱重量
     */
    private Double containerWeight;

    /**
     * 港机编码
     */
    private String portCode;

    /**
     * 1-桥吊;2-场吊
     */
    private Byte portType;

    /**
     * //扭锁标签 0：不需装扭锁；1：需装扭锁；2需卸扭锁
     */
    private String localLabel;

    /**
     * 任务关联
     */
    private String taskAssociation;

    /**
     * 作业完成信号, 0-完成;1-继续作业
     */
    private String overSign;

    /**
     * 车辆当前装箱状态:0-空;1-大箱;2-双小箱;3-前小箱;4-中小箱;5-后小箱
     */
    private Byte cartonCondition;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;

    /**
     * 车辆任务点描述
     */
    @TableField(exist = false)
    private String locationDescription;

    @TableField(exist = false)
    private Integer costTimeSeconds;

    @TableField(exist = false)
    private Long startTimeStamp;

    @TableField(exist = false)
    private Integer lockLabel;

    @TableField(exist = false)
    private Integer appControl;

    @TableField(exist = false)
    private String vehicleNum;

    @TableField(exist = false)
    private String costTime;

    @TableField(exist = false)
    private Date startTime;
    /**
     * 任务结束时间
     */
    @TableField(exist = false)
    private Date endTime;
    @TableField(exist = false)
    private Date updateTime;
    @TableField(exist = false)
    private Integer taskSource;
    @TableField(exist = false)
    private Integer containerNum;
}