package com.ssi.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.util.Date;


/**
 * @author zhang liyao
 * @email
 * @date 2020-07-17 09:47:00
 */
@Getter
@Setter
@ApiModel(value = "VmsVehicleEmergencyStop")
public class VmsVehicleEmergencyStop {

    /**
     *
     */
    @ApiModelProperty(value = "id")
    @TableId(type = IdType.AUTO)
    private Long id;
    /**
     *
     */
    @ApiModelProperty(value = "")
    private Long parentId;
    /**
     *
     */
    @ApiModelProperty(value = "")
    private String vin;
    /**
     * 急停类型 1：急停，2：取消急停
     */
    @ApiModelProperty(value = "急停类型")
    private String emergencyType;
    /**
     * 接收指令时间
     */
    @ApiModelProperty(value = "接收指令时间")
    private Date receive_time;
    /**
     * 车端反馈时间
     */
    @ApiModelProperty(value = "车端反馈时间")
    private Date feedbackTime;
    /**
     * 反馈结果 1:紧停成功，2：紧停失败，17：取消紧停成功，18：取消紧停失败
     */
    @ApiModelProperty(value = "反馈结果")
    private Integer result;
    /**
     * 错误原因
     */
    @ApiModelProperty(value = "错误原因")
    private String errorMsg;
    /**
     * 报警位置
     */
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 解除报警时间
     */
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
    /**
     * 车辆编号
     */
    @ApiModelProperty(value = "车辆编号")
    @TableField(exist = false)
    private String vehicleNum;
}
