package com.ssi.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.math.BigDecimal;
import java.util.Date;


/**
 * 运营里程定时任务表
 *
 * @author zhang liyao
 * @email
 * @date 2020-07-16 09:32:59
 */
@Getter
@Setter
@ApiModel(value = "VmsVehicleOperateTask")
public class VmsVehicleOperateTask {

    /**
     *
     */
    @ApiModelProperty(value = "id")
    @TableId(type = IdType.AUTO)
    private Integer id;
    /**
     * vin
     */
    @ApiModelProperty(value = "vin")
    private String vin;
    /**
     * 运营里程
     */
    @ApiModelProperty(value = "运营里程")
    private BigDecimal operateMile;
    /**
     * 运营时长
     */
    @ApiModelProperty(value = "运营时长")
    private BigDecimal operateTime;

    /**
     * 统计日期
     */
    @ApiModelProperty(value = "统计日期")
    private String taskDate;
    /**
     * 统计成功
     */
    @ApiModelProperty(value = "统计成功 0 成功 1 失败")
    private Integer taskSuccess;

    @TableField(exist = false)
    private Double mileVal;

    @TableField(exist = false)
    private Long timeVal;
    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 修改时间
     */
    @ApiModelProperty(value = "修改时间")
    private Date updateTime;
}
