package com.ssi.entity.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import lombok.ToString;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

/**
 * 车辆控制参数类
 */
@Getter
@Setter
@ToString
@ApiModel("车辆控制参数")
public class CarControlCommandParam {
    //车辆编号
    @ApiModelProperty("车辆编号")
    @NotBlank(message = "vin不能为空")
    private String vin;

    //时间戳
    private Long collectTime;

    //指令类型,1-启动 2-熄火 3-停车 4-前移 5-后退 6-左转 7-右转
    @ApiModelProperty("指令类型,1-启动 2-熄火 3-停车 4-前移 5-后退 6-左转 7-右转")
    @NotNull(message = "指令类型不能为空")
    private Integer commandType;

}
