package com.ssi.entity.dto;

import lombok.Data;

import javax.validation.constraints.NotNull;

/**
 * 远程操作APP车控参数
 * @author ZhangLiYao
 * @version 1.0
 * @date 2020/9/1 18:28
 */
@Data
public class TelecontrolParamDto {

    @NotNull(message = "vin不能为空")
    private String vin;

    @NotNull(message = "控制类型不能为空")
    private Integer controlType;

    private Integer operationType;

    @NotNull(message = "操作必须传值")
    private Integer operationValue;

    @NotNull(message = "appMac必须传值")
    private String appMac;

    @NotNull(message = "置零标识必须传值")
    private Integer zeroed;

    private String taskId;

    public static boolean isTakeOverCommand(TelecontrolParamDto telecontrolParamDto){
        return telecontrolParamDto != null
                && telecontrolParamDto.getControlType() != null
                && telecontrolParamDto.getControlType() == 1
                && telecontrolParamDto.getOperationValue() != null
                && telecontrolParamDto.getOperationValue() == 1;
    }

    public static boolean isCancelTakeOverCommand(TelecontrolParamDto telecontrolParamDto){
        return telecontrolParamDto != null
                && telecontrolParamDto.getControlType() != null
                && telecontrolParamDto.getControlType() == 1
                && telecontrolParamDto.getOperationValue() != null
                && telecontrolParamDto.getOperationValue() == 2;
    }
}
