package com.ssi.entity.dto;

import lombok.Data;

import java.math.BigDecimal;

@Data
public class VehicleTerminalData {

    private BigDecimal zAxisCoordinate;
    private Integer lightDirection;
    private BigDecimal zAxisAngleSpeed;
    private Integer soc;
    private Integer espStatus;
    private BigDecimal yAxisAcceleration;
    private Integer batteryGroupSOH;
    private BigDecimal zAxisSpeed;
    private Integer autoPilotMode;
    private Integer gpsStatus;
    /**
     * charging status:
     * 1: charging
     */
    private Integer chargingStatus;
    private BigDecimal rollAngle;
    private String vin;
    private String id;
    private Integer motorCurrentNm;
    private Integer outShaftRpm;
    private Integer brakeLampState;
    private String vehicleType;
    private BigDecimal brakePedalOpen;
    private Double longitude;
    private BigDecimal mileage;
    private Integer vehicleState;
    private BigDecimal yawAngle;
    private Integer brakeStatus;
    private Integer sidelights;
    private String index;
    private Integer batteryGasPressureMonitoring;
    private Integer batteryGroupStatus;
    private Integer singleMaximumTemperature;
    private Integer keyOnStatus;
    private BigDecimal motorCurrentRpm;
    private BigDecimal yAxisSpeed;
    private Integer drivingLampStatus;
    private BigDecimal steeringAngle;
    private Integer alarmHornLight;
    private double totalVoltage;
    private Integer gear;
    private Integer rightTurn;
    private Integer tcsStatus;
    private Integer altitude;
    private Integer absStatus;
    private BigDecimal xAxisSpeed;
    private Double latitude;
    private Integer leftTurn;
    private String msgId;
    private BigDecimal xAxisCoordinate;
    private Long gpsTimestamp;
    private BigDecimal speed;
    private Integer dippedHeadlight;
    private String vehicleCompany;
    private String sim;
    private BigDecimal xAxisAngleSpeed;
    private Double totalElectricity;
    private BigDecimal fullChargeCapacity;
    private Integer insulationResistanceDetectStatus;
    private BigDecimal zAxisAcceleration;
    private Integer ldwStatus;
    private String table;
    private Integer direction;
    private Long collectTime;
    private Integer loadStatus;
    private BigDecimal yAxisCoordinate;
    private String plateNo;
    private BigDecimal xAxisAcceleration;
    private Integer rearWheelSpeed;
    private BigDecimal totalMile;
    private BigDecimal pitchAngle;
    private Long receiveTime;
    private Integer equipStatus;
    private BigDecimal[] location;
    private Double singleMinimumVoltage;
    private String did;
    private BigDecimal yAxisAngleSpeed;
    private Integer powerStatus;

    /**
     * @return
     */
    public boolean isRun() {
        if (isCharging()) {
            return false;
        }

        return true;
    }

    public boolean isCharging() {
        return this.getChargingStatus() != null && 1 == this.getChargingStatus();
    }

}
