package com.ssi.entity.dto;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;


/**
 * 车辆表
 *
 * @author zhang liyao
 * @email
 * @date 2020-07-08 15:38:37
 */
@Data
@ApiModel(value = "VmsVehicle")
public class VmsVehicleDto implements Serializable {

    /**
     *
     */
    @ApiModelProperty(value = "id")
    @TableId(type = IdType.AUTO)
    private Long id;
    /**
     *
     */
    @ApiModelProperty(value = "vin")
    private String vin;

    /**
     *
     */
    @ApiModelProperty(value = "vin")
    private String vinSSI;

    /**
     * 车辆编号
     */
    @ApiModelProperty(value = "车辆编号")
    private String vehicleNum;

    /**
     * 车辆编号
     */
    @ApiModelProperty(value = "车辆编号")
    private String vehicleNumSSI;

    /**
     * 禁用标记 ( 1  已禁用  0 未禁用)
     */
    @ApiModelProperty(value = "禁用标记 ( 1  已禁用  0 未禁用)")
    private Integer status;
    /**
     * 车型id
     */
    @ApiModelProperty(value = "车型id")
    private Integer vehicleType;
    /**
     * 车型名
     */
    @ApiModelProperty(value = "车型名")
    private String vehicleTypeName;
    /**
     * 车牌号
     */
    @ApiModelProperty(value = "车牌号")
    private String plateNo;
    /**
     * 终端编号
     */
    @ApiModelProperty(value = "终端编号")
    private String terminalNum;
    /**
     * 视频终端编号
     */
    @ApiModelProperty(value = "视频终端编号")
    private String videoTerminalNum;
    /**
     * 底盘号
     */
    @ApiModelProperty(value = "底盘号")
    private String chassisNum;
    /**
     * 总电量
     */
    @ApiModelProperty(value = "总电量")
    private BigDecimal totalElecQuantity;
    /**
     * 最低可用soc
     */
    @ApiModelProperty(value = "最低可用soc")
    private Integer lowestSoc;
    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 修改时间
     */
    @ApiModelProperty(value = "修改时间")
    private Date updateTime;
}
