package com.ssi.entity.dto.kpi;

import cn.afterturn.easypoi.excel.annotation.Excel;
import com.ssi.entity.dto.VmsTosOrdersDto;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

/**
 * KPI页面数据实体类
 */
@Data
public class VmsTosOrdersKpiDto {

    /**
     * 任务编号映射值
     */
    @ApiModelProperty(value = "任务编号映射值")
    @Excel(name = "任务编号", orderNum = "3", width = 10)
    private String taskNo;
    /**
     * 车辆编号
     */
    @ApiModelProperty(value = "车辆编号")
    @Excel(name = "车辆编号", orderNum = "4")
    private String vehicleNum;

    /**
     * 作业耗时
     */
    @ApiModelProperty(value = "作业耗时")
    @Excel(name = "作业时间", orderNum = "14")
    private String costTime;

    /**
     * 集装箱编号
     */
    @ApiModelProperty(value = "集装箱编号")
    @Excel(name = "集装箱ID", orderNum = "10", width = 10)
    private String containerId;

    /**
     * TOS下发指令时间
     */
    @ApiModelProperty(value = "TOS下发指令时间")
    private Long collectTime;

    /**
     * 结束时间
     */
    @ApiModelProperty(value = "结束时间")
    private Long endTime;

    /**
     * 集装箱重量
     */
    @ApiModelProperty(value = "集装箱重量")
    private Float containerWeight;

    /**
     * 集装箱尺寸
     */
    @ApiModelProperty(value = "集装箱尺寸")
    private Integer containerSize;

    /**
     * 车辆任务标签
     */
    @ApiModelProperty(value = "车辆任务标签：1:装船；2：卸船；3：堆场间搬移； 4：停车，5：充电")
    private Integer vehicleTaskLabel;

    //
    private Integer taskSource;

    @ApiModelProperty(value = "app介入")
    private Integer appControl;

    /**
     * 车辆接受、启动、完成任务状态时间列表
     */
    private List<VehicleDateStageDto> statusDateList;

    /**
     * 子任务列表
     */
    private List<VmsTosOrdersDto> vmsOrderList;
}
