package com.ssi.entity.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.List;

@Getter
@Setter
public class DayHourTrend implements Serializable {

    @JsonFormat(pattern = "M.d")
    private LocalDate date;

    private int hour;

    public static List<DayHourTrend> fillBlankDay(List<? extends DayHourTrend> list, Class<? extends DayHourTrend> clazz, LocalDateTime startTime, LocalDateTime endTime) throws Exception{
        List<DayHourTrend> resList = new ArrayList<>();
        LocalDate date = startTime.toLocalDate();
        do {
            DayHourTrend vo = clazz.newInstance();
            vo.setDate(date);
            for (int i = 0; i < list.size(); i++) {
                DayHourTrend vo1 = list.get(i);
                if (date.compareTo(vo1.getDate()) == 0) {
                    vo = vo1;
                    break;
                }
            }
            resList.add(vo);
            date = date.plusDays(1);
        } while (date.compareTo(endTime.toLocalDate()) <= 0);
        return resList;
    }

    public static List<? extends DayHourTrend> fillBlankHour(List<? extends DayHourTrend> list,Class<? extends DayHourTrend> clazz) throws Exception{
        List<DayHourTrend> resList = new ArrayList<>();
        for (int i = 0; i < 24; i++) {
            DayHourTrend vo = null;
            for (int j = 0; j < list.size(); j++) {
                DayHourTrend vo1 = list.get(j);
                if (vo1.getHour() == i) {
                    vo = vo1;
                    break;
                }
            }
            if (vo == null) {
                vo = clazz.newInstance();
                vo.setHour(i);
            }
            resList.add(vo);
        }
        return resList;
    }
}
