package com.ssi.entity.vo;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import lombok.ToString;

import java.math.BigDecimal;
import java.util.Date;

@Getter
@Setter
@ToString
public class VehicleControlStatusVo {

    /**
     *
     */
    @ApiModelProperty(value = "id")
    @TableId(type = IdType.AUTO)
    private Long id;
    /**
     *
     */
    @ApiModelProperty(value = "vin")
    private String vin;
    /**
     * 车辆编号
     */
    @ApiModelProperty(value = "车辆编号")
    private String vehicleNum;
    /**
     * 禁用标记 ( 1  已禁用  0 未禁用)
     */
    @ApiModelProperty(value = "禁用标记 ( 1  已禁用  0 未禁用)")
    private Integer status;
    /**
     * 车型id
     */
    @ApiModelProperty(value = "车型id")
    private Integer vehicleType;
    /**
     * 车型名
     */
    @ApiModelProperty(value = "车型名")
    private String vehicleTypeName;
    /**
     * 车牌号
     */
    @ApiModelProperty(value = "车牌号")
    private String plateNo;
    /**
     * 终端编号
     */
    @ApiModelProperty(value = "终端编号")
    private String terminalNum;
    /**
     * 底盘号
     */
    @ApiModelProperty(value = "底盘号")
    private String chassisNum;
    /**
     * 总电量
     */
    @ApiModelProperty(value = "总电量")
    private BigDecimal totalElecQuantity;
    /**
     * 最低可用soc
     */
    @ApiModelProperty(value = "最低可用soc")
    private Integer lowestSoc;
    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 修改时间
     */
    @ApiModelProperty(value = "修改时间")
    private Date updateTime;

    private Integer appControl;

    private Integer appActive;

    private String appMac;

    /**
     * 1-紧急停车;2-取消紧停
     */
    private Integer emergencyStatus;

    /**
     * 1:进入自动驾驶，4:结束自动驾驶
     */
    private Integer autopilot;
    /**
     *车辆电量百分比
     */
    private Integer soc;
}
