package com.ssi.entity.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;
import java.util.Map;

/**
 * @author ZhangLiYao
 * @version 1.0
 * @date 2020/7/10 10:18
 */
@Data
@ApiModel(value = "VehicleStatusVo")
public class VehicleStatusVo {

    /**
     * 车辆总数
     */
    @ApiModelProperty(value = "车辆总数")
    private Integer vehicleNum;
    /**
     * 装船中车辆数
     */
    @ApiModelProperty(value = "装船中车辆数")
    private Integer loadingGoodsNum;
    /**
     * 卸船中车辆数
     */
    @ApiModelProperty(value = "卸船中车辆数")
    private Integer unloadingGoodsNum;
    /**
     * 理货车辆数
     */
    @ApiModelProperty(value = "理货车辆数")
    private Integer arrangeGoodsNum;
    /**
     * 停车、空闲车辆数
     */
    @ApiModelProperty(value = "停车、空闲车辆数")
    private Integer parkNum;
    /**
     * 充电车辆数
     */
    @ApiModelProperty(value = "充电车辆数")
    private Integer chargeNum;
    /**
     * 临时停车车辆数
     */
    @ApiModelProperty(value = "临时停车车辆数")
    private Integer temporaryParkNum;
    /**
     * 离线车辆数
     */
    @ApiModelProperty(value = "离线车辆数")
    private Integer offlineNum;

    /**
     * 其他任务类型车辆数（大屏用）
     */
    @ApiModelProperty(value = "其他任务类型车辆数（大屏用）")
    private Integer otherOrdersNum;




    /**
     * 离线车辆数占比
     */
    @ApiModelProperty(value = "离线车辆数占比")
    private String offlinePer;

    /**
     * 装船中车辆占比
     */
    @ApiModelProperty(value = "装船中车辆占比")
    private String loadingGoodsPer;
    /**
     * 卸船中车辆占比
     */
    @ApiModelProperty(value = "卸船中车辆占比")
    private String unloadingGoodsPer;
    /**
     * 理货车辆占比
     */
    @ApiModelProperty(value = "理货车辆占比")
    private String arrangeGoodsPer;
    /**
     * 空闲车辆占比
     */
    @ApiModelProperty(value = "空闲车辆占比")
    private String parkPer;
    /**
     * 充电车辆数占比
     */
    @ApiModelProperty(value = "充电车辆数占比")
    private String chargePer;
    /**
     * 临时停车车辆数占比
     */
    @ApiModelProperty(value = "临时停车车辆数占比")
    private String temporaryParkPer;
    /**
     * 临时停车车辆数占比
     */
    @ApiModelProperty(value = "临时停车车辆数占比")
    private String otherOrdersPer;
}
