package com.ssi.entity.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import lombok.ToString;

import java.util.Date;

import cn.afterturn.easypoi.excel.annotation.Excel;

@Getter
@Setter
@ToString
public class VmsVehicleAlertHistoryVo {
    /**
     *
     */
    private String id;
    /**
     *
     */
    @ApiModelProperty(value = "")
    private String vin;
    /**
     * 故障代码
     */
    @ApiModelProperty(value = "故障代码")
    @Excel(name = "报文Id", orderNum = "3", width = 35)
    private String faultCode;
    /**
     * SPN
     */
    @ApiModelProperty(value = "SPN")
    @Excel(name = "SPN", orderNum = "5", width = 35)
    private String spn;
    /**
     * FMI
     */
    @ApiModelProperty(value = "FMI")
    @Excel(name = "FMI", orderNum = "4", width = 35)
    private String fmi;
    /**
     * 报警状态 0：未解除 1：已解除
     */
    @ApiModelProperty(value = "报警状态 0：未解除 1：已解除")
    private Integer troubleStatus;
    /**
     * 报警时间
     */
    @ApiModelProperty(value = "报警时间")
    @Excel(name = "报警时间", orderNum = "8", width = 35)
    private Date alarmTime;
    /**
     * 报警位置
     */
    @ApiModelProperty(value = "报警位置")
    private String alarmPosition;
    /**
     * 解除报警时间
     */
    @ApiModelProperty(value = "解除报警时间")
    @Excel(name = "解除时间", orderNum = "9", width = 35)
    private Date relieveAlarmTime;
    /**
     * 车辆编号
     */
    @ApiModelProperty(value = "车辆编号")
    @Excel(name = "车辆编号", orderNum = "1", width = 35)
    private String vehicleNum;

    /**
     * 故障等级 1 一级 2 二级 3 三级
     */
    @ApiModelProperty(value = "故障等级")
    @Excel(name = "报警等级", orderNum = "6", replace = {"一般故障_1","严重故障_2","报警_3","事件_4"},width = 35)
    private String faultGrade;

    /**
     * 描述
     */
    @ApiModelProperty(value = "故障描述")
    private String describition;

    /**
     * 故障名称
     */
    @Excel(name = "报警名称", orderNum = "2", width = 35)
    private String faultName;

    /**
     * 故障类型，V：整车，I：智能，P：平台，OBU：OBU
     */
    @Excel(name = "报警类型", orderNum = "7",replace = {"整车系统_V","智能系统_I","车管平台_P","OBU_OBU"}, width = 35)
    private String faultType;

    @ApiModelProperty(value = "故障源类别")
    @Excel(name = "故障源类别", orderNum = "7")
    private String faultSourceType;

    @ApiModelProperty(value = "故障源类别名称")
    @Excel(name = "故障源类别名称", orderNum = "8")
    private String faultSourceTypeName;

    @ApiModelProperty(value = "故障源识别码")
    @Excel(name = "故障源识别码", orderNum = "9")
    private String faultLabel;

    @ApiModelProperty(value = "故障诊断仪码")
    @Excel(name = "故障诊断仪码", orderNum = "10")
    private String faultDmCode;

    @ApiModelProperty(value = "故障模块")
    @Excel(name = "故障模块", orderNum = "11")
    private String faultModule;

    @ApiModelProperty(value = "故障原因")
    @Excel(name = "故障原因", orderNum = "12")
    private String faultReason;

    @ApiModelProperty(value = "故障解决方案")
    @Excel(name = "故障解决方案", orderNum = "13")
    private String faultSolution;

}
