package com.ssi.kafka.model;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.kafka.support.SendResult;
import org.springframework.stereotype.Component;
import org.springframework.util.concurrent.ListenableFuture;

import java.util.List;
import java.util.Map;

/**
 * 推送数据到kafka，此类暂未使用
 */
@Component
@Slf4j
public class KafkaRecordModel {

  @Value("${spring.websocket.history.record:vms_history_record}")
  private String topic;

  @Value("${meilan.faceRecongition.record:MEILAN_FACE_RECOGNITION_TOPIC}")
  private String faceRecongitionTopic;

  @Autowired
  private KafkaTemplate<String, String> kafkaTemplate;

  public void messageBroadcast(List<Map<String, Map<String, Object>>> messages) {
    long timestamp = System.currentTimeMillis();
    messages.forEach(message -> {
      String msg = String.format(
          "{\"key\":\"all\",\"timestamp\":%s,\"id\":\"%s\",\"value\":%s,\"msgId\":\"vms_history_data\"}",
          timestamp, timestamp, JSON.toJSONString(message));
      ListenableFuture<SendResult<String, String>> send
          = kafkaTemplate.send(topic, null, timestamp, null, msg);
      send.addCallback(result -> {
        log.debug(String.format("推送成功：%s", "result"));
      }, ex -> {
        if (ex != null) {
          log.error("推送失败!", ex);
        }
      });
    });
  }

  public void sendFaceRecongition(String data) {
    JSONObject jsonObject = JSON.parseObject(data);
    long timestamp = System.currentTimeMillis();
    String vin = jsonObject.getString("vin");
    kafkaTemplate.send(faceRecongitionTopic, null, timestamp, vin, data);
    kafkaTemplate.flush();
  }
}
