package com.ssi.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.ssi.entity.VmsVehicleAlertHistory;
import com.ssi.entity.vo.VmsVehicleAlertHistoryVo;
import com.ssi.entity.vo.VmsVehicleFaultVo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;

/**
 * @author zhang liyao
 * @email
 * @date 2020-07-17 09:47:00
 */
@Mapper
public interface VehicleTroubleHistoryMapper extends BaseMapper<VmsVehicleAlertHistory> {

    IPage<VmsVehicleAlertHistoryVo> getAlertHistoryList(IPage<VmsVehicleAlertHistoryVo> page, @Param("param") Map<String, Object> params);

    List<VmsVehicleAlertHistoryVo> getAlertHistoryList(@Param("param") Map<String, Object> params);

    /**
     * 获取24小时故障趋势图
     * @param startTime
     * @param endTime
     * @param startTimeStamp
     * @param params
     * @return
     */
    List<VmsVehicleFaultVo> getFaultTrendByHour(@Param("startTime")LocalDateTime startTime,
                                                @Param("endTime")LocalDateTime endTime,
                                                @Param("startTimeStamp")Long startTimeStamp,
                                                @Param("params")Map<String, Object> params);

    /**
     * 获取7天、一个月的故障趋势图
     * @param startTime
     * @param endTime
     * @param params
     * @return
     */
    List<VmsVehicleFaultVo> getFaultTrendByDay(@Param("startTime")LocalDateTime startTime,
                                               @Param("endTime")LocalDateTime endTime,
                                               @Param("params")Map<String, Object> params);

    /**
     * 获取TOP 10的故障
     * @param startTime
     * @param endTime
     * @param params
     * @return
     */
    List<VmsVehicleFaultVo> getFaultDistribution(@Param("startTime") LocalDate startTime,
                                                 @Param("endTime")LocalDateTime endTime,
                                                 @Param("params")Map<String, Object> params);

    /**
     *获取24小时故障类型趋势图
     * @param startTime
     * @param endTime
     * @param startTimeStamp
     * @param params
     * @return
     */
    List<VmsVehicleFaultVo> getFaultTypeTrendByHour(@Param("startTime")LocalDateTime startTime,
                                                    @Param("endTime")LocalDateTime endTime,
                                                    @Param("startTimeStamp")Long startTimeStamp,
                                                    @Param("params")Map<String, Object> params);

    /**
     * 获取7天、一个月的故障类型趋势图
     * @param startTime
     * @param endTime
     * @param params
     * @return
     */
    List<VmsVehicleFaultVo> getFaultTypeTrendByDay(@Param("startTime")LocalDateTime startTime,
                                                   @Param("endTime")LocalDateTime endTime,
                                                   @Param("params")Map<String, Object> params);

    /**
     *获取24小时故障等级趋势图
     * @param startTime
     * @param endTime
     * @param startTimeStamp
     * @param params
     * @return
     */
    List<VmsVehicleFaultVo> getFaultLevelTrendByHour(@Param("startTime")LocalDateTime startTime,
                                                    @Param("endTime")LocalDateTime endTime,
                                                    @Param("startTimeStamp")Long startTimeStamp,
                                                    @Param("params")Map<String, Object> params);

    /**
     * 获取7天、一个月的故障等级趋势图
     * @param startTime
     * @param endTime
     * @param params
     * @return
     */
    List<VmsVehicleFaultVo> getFaultLevelTrendByDay(@Param("startTime")LocalDateTime startTime,
                                                   @Param("endTime")LocalDateTime endTime,
                                                   @Param("params")Map<String, Object> params);
}
