package com.ssi.mapper;

import com.google.common.base.Joiner;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.jdbc.SQL;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;

@Mapper
@Component
public interface VehicleVideoMapper {
    @Select(" select id,vin,number,url,url as flvUrl,direction from v2x_vehicle_history_video where vin =#{vin} order by show_position asc  ")
    List<Map<String, Object>> getHistoryVideoByVin(@Param("vin") String vin);

    @SelectProvider(type = SQLProvider.class, method = "getVideoListByVins")
    List<Map<String, Object>> getVideoListByVins(@Param("vins") List<String> vins);

    class SQLProvider {
        public String getVideoListByVins(@Param("vins") List<String> vins) {

            return new SQL() {
                {
                    SELECT("id, vin , number,url,direction,scenes_id scenesId").FROM("hac_camera_info");
                    WHERE(String.format("vin in ('%s')", Joiner.on("','").skipNulls().join(vins)));
                    ORDER_BY("show_position");
                }
            }.toString();
        }
    }
}
