package com.ssi.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.ssi.entity.VmsCarryCapacityAnalysis;
import com.ssi.entity.vo.OperateDataVo;
import com.ssi.entity.vo.TaskMileTrendByDayVo;
import com.ssi.entity.vo.UseInfoByVehicleVo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.time.LocalDateTime;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 *
 * @author hli
 * @email
 * @date 2020-12-28 10:24:34
 */
@Mapper
public interface VmsCarryCapacityAnalysisMapper extends BaseMapper<VmsCarryCapacityAnalysis> {

    double getVehicleEffectiveUseRate(@Param("vins")List<String> vins, @Param("startDate")Date startDate, @Param("endDate")Date endDate);

    Map getStopWaitTimeRate(@Param("startTime") Long startTime);

    List<TaskMileTrendByDayVo> getTaskMileTrendByDay(@Param("startTime") LocalDateTime startTime, @Param("endTime") LocalDateTime endTime);

    List<UseInfoByVehicleVo> getUseInfoByVehicle();

    OperateDataVo getOverallOperateData(@Param("vins")List<String> vins, @Param("startDate")Date startDate, @Param("endDate")Date endDate);

}
