package com.ssi.mapper;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.ssi.entity.VmsTosOrders;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.ssi.entity.dto.VmsTosOrdersDto;
import com.ssi.entity.vo.TaskAnalysisVo;
import com.ssi.entity.vo.TaskKPIVo;
import com.ssi.entity.vo.VehicleKpiVo;
import com.ssi.entity.vo.VehicleOrderVo;
import com.ssi.entity.vo.VmsTosOrdersKPIVo;
import com.ssi.entity.vo.VmsTosOrdersVo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.session.ResultHandler;
import org.springframework.stereotype.Component;

import java.time.LocalDateTime;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @author zhang liyao
 * @email
 * @date 2020-07-11 13:12:01
 */
@Mapper
@Component
public interface VmsTosOrdersMapper extends BaseMapper<VmsTosOrders> {

    void getListAsStream(@Param("vmsTosOrdersVo") VmsTosOrdersVo vmsTosOrdersVo, ResultHandler<VmsTosOrders> handler);

    List<TaskAnalysisVo> queryContainerNumByDay(@Param("startTime") LocalDateTime startTime, @Param("endTime") LocalDateTime endTime);

    TaskAnalysisVo queryContainerNum(@Param("vins")List<String> vins, @Param("startDate")Date startDate, @Param("endDate")Date endDate);

    List<TaskAnalysisVo> queryContainerAvgTimeByDay(@Param("startTime") LocalDateTime startTime, @Param("endTime") LocalDateTime endTime);

    /**
     * @param startTime 分析起始时间
     * @param endTime 分析结束时间
     * @return List<TaskAnalysisVo> 以天为单位任务分析结果list
     * @deprecated 使用中间表统计，此方法废弃
     * @see VmsTosOrdersAnalysisMapper#getTaskTrendByDay(LocalDateTime, LocalDateTime)
     */
    @Deprecated
    List<TaskAnalysisVo> getTaskTrendByDay(@Param("startTime") LocalDateTime startTime, @Param("endTime") LocalDateTime endTime);

    List<TaskAnalysisVo> getTaskTrendByHour(@Param("startTime") LocalDateTime startTime, @Param("endTime") LocalDateTime endTime,
                                            @Param("startTimeStamp") Long startTimeStamp);

    TaskAnalysisVo queryContainerAvgTime(@Param("vins")List<String> vins, @Param("startDate")Date startDate, @Param("endDate")Date endDate);

    List<VehicleOrderVo> getVehicleByPadMac(@Param("padMac") String padMac);

    List<VmsTosOrders> getVehicleTrip(@Param("vin") String vin,@Param("startTime") Date startDate,@Param("endTime") Date stopDate);

    List<VehicleKpiVo.HourKpi> getDailyKpi(@Param("startTime") LocalDateTime startTime, @Param("endTime") LocalDateTime endTime);

    List<Map<String, Object>> getContainNum(@Param("startTime") LocalDateTime startTime, @Param("endTime") LocalDateTime endTime);

    List<TaskAnalysisVo> getTaskNumTimeByDay(@Param("startTime") LocalDateTime startTime, @Param("endTime") LocalDateTime endTime,
                                             @Param("startTimeStamp") Long startTimeStamp);

    //任务KPI-效率OEE分析
	List<TaskKPIVo> taskKPI(@Param("vmsTosOrders") VmsTosOrdersKPIVo vmsTosOrders,@Param("nowStartTime") String nowStartTime,@Param("nowEndTime") String nowEndTime);

	//查询KPI页面中车辆的任务信息
    List<VmsTosOrdersDto> queryPageByAllStatus(@Param("ordersVo") VmsTosOrdersVo ordersVo);

    IPage<VmsTosOrders> pageQuery(IPage<VmsTosOrders> iPage,@Param("ordersVo") VmsTosOrdersVo ordersVo);

    TaskAnalysisVo queryOrderNum(@Param("vins")List<String> vin, @Param("startDate")Date startDate, @Param("endDate")Date endDate);

    Integer  queryOrderNumByDate(@Param("vins")List<String> vin, @Param("startDate")String startDate,@Param("totalType")Integer totalType, @Param("flag") Integer flag);

    Integer  queryTosOrderByDate(@Param("vins")List<String> vin, @Param("startDate")String startDate,@Param("totalType")Integer totalType, @Param("flag") Integer flag);

    Integer staticsAppCaveOrdersByDate(@Param("vins")List<String> vin, @Param("startDate")String startDate, @Param("totalType")Integer totalType, @Param("flag") Integer flag);

    Integer staticsContainerNumsByDate(@Param("vins")List<String> vin, @Param("startDate")String startDate, @Param("totalType")Integer totalType, @Param("flag") Integer flag);

    Integer queryOrdersByDate(@Param("vins")List<String> vin, @Param("startDate")String startDate, @Param("totalType")Integer totalType, @Param("flag") Integer flag);
}
