package com.ssi.model;

import com.alicp.jetcache.anno.CacheRefresh;
import com.alicp.jetcache.anno.Cached;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.ssi.entity.VmsVehicle;
import com.ssi.mapper.VehicleTboxMapper;
import com.ssi.mapper.VmsVehicleMapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;
import java.util.concurrent.TimeUnit;

/**
 * Description: jetcahe 一般配置在Model层或service接口层
 *
 * @author LiXiaoCong
 * @version 2019/8/20 14:00
 */
@Component
public class VehicleBaseInfoModel {


  @Autowired
  private VehicleTboxMapper vehicleTboxMapper;
  @Autowired
  private VmsVehicleMapper vehicleMapper;

  @Cached(name = "mlVehicleBaseInfoModel:getVehicleBaseInfo", expire = 120, timeUnit = TimeUnit.MINUTES)
  @CacheRefresh(refresh = 5, stopRefreshAfterLastAccess = 1440, timeUnit = TimeUnit.MINUTES)
  public Map<String, Object> getVehicleBaseInfo(@Param("vin") String vin) {
    return vehicleTboxMapper.getVehicleBaseInfo(vin);
  }

  //    @Cached(name = "mlVehicleBaseInfoModel:getAllVehicleInfo", expire = 120, timeUnit = TimeUnit.MINUTES)
//    @CacheRefresh(refresh = 5, stopRefreshAfterLastAccess = 1440, timeUnit = TimeUnit.MINUTES)
  public List<VmsVehicle> getAllVehicleInfo() {
    List<VmsVehicle> list = vehicleMapper.selectList(null);
    return list;
  }

}
