package com.ssi.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.ssi.entity.VmsVehicleAlertHistory;
import com.ssi.entity.vo.VmsTosOrdersVo;
import com.ssi.response.SSIPage;
import com.ssi.response.SSIResponse;

import java.util.Map;

import javax.servlet.http.HttpServletResponse;

/**
 * @author zhang liyao
 * @email
 * @date 2020-07-17 09:47:00
 */
public interface VehicleTroubleService extends IService<VmsVehicleAlertHistory> {

    /**
     * 故障列表查询
     * @param params
     * @return
     */
    SSIPage queryPage(Map<String, Object> params);

    /**
     * 故障趋势图
     * @return
     */
    SSIResponse getFaultTrend(Map<String, Object> params) throws Exception;

    /**
     * 故障分布图
     * @return
     */
    SSIResponse getFaultDistribution(Map<String, Object> params) throws Exception;

    /**
     * 故障类型分布图
     * @return
     */
    SSIResponse getFaultTypeTrend(Map<String, Object> params) throws Exception;

    /**
     * 故障等级分布图
     * @return
     */
    SSIResponse getFaultLevelTrend(Map<String, Object> params) throws Exception;
    
    void export(Map<String, Object> params, HttpServletResponse response) ;
}

