package com.ssi.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.ssi.entity.VmsTosOrders;
import com.ssi.entity.vo.TaskKPIVo;
import com.ssi.entity.vo.VmsTosOrdersKPIVo;
import com.ssi.entity.vo.VmsTosOrdersVo;
import com.ssi.response.SSIPage;
import com.ssi.response.SSIResponse;

import javax.servlet.http.HttpServletResponse;

import java.text.ParseException;
import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;


/**
 * @author zhang liyao
 * @email
 * @date 2020-07-11 13:12:01
 */
public interface VmsTosOrdersService extends IService<VmsTosOrders> {

    Map<String, VmsTosOrders> getAllVehicleLatestWork();

    Map<String, Object> getOrdersByVin(String vin);

    SSIResponse getVehicleTrip(String vin, Long startTime, Long endTime, String troubleTypeId);

    SSIResponse getMileTimeByTime(String vin, Long startTime, Long stopTime);

    SSIPage queryPage(VmsTosOrdersVo vmsTosOrdersVo);

    SSIPage queryPageByAllStatus(VmsTosOrdersVo vmsTosOrdersVo);

    void export(VmsTosOrdersVo vmsTosOrdersVo, HttpServletResponse response);

    SSIResponse getTripByAlert(String vin, String alertId);

    SSIResponse queryContainerNumOneDay(LocalDateTime startTime, LocalDateTime endTime);

    SSIResponse queryContainerNum();

    SSIResponse queryContainerNumByDay(LocalDateTime startTime, LocalDateTime endTime) throws Exception;

    SSIResponse queryContainerAvgTimeOneDay(LocalDateTime startTime, LocalDateTime endTime);

    SSIResponse queryContainerAvgTime();

    SSIResponse getNumByVin(String vin);

    SSIResponse getVehicleByPadMac(String padMac, String taskNo);

    SSIResponse getTaskHistory(String taskNo);

    SSIPage listInProcess(VmsTosOrdersVo vmsTosOrdersVo);

    SSIPage realTimeTasks(VmsTosOrdersVo vmsTosOrdersVo);

    List getDailyKpi(LocalDateTime startTime, LocalDateTime endTime,String vehicleNum);
    
   	//任务KPI-效率OEE分析
    List taskKPI(VmsTosOrdersKPIVo vmsTosOrders) throws Exception;

    SSIResponse forceCancel(String taskNo);
}

