package com.ssi.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.ssi.entity.VmsVehicle;
import com.ssi.entity.vo.VehicleControlStatusVo;
import com.ssi.entity.vo.VehicleStatusVo;
import com.ssi.response.SSIPage;
import com.ssi.response.SSIResponse;

import java.util.List;
import java.util.Map;

/**
 * 车辆表
 *
 * @author zhang liyao
 * @email
 * @date 2020-07-08 15:38:37
 */
public interface VmsVehicleService extends IService<VmsVehicle> {

    SSIPage queryPage(Map<String, Object> params);

    List<VmsVehicle> getNormalVehicle();

    List<VmsVehicle> getNormalVehicleByVehicleNum(String vehicleNum,Integer vehicleType);

    List<VmsVehicle> listAndCache();

    SSIResponse listForMonitor(List<VmsVehicle> vehicleList);

    SSIResponse vehicleStatusForMonitor(List<VmsVehicle> vehicleList);

    VehicleStatusVo vehicleStatusDist(List<VmsVehicle> vehicleList);

    SSIResponse saveVehicle(VmsVehicle vehicle);

    SSIResponse transportCapacity();

    List<VehicleControlStatusVo> getVehicleByLocation(String location, Integer distance);

    Map getVmsCranePosMapInfo(String name);
    List<Map>getVmsVehicle();
}

