package com.ssi.service.impl;

import cn.afterturn.easypoi.handler.impl.ExcelDataHandlerDefaultImpl;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ssi.entity.vo.VehicleCommandVo;
import com.ssi.mapper.VehicleCommandMapper;
import com.ssi.model.VehicleElasticSearchModel;
import com.ssi.service.VehicleCommandService;
import com.ssi.utils.PoiUtils;
import org.apache.commons.lang3.StringUtils;
import org.elasticsearch.client.transport.TransportClient;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 无人集卡作业明细
 * @author yinjiangqiao
 * @version 1.0
 * @date 2022/7/4 9:51
 */
@Service("VehicleCommandService")
@DS("oracle")
public class VehicleCommandServiceImpl implements VehicleCommandService {


    @Autowired
    private VehicleCommandMapper vehicleCommandMapper;
    @Autowired
    protected TransportClient transportClient;

    @Autowired
    private VehicleElasticSearchModel vehicleElasticSearchModel;

    @Override
    public IPage<VehicleCommandVo> vehicleTypeCommandList(String queryStartTime,String queryEndTime,String truckNo,Integer pageNum,Integer pageSize) {
        Map  params =  new HashMap();
        params.put("queryStartTime", queryStartTime);
        params.put("queryEndTime", queryEndTime);
        params.put("truckNo", truckNo);
        IPage<VehicleCommandVo> page = new Page<>(pageNum, pageSize);
        page = vehicleCommandMapper.vehicleTypeCommandList(page,params);
//        List<VehicleCommandVo>  list  = new ArrayList<>();
//        VehicleCommandVo  vehicleCommandVo  = new VehicleCommandVo();
//        vehicleCommandVo.setArriveTime("");
//        vehicleCommandVo.setCntr("NAKU5187743");
//        vehicleCommandVo.setCntrSizCod("40");
//        vehicleCommandVo.setCyWorkTime("");
//        vehicleCommandVo.setQueueType("卸船");
//        vehicleCommandVo.setShipName("A ASO");
//        vehicleCommandVo.setShipNo("42707");
//        vehicleCommandVo.setShipWorkTime("2022-07-13 10:55:02");
//        vehicleCommandVo.setTruckNo("911");
//        vehicleCommandVo.setVoyage("voyage");
//        vehicleCommandVo.setTaskNo("AE221706DE843714E0540017A4771C09");
//        list.add(vehicleCommandVo);
//        page.setRecords(list);
//        String year = DateUtils.format(new Date(), "yyyy");
//        page.getRecords().stream().forEach(vehicleCommand -> {
//            String taskNo = vehicleCommand.getTaskNo();
//            List<TaskStatusHistory> lists = vehicleElasticSearchModel.searchTaskHistory(taskNo, year);
//            if(lists.size()==0){
//                return;
//            }
//            for(TaskStatusHistory askStatusHistory:lists){
//                if(askStatusHistory.getStatus()==42){
//                    vehicleCommand.setTosTime(DateUtils.format(new Date(askStatusHistory.getCollectTime()), "yyyy-MM-dd yyyy-MM-dd HH:mm:ss"));
//                }
//            }
//                });
        return page;
    }

    @Override
    public List<VehicleCommandVo> exportCommandList(String queryStartTime, String queryEndTime, String truckNo, Integer pageNum, Integer pageSize) {
        Map  params =  new HashMap();
        params.put("queryStartTime", queryStartTime);
        params.put("queryEndTime", queryEndTime);
        params.put("truckNo", truckNo);
        params.put("pageSize",pageSize);
        params.put("pageNum",pageNum);
        return  vehicleCommandMapper.exportCommandList(params);
    }

    @Override
    public void export(String queryStartTime, String queryEndTime, String truckNo, Integer pageIndex, Integer pageSize, String exportType, HttpServletResponse response) {
        if(StringUtils.equals(exportType,"1")){
            pageSize = 100000;
        }
        List<VehicleCommandVo>  list =  exportCommandList(queryStartTime,queryEndTime,truckNo,pageIndex,pageSize);
        ExcelDataHandlerDefaultImpl<Object> excelDataHandler = new ExcelDataHandlerDefaultImpl<Object>() {
            @Override
            public String[] getNeedHandlerFields() {
                return new String[]{"航次","车号","船号","作业类型","尺码","箱位置","箱号","收到TOS指令时间","单车到桥下时间","桥边确认","堆场确认","作业时长"};
            }
            @Override
            public Object exportHandler(Object obj, String name, Object value) {
                if ("航次".equals(name)) {
                    VehicleCommandVo order = (VehicleCommandVo) obj;
                    return order.getVoyage();
                }
                if ("车号".equals(name)) {
                    VehicleCommandVo order = (VehicleCommandVo) obj;
                    return order.getTruckNo();
                }
                if ("船号".equals(name)) {
                    VehicleCommandVo order = (VehicleCommandVo) obj;
                    return order.getShipNo();
                }
                if ("作业类型".equals(name)) {
                    VehicleCommandVo order = (VehicleCommandVo) obj;
                    return order.getQueueType();
                }
                if ("尺码".equals(name)) {
                    VehicleCommandVo order = (VehicleCommandVo) obj;
                    return order.getCntrSizCod();
                }
                if ("箱位置".equals(name)) {
                    VehicleCommandVo order = (VehicleCommandVo) obj;
                    return order.getTruckPosition();
                }
                if ("箱号".equals(name)) {
                    VehicleCommandVo order = (VehicleCommandVo) obj;
                    return order.getCntr();
                }
                if ("收到TOS指令时间".equals(name)) {
                    VehicleCommandVo order = (VehicleCommandVo) obj;
                    return order.getTosTime();
                }
                if ("单车到桥下时间".equals(name)) {
                    VehicleCommandVo order = (VehicleCommandVo) obj;
                    return order.getArriveTime();
                }
                if ("桥边确认".equals(name)) {
                    VehicleCommandVo order = (VehicleCommandVo) obj;
                    return order.getShipWorkTime();
                }
                if ("堆场确认".equals(name)) {
                    VehicleCommandVo order = (VehicleCommandVo) obj;
                    return order.getCyWorkTime();
                }
                if ("作业时长".equals(name)) {
                    VehicleCommandVo order = (VehicleCommandVo) obj;
                    return order.getTime();
                }
                return super.exportHandler(obj, name, value);
            }

        };
        PoiUtils.exportExcel(excelDataHandler, list, "无人集卡明细清单", "无人集卡明细清单", VehicleCommandVo.class, "无人集卡明细清单" + ".xls", true, response);

    }


}
