package com.ssi.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ssi.entity.VmsVehicleEmergencyStop;
import com.ssi.entity.VmsVehicleRemoteInstruction;
import com.ssi.entity.vo.VmsVehicleEmergencyVo;
import com.ssi.entity.vo.VmsVehicleRemoteInstructionVo;
import com.ssi.mapper.VehicleEmergencyMapper;
import com.ssi.mapper.VehicleRemoteInstructionMapper;
import com.ssi.mapper.VmsVehicleMapper;
import com.ssi.model.RedisDataModel;
import com.ssi.response.AccessResponse;
import com.ssi.response.SSIPage;
import com.ssi.response.SSIResponse;
import com.ssi.service.VehicleEmergencyService;
import com.ssi.service.VehicleRemoteInstructionService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * 故障历史服务实现类
 */
@Service("VehicleRemoteInstructionService")
@Slf4j
public class VehicleRemoteInstructionServiceImpl extends ServiceImpl<VehicleRemoteInstructionMapper, VmsVehicleRemoteInstruction> implements VehicleRemoteInstructionService {

    /**
     * 故障列表分页
     */
    @Override
    public SSIPage queryPage(Map<String, Object> params) {

        Integer pageSize = params.get("pageSize") == null ? 0 : (Integer) params.get("pageSize");
        Integer pageIndex = params.get("pageIndex") == null ? 10 : (Integer) params.get("pageIndex");
        Long startTime = (Long) params.get("startTime");
        Long stopTime = (Long) params.get("stopTime");
        Date startDate = startTime == null ? null : new Date(startTime);
        Date stopDate = stopTime == null ? null : new Date(stopTime);
        params.put("startTime",startDate);
        params.put("stopTime",stopDate);

        IPage<VmsVehicleRemoteInstructionVo> page = new Page<>(pageIndex, pageSize);
        page = this.getBaseMapper().getRemoteInstructionList(page,params);
        return new SSIPage(page);
    }

}
