package com.ssi.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.conditions.query.QueryChainWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ssi.entity.VmsAreaBusinessInfo;
import com.ssi.entity.map.MapDataDto;
import com.ssi.service.VmsAreaBusinessInfoService;
import com.ssi.mapper.VmsAreaBusinessInfoMapper;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.RequestBody;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;
import java.util.stream.Collectors;

/**
*
*/
@Service
public class VmsAreaBusinessInfoServiceImpl extends ServiceImpl<VmsAreaBusinessInfoMapper, VmsAreaBusinessInfo>
implements VmsAreaBusinessInfoService{

    @Override
    public List<String> getByCrane(String portCode,Integer taskType,List<Integer> taskTypes) {
        return this.baseMapper.getByCrane(portCode,taskType,taskTypes);
    }


    @Override
    @Transactional
    public void updatePassArea(@RequestBody MapDataDto mapdata) {


        VmsAreaBusinessInfo deleteEntity = new VmsAreaBusinessInfo();
        deleteEntity.setAreaId(mapdata.getId());
        deleteEntity.setTaskType(mapdata.getTaskType());
        this.baseMapper.delete(new QueryWrapper<>(deleteEntity));
        if(StringUtils.isBlank(mapdata.getBridge())){
            return;
        }
        String[] split = mapdata.getBridge().split(",");
        for (int i = 0; i < split.length; i++) {
            this.baseMapper.deleteByCrane(split[i],mapdata.getTaskType());
            VmsAreaBusinessInfo saveEntity = new VmsAreaBusinessInfo();
            saveEntity.setAreaId(mapdata.getId());
            saveEntity.setPlacetype(mapdata.getPlacetype());
            saveEntity.setAreaNo(mapdata.getNumber());
            saveEntity.setAreaType(mapdata.getType());
            saveEntity.setTaskType(mapdata.getTaskType());
            saveEntity.setBridge(split[i]);
            this.save(saveEntity);
        }
    }
}
