package com.ssi.service.impl;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ssi.entity.VmsChargingEquipmentInfo;
import com.ssi.mapper.VmsChargingEquipmentInfoMapper;
import com.ssi.service.VmsChargingEquipmentInfoService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
*
*/
@Service
public class VmsChargingEquipmentInfoServiceImpl extends ServiceImpl<VmsChargingEquipmentInfoMapper, VmsChargingEquipmentInfo>
implements VmsChargingEquipmentInfoService{

    @Override
    public Runnable saveEquipmentInfo(JSONObject data) {
        return ()->{
            try {
                JSONArray stationInfos = data.getJSONArray("StationInfos");
                for (int i = 0; i < stationInfos.size(); i++) {
                    JSONObject stationInfo = stationInfos.getJSONObject(i);
                    JSONArray equipmentInfos = stationInfo.getJSONArray("EquipmentInfos");
                    for (int j = 0; j < equipmentInfos.size(); j++) {
                        VmsChargingEquipmentInfo equipmentInfo = equipmentInfos.getObject(j, VmsChargingEquipmentInfo.class);
                        equipmentInfo.setStationId(stationInfo.getString("StationID"));
                        this.saveOrUpdate(equipmentInfo);
                    }
                }
            }catch (Exception e){
                log.error("saveEquipmentInfo occur error:",e);
            }
        };
    }

    @Override
    public List<VmsChargingEquipmentInfo> qryFreeEquipment(int i) {
        return this.baseMapper.qryFreeEquipment(i);
    }
}
