package com.ssi.service.impl;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ssi.entity.VmsChargingStation;
import com.ssi.service.VmsChargingStationService;
import com.ssi.mapper.VmsChargingStationMapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.Date;

/**
*
*/
@Service
@Slf4j
public class VmsChargingStationServiceImpl extends ServiceImpl<VmsChargingStationMapper, VmsChargingStation>
implements VmsChargingStationService{

    @Override
    public Runnable saveStationInfo(JSONObject data) {
        return ()->{
            try {
                JSONArray stationInfos = data.getJSONArray("StationInfos");
                for (int i = 0; i < stationInfos.size(); i++) {
                    VmsChargingStation vmsChargingStation = stationInfos.getObject(i, VmsChargingStation.class);
                    vmsChargingStation.setUpdateTime(new Date());
                    this.saveOrUpdate(vmsChargingStation);
                }
            }catch (Exception e){
                log.error("saveStationInfo occur error:",e);
            }
        };
    }
}
