package com.ssi.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.ssi.response.SSIPage;
import com.ssi.utils.QueryUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import java.util.Map;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import com.ssi.mapper.VmsDeviceVersionMapper;
import com.ssi.entity.VmsDeviceVersion;
import com.ssi.service.VmsDeviceVersionService;

/**
 * 终端版本服务实现类
 */
@Service("deviceVersionService")
public class VmsDeviceVersionServiceImpl extends ServiceImpl<VmsDeviceVersionMapper, VmsDeviceVersion> implements VmsDeviceVersionService {

    @Override
    public SSIPage queryPage(Map<String, Object> params) {
        String deviceName = (String) params.get("deviceName");
        IPage<VmsDeviceVersion> page = this.page(
                new QueryUtils<VmsDeviceVersion>().getPage(params),
                new LambdaQueryWrapper<VmsDeviceVersion>()
                        .like(StringUtils.isNotBlank(deviceName), VmsDeviceVersion::getDeviceName, deviceName)
                        .orderByDesc(VmsDeviceVersion::getPublishTime)
        );

        return new SSIPage(page);
    }

}
