package com.ssi.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ssi.entity.VmsIndividuationConfig;
import com.ssi.entity.VmsTerminalVersion;
import com.ssi.response.SSIPage;
import com.ssi.service.VmsIndividuationConfigService;
import com.ssi.mapper.VmsIndividuationConfigMapper;
import com.ssi.utils.QueryUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
*
*/
@Service
public class VmsIndividuationConfigServiceImpl extends ServiceImpl<VmsIndividuationConfigMapper, VmsIndividuationConfig>
implements VmsIndividuationConfigService{

    @Override
    public SSIPage queryPage(VmsIndividuationConfig params) {

        IPage<VmsIndividuationConfig> page = this.page(
                new Page<>(params.getPageIndex(),params.getPageSize()),
                new LambdaQueryWrapper<VmsIndividuationConfig>()
                        .like(StringUtils.isNotBlank(params.getConfigKey()),VmsIndividuationConfig::getConfigKey,params.getConfigKey())
                        .eq(VmsIndividuationConfig::getStatus,1)
                        .orderByDesc(VmsIndividuationConfig::getCreateTime)
        );
        return new SSIPage(page);
    }

    @Override
    public List<VmsIndividuationConfig> listByParent(String name) {
       return  this.baseMapper.listByParent(name);
    }


}
