package com.ssi.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.ssi.mapper.VmsTerminalVersionMapper;
import com.ssi.response.SSIPage;
import com.ssi.utils.QueryUtils;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.Map;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import com.ssi.entity.VmsTerminalVersion;
import com.ssi.service.VmsTerminalVersionService;

/**
 * 终端版本服务实现类
 */
@Service("terminalVersionService")
public class VmsTerminalVersionServiceImpl extends ServiceImpl<VmsTerminalVersionMapper, VmsTerminalVersion> implements VmsTerminalVersionService {

    @Override
    public SSIPage queryPage(Map<String, Object> params) {
        Integer publishStatus = (Integer) params.get("publishStatus");
        IPage<VmsTerminalVersion> page = this.page(
                new QueryUtils<VmsTerminalVersion>().getPage(params),
                new LambdaQueryWrapper<VmsTerminalVersion>()
                        .lt(publishStatus != null && publishStatus == 0, VmsTerminalVersion::getPublishTime, new Date())
                        .ge(publishStatus != null && publishStatus == 1, VmsTerminalVersion::getPublishTime, new Date())
                        .orderByDesc(VmsTerminalVersion::getPublishTime)
        );

        return new SSIPage(page);
    }

}
