package com.ssi.service.platform.impl;


import com.ssi.model.RedisConfigModel;
import com.ssi.service.platform.RedisConfigService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Map;
import java.util.Set;

/**
 * Description:
 *
 * @author LiXiaoCong
 * @version 2019/10/17 10:24
 */
@Service
@Slf4j
public class RedisConfigServiceImpl implements RedisConfigService {

    @Autowired
    private RedisConfigModel redisConfigModel;

    @Override
    public void setConfig(String group, String key, String value) {
        if (group != null) {
            redisConfigModel.setConfig(group, key, value);
        } else {
            redisConfigModel.setConfig(key, value);
        }
    }

    @Override
    public String getConfigWithDefault(String group, String key, String defaultValue) {
        if (group != null) {
            return redisConfigModel.getConfigWithDefault(group, key, defaultValue);
        } else {
            return redisConfigModel.getConfigWithDefault(key, defaultValue);
        }
    }

    @Override
    public String getConfig(String group, String key) {
        if (group != null) {
            return redisConfigModel.getConfig(group, key);
        } else {
            return redisConfigModel.getConfig(key);
        }
    }

    @Override
    public Map<String, String> getConfigs(String group, Set<String> keys) {
        if (group != null) {
            return redisConfigModel.getConfigs(group, keys);
        } else {
            return redisConfigModel.getConfigs(keys);
        }
    }

    @Override
    public void deteles(String group, String... keys) {
        if (group != null) {
            redisConfigModel.deteles(group, keys);
        } else {
            redisConfigModel.deteles(keys);
        }
    }
}
