package com.ssi.service.platform.impl;

import com.google.common.collect.Sets;
import com.ssi.entity.ScrollTrackLocationEntity;
import com.ssi.model.VehicleElasticSearchModel;
import com.ssi.response.SSIResponse;
import com.ssi.service.platform.VehicleTrackService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.util.Set;

/**
 * Description:
 *
 * @author LiXiaoCong
 * @version 2020/2/8 12:56
 */
@Service
@Slf4j
public class VehicleTrackServiceImpl implements VehicleTrackService {

    @Value("${analysis.vehicle-data.es-index-name:vms_igv_vehicle}")
    private String dataIndex;

    @Value("${analysis.vehicle-data.index-rule:year}")
    private String indexRule;

    @Value("${data.esIndex.timeField:receiveTime}")
    private String timeField;


    @Autowired
    private VehicleElasticSearchModel vehicleElasticSearchModel;
//    @Autowired
//    private VehicleElasticRestSearchModel vehicleElasticRestSearchModel;

    @Override
    public SSIResponse scrollTrack(ScrollTrackLocationEntity scrollTrackLocationEntity) {
//        Map<String, Object> map = vehicleElasticRestSearchModel.searchScrollTrackLocations(dataIndex, indexRule, timeField, scrollTrackLocationEntity);

        return vehicleElasticSearchModel.searchScrollTrackLocations(dataIndex, indexRule, timeField, scrollTrackLocationEntity);
    }

    @Override
    public SSIResponse smallTrack(String vin,
                                          Long startTime,
                                          Long stopTime,
                                          String posType) {
//        Map<String, Object> map =  vehicleElasticRestSearchModel.searchAllTrackLocations(vin,
//                dataIndex,
//                indexRule,
//                null,
//                timeField,
//                startTime,
//                stopTime,
//                posType);
        Set<String> columns = Sets.newHashSet("vin", "speed",
                "gear","location","longitude", "latitude","collectTime"
                ,"brakePedalOpen","gear","brakeStatus");
        return vehicleElasticSearchModel.searchAllTrackLocations(vin,
                dataIndex,
                indexRule,
                columns,
                timeField,
                startTime,
                stopTime,
                posType);
    }
}
