package com.ssi.service.platform.impl;


import com.ssi.model.WebSocketDataServiceModel;
import com.ssi.service.platform.WebSocketDataService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Map;

/**
 * Description:
 * 从redis中获取所有车辆数据
 *
 * @author LiXiaoCong
 * @version 2019/9/20 11:47
 */
@Service
@Slf4j
public class WebSocketDataServiceImpl implements WebSocketDataService {

    @Autowired
    private WebSocketDataServiceModel webSocketDataServiceModel;

    @Override
    public Map<String, Map<String, Object>> realTimeDataAll() {
        return webSocketDataServiceModel.realTimeDataAll(true);
    }

    @Override
    public Map<String, Map<String, Object>> getVehicleRunData() {
        return webSocketDataServiceModel.getVehicleRunData();
    }

}
