package com.ssi.task;

import com.ssi.service.VmsTosOrderDailyKpiService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.time.LocalDateTime;

/**
 * @description: Order Daily Kpi 定时任务
 * @author: dt
 * @create: 2022-10-31 16:40
 */
@Component
@EnableScheduling
public class VmsTosOrderDailyKpiTask {

    private final Logger logger = LoggerFactory.getLogger(VmsTosOrderDailyKpiTask.class);

    private VmsTosOrderDailyKpiService vmsTosOrderDailyKpiService;

    public VmsTosOrderDailyKpiTask(VmsTosOrderDailyKpiService vmsTosOrderDailyKpiService) {
        this.vmsTosOrderDailyKpiService = vmsTosOrderDailyKpiService;
    }

    /**
     * 定期每隔多长时间执行任务
     */
    @Scheduled(fixedDelay = 1000*60*10)
    public void analysisTosOrderDailyKpi() {
        logger.info("------ 执行 kpi 分析任务开始，时间: "+ LocalDateTime.now().toString()+" ------");
        vmsTosOrderDailyKpiService.analysisTosOrderDailyKpi(null);
        logger.info("------ 执行 kpi 分析任务结束，时间: "+ LocalDateTime.now().toString()+" ------");
    }

}