package com.ssi.utils;

import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Arrays;
import javax.crypto.Cipher;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import org.apache.commons.codec.binary.Base64;


/**
 * @author SunnyHotz
 * @PackageName:com.ssi.task
 * @ClassName:Test
 * @Description:
 * @date 2022/7/18 18:17
 */
public class AESUtil {

    private static SecretKeySpec secretKey;
    private static IvParameterSpec initVectorKey;
    private static byte[] key ;
    
    private static String decryptedString;
    private static String encryptedString;

    public static void setKey(String myKey,String ivKey){

        MessageDigest sha = null;
        try {
            key = myKey.getBytes("UTF-8");
            sha = MessageDigest.getInstance("SHA-1");
            key = sha.digest(key);
            key = Arrays.copyOf(key, 16); // use only first 128 bit
            secretKey = new SecretKeySpec(key, "AES");
            
            byte[] ivKeyBytes = ivKey.getBytes("UTF-8");
            ivKeyBytes = Arrays.copyOf(ivKeyBytes, 16);
            initVectorKey = new IvParameterSpec(ivKeyBytes);
        } catch (NoSuchAlgorithmException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (UnsupportedEncodingException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }

    }

    public static String getDecryptedString() {
        return decryptedString;
    }

    public static void setDecryptedString(String decryptedString) {
        AESUtil.decryptedString = decryptedString;
    }

    public static String getEncryptedString() {
        return encryptedString;
    }

    public static void setEncryptedString(String encryptedString) {
        AESUtil.encryptedString = encryptedString;
    }

    public static String encrypt(String strToEncrypt)
    {
        try
        {
            Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
            cipher.init(Cipher.ENCRYPT_MODE, secretKey,initVectorKey);
            setEncryptedString(Base64.encodeBase64String(cipher.doFinal(strToEncrypt.getBytes("UTF-8"))));

        }
        catch (Exception e)
        {
            System.out.println("Error while encrypting: "+e.toString());
        }
        return encryptedString;
    }
    public static String decrypt(String strToDecrypt)
    {
        try
        {
            Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5PADDING");
            cipher.init(Cipher.DECRYPT_MODE, secretKey,initVectorKey);
            setDecryptedString(new String(cipher.doFinal(Base64.decodeBase64(strToDecrypt))));

        }
        catch (Exception e)
        {

            System.out.println("Error while decrypting: "+e.toString());
        }
        return decryptedString;
    }

    public static void main(String args[])
    {
        final String strToEncrypt = "{\"OperatorID\":\"123456789\",\"OperatorSecret\":\"1234567890abcdef\"}";
        final String strPssword = "1234567890abcdef";
        AESUtil.setKey(strPssword,strPssword);

        AESUtil.encrypt(strToEncrypt.trim());

        System.out.println("String to Encrypt: " + strToEncrypt);
        System.out.println("Encrypted: " + AESUtil.getEncryptedString());
        final String strToDecrypt =  AESUtil.getEncryptedString();
        AESUtil.decrypt(strToDecrypt);

        System.out.println("String To Decrypt : " + strToDecrypt);
        System.out.println("Decrypted : " + AESUtil.getDecryptedString());

    }

}
