package com.ssi.utils;

import com.alibaba.fastjson.JSONObject;
import com.ssi.constant.VehicleConstant;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

/**
 * @author ZhangLiYao
 * @version 1.0
 * @date 2020/3/4 10:52
 */
public class AuthorizationUtils {

  /**
   * 获取请求的token
   */
  public static String getRequestToken() {
    ServletRequestAttributes attributes = (ServletRequestAttributes) RequestContextHolder.getRequestAttributes();
    HttpServletRequest request = attributes.getRequest();
    //从header中获取token
    String token = request.getHeader("Authorization");

    //如果header中不存在token，则从参数中获取token
    if (org.apache.commons.lang.StringUtils.isBlank(token)) {
      token = request.getParameter("Authorization");
    }

    return token;
  }

  /**
   * 获取当前用户
   */
  public static JSONObject getCurUser() {
    ServletRequestAttributes attributes = (ServletRequestAttributes) RequestContextHolder.getRequestAttributes();
    HttpServletRequest request = attributes.getRequest();
    HttpSession httpSession = request.getSession();
    JSONObject jsonObject = (JSONObject) httpSession.getAttribute(VehicleConstant.LOGIN_USER_KEY);
    return jsonObject;
  }


}
