package com.ssi.utils;

import com.alibaba.fastjson.JSONObject;
import com.ssi.constant.enums.Status;
import org.apache.shiro.authz.UnauthenticatedException;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

/**
 * @author ZhangLiYao
 * @version 1.0
 * @date 2020/3/3 9:44
 */
@Service
public class DataPermissionUtils {

  @Value("${login-check-url}")
  private String loginCheckUrl;
  @Value("${data-permission-check-url}")
  private String dataPermissionCheckUrl;

  public String getRoleDataPermission() {
    String result = RestTemplateUtil.get(dataPermissionCheckUrl,
        AuthorizationUtils.getRequestToken());
    JSONObject resultObj = JSONObject.parseObject(result);
    String applySql = null;
    if ((int) resultObj.get("code") == Status.SUCCESS.getCode()) {
      applySql = resultObj.getJSONObject("data").getString("applySql");
    } else if ((int) resultObj.get("code") == Status.ERROR.getCode()) {
      applySql = " create_user_id = " + resultObj.get("userId");
    } else {
      throw new UnauthenticatedException();
    }
    return applySql;
  }

  public JSONObject getRoleDataPermissionOriginal() {
    String result = RestTemplateUtil.get(dataPermissionCheckUrl,
        AuthorizationUtils.getRequestToken());
    JSONObject resultObj = JSONObject.parseObject(result);
    if ((int) resultObj.get("code") == Status.UNAUTHORIZED.getCode()) {
      throw new UnauthenticatedException();
    }
    return resultObj;
  }
}
