package com.ssi.utils;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.TypeReference;
import com.alibaba.fastjson.parser.Feature;
import lombok.extern.slf4j.Slf4j;

import java.util.Map;

@Slf4j
public class JsonUtil {

  public static Map<String, Object> jsonToMap(String json) {
    int disableDecimalFeature = JSON.DEFAULT_PARSER_FEATURE & ~Feature.UseBigDecimal.getMask();
    Map<String, Object> record = null;
    try {
      record = JSON.parseObject(json,
          new TypeReference<Map<String, Object>>() {
          }.getType(), disableDecimalFeature, Feature.OrderedField);
    } catch (Exception e) {
      log.error("json数据转换失败：%s\n %s", e.getMessage(), json);
    }
    return record;
  }
}
