package com.ssi.utils;

import java.util.ArrayList;
import java.util.List;

/**
 * 自定义List分页工具
 *
 * @author ZhangLiYao
 * @version 1.0
 * @date 2020/5/12 10:29
 */
public class PageUtil {

  /**
   * 开始分页
   *
   * @param pageNum 页码
   * @param pageSize 每页多少条数据
   */
  public static List startPage(List list, Integer pageNum,
      Integer pageSize) {
    if (list == null) {
      return null;
    }
    if (list.size() == 0) {
      return null;
    }

    Integer count = list.size(); // 记录总数
    Integer pageCount = 0; // 页数
    if (count % pageSize == 0) {
      pageCount = count / pageSize;
    } else {
      pageCount = count / pageSize + 1;
    }

    int fromIndex = 0; // 开始索引
    int toIndex = 0; // 结束索引

    if (pageNum != pageCount) {
      fromIndex = (pageNum - 1) * pageSize;
      toIndex = fromIndex + pageSize;
    } else {
      fromIndex = (pageNum - 1) * pageSize;
      toIndex = count;
    }

    if (fromIndex >= count) {
      return new ArrayList();
    }
    List pageList = list.subList(fromIndex, toIndex);

    return pageList;
  }
}
