package com.ssi.utils;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.metadata.OrderItem;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.commons.lang3.StringUtils;

import java.util.Map;

/**
 * 查询参数
 */
public class QueryUtils<T> {

  public IPage<T> getPage(Map<String, Object> params) {
    return this.getPage(params, null, false);
  }

  public IPage<T> getPage(Map<String, Object> params, String defaultOrderField, boolean isAsc) {
    //分页参数
    int curPage = 1;
    int limit = 10;

    if (params.get("pageIndex") != null) {
      curPage = (int) params.get("pageIndex");
    }
    if (params.get("pageSize") != null) {
      limit = (int) params.get("pageSize");
    }

    //分页对象
    Page<T> page = new Page<>(curPage, limit);

    //分页参数
    params.put("page", page);

    //排序字段

    String order = (String) params.get("order");

    //没有排序字段，则不排序
    if (StringUtils.isBlank(defaultOrderField)) {
      return page;
    }

    //默认排序
    if (isAsc) {
      page.addOrder(OrderItem.asc(defaultOrderField));
    } else {
      page.addOrder(OrderItem.desc(defaultOrderField));
    }

    return page;
  }

}
