package com.ssi.utils;

import org.apache.commons.collections.MapUtils;
import org.apache.commons.lang3.tuple.MutableTriple;
import org.apache.commons.lang3.tuple.Triple;
import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

@Component
public class SpringUtils implements ApplicationContextAware {

  private static ApplicationContext applicationContext;

  private static Map<String,Map<String,Object>> localCache = new ConcurrentHashMap<>();

  @Override
  public void setApplicationContext(ApplicationContext applicationContextParam)
      throws BeansException {
    applicationContext = applicationContextParam;
  }

  public static Object getObject(String id) {
    Object object = null;
    object = applicationContext.getBean(id);
    return object;
  }

  public static <T> T getObject(Class<T> tClass) {
    return applicationContext.getBean(tClass);
  }

  public static Object getBean(String tClass) {
    return applicationContext.getBean(tClass);
  }

  public static void setLocalCache(String topic,String key, Object value) {
    Map<String, Object> valMap = localCache.get(topic);
    synchronized (SpringUtils.class){
      if(MapUtils.isNotEmpty(valMap)){
        valMap.put(key,value);
      }else {
        localCache.put(topic,new HashMap<String,Object>(){{put(key,value);}});
      }
    }

  }

  public static Object getValue(String topic,String key){
    Map<String, Object> valMap = localCache.get(topic);
    if(MapUtils.isNotEmpty(valMap)){
        return valMap.get(key);
    }
    return null;
  }

  public static void clearStatus(String topic,String key){
    Map<String, Object> valMap = localCache.get(topic);
    if(MapUtils.isNotEmpty(valMap)){
       valMap.remove(key);
    }
  }
}
