package com.ssi.utils;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Reader;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.UUID;
import java.util.Vector;

import org.apache.commons.lang.StringUtils;
import org.springframework.kafka.core.KafkaTemplate;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.ssi.constant.URL;
import com.ssi.entity.VmsShipNcl;
import com.ssi.entity.dto.VmsTosOrdersDto;
import com.ssi.response.SSIResponse;

public class TestGetBean {
	private Connection connection;
	private PreparedStatement UserQuery;
	/* mysql url的连接字符串 */
//    private static String url = "jdbc:mysql://127.0.0.1:3306/rad?useUnicode=true&characterEncoding=UTF-8";  
	private static String url = "jdbc:oracle:thin:@//172.16.1.239:1521/test2.coscoyh.com.cn";
	// 账号 172.16.1.239:1521/test2.coscoyh.com.cn
	private static String user = "XMYH_DCV";
	// 密码
	private static String password = "coscoyh";
	private Vector<String> vector = new Vector<String>();
	// mysql jdbc的java包驱动字符串
//    private String driverClassName = "com.mysql.jdbc.Driver"; 
	private String driverClassName = "oracle.jdbc.OracleDriver";

	// 数据库中的表名
	String table = "sys_logs";
	// 数据库的列名称
	private String[] colnames; // 列名数组
	// 列名类型数组
	private String[] colTypes;

	public TestGetBean() {
		try {// 驱动注册
			Class.forName(driverClassName);
			if (connection == null || connection.isClosed())
				// 获得链接
				connection = DriverManager.getConnection(url, user, password);
		} catch (ClassNotFoundException ex) {
			ex.printStackTrace();
			System.out.println("Oh,not");
		} catch (SQLException e) {
			e.printStackTrace();
			System.out.println("Oh,not");
		}
	}

	public Connection getConnection() {
		return connection;
	}

	public void setConnection(Connection connection) {
		this.connection = connection;
	}

	public void doAction() {
		String sql = "select * from " + table;
		try {
			PreparedStatement statement = connection.prepareStatement(sql);
			// 获取数据库的元数据
			ResultSetMetaData metadata = statement.getMetaData();
			// 数据库的字段个数
			int len = metadata.getColumnCount();
			// 字段名称
			colnames = new String[len + 1];
			// 字段类型 --->已经转化为java中的类名称了
			colTypes = new String[len + 1];
			for (int i = 1; i <= len; i++) {
				// System.out.println(metadata.getColumnName(i)+":"+metadata.getColumnTypeName(i)+":"+sqlType2JavaType(metadata.getColumnTypeName(i).toLowerCase())+":"+metadata.getColumnDisplaySize(i));
				// metadata.getColumnDisplaySize(i);
				colnames[i] = metadata.getColumnName(i); // 获取字段名称
				System.out.println(colnames[i]);
				colTypes[i] = sqlType2JavaType(metadata.getColumnTypeName(i)); // 获取字段类型
				System.out.println(metadata.getColumnTypeName(i));
				System.out.println(colTypes[i]);
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
	}

	/*
	 * mysql的字段类型转化为java的类型
	 */
	private String sqlType2JavaType(String sqlType) {

		if (sqlType.equalsIgnoreCase("bit")) {
			return "boolean";
		} else if (sqlType.equalsIgnoreCase("tinyint")) {
			return "byte";
		} else if (sqlType.equalsIgnoreCase("smallint")) {
			return "short";
		} else if (sqlType.equalsIgnoreCase("int")) {
			return "int";
		} else if (sqlType.equalsIgnoreCase("bigint")) {
			return "long";
		} else if (sqlType.equalsIgnoreCase("float")) {
			return "float";
		} else if (sqlType.equalsIgnoreCase("decimal") || sqlType.equalsIgnoreCase("numeric")
				|| sqlType.equalsIgnoreCase("real") || sqlType.equalsIgnoreCase("money")
				|| sqlType.equalsIgnoreCase("smallmoney")) {
			return "double";
		} else if (sqlType.equalsIgnoreCase("varchar") || sqlType.equalsIgnoreCase("char")
				|| sqlType.equalsIgnoreCase("nvarchar") || sqlType.equalsIgnoreCase("nchar")
				|| sqlType.equalsIgnoreCase("text")) {
			return "String";
		} else if (sqlType.equalsIgnoreCase("datetime") || sqlType.equalsIgnoreCase("date")) {
			return "Date";
		} else if (sqlType.equalsIgnoreCase("image")) {
			return "Blod";
		} else if (sqlType.equalsIgnoreCase("timestamp")) {
			return "Timestamp";
		}

		return null;
	}

	/*
	 * 获取整个类的字符串并且输出为java文件
	 */
	public StringBuffer getClassStr() {
		// 输出的类字符串
		StringBuffer str = new StringBuffer("");
		// 获取表类型和表名的字段名
		this.doAction();
		// 校验
		if (null == colnames && null == colTypes)
			return null;
		// 拼接
		str.append("public class " + GetTuoFeng(table) + " {\r\n");
		// 拼接属性
		for (int index = 1; index < colnames.length; index++) {
			str.append(getAttrbuteString(colnames[index], colTypes[index]));
		}
		// 拼接get，Set方法
		for (int index = 1; index < colnames.length; index++) {
			str.append(getGetMethodString(colnames[index], colTypes[index]));
			str.append(getSetMethodString(colnames[index], colTypes[index]));
		}
		str.append("}\r\n");
		// 输出到文件中
//        File file = new File("E:/mengwx/【源码】mysql版本_spring4.0/FHMYSQL/src/com/fh/entity/"+GetTuoFeng(table)+".java");  
//        BufferedWriter write = null;  
//  
//        try {  
//            write = new BufferedWriter(new FileWriter(file));  
//            write.write(str.toString());  
//            write.close();  
//        } catch (IOException e) {  
//  
//            e.printStackTrace();  
//            if (write != null)  
//                try {  
//                    write.close();  
//                } catch (IOException e1) {            
//                    e1.printStackTrace();  
//                }  
//        }  
		return str;
	}

	/*
	 * 获取字段字符串
	 */
	public StringBuffer getAttrbuteString(String name, String type) {
		if (!check(name, type)) {
			System.out.println("类中有属性或者类型为空");
			return null;
		}
		;
		String format = String.format("    private %s %s;\n\r", new String[] { type, name });
		return new StringBuffer(format);
	}

	/*
	 * 校验name和type是否合法
	 */
	public boolean check(String name, String type) {
		if ("".equals(name) || name == null || name.trim().length() == 0) {
			return false;
		}
		if ("".equals(type) || type == null || type.trim().length() == 0) {
			return false;
		}
		return true;

	}

	/*
	 * 获取get方法字符串
	 */
	private StringBuffer getGetMethodString(String name, String type) {
		if (!check(name, type)) {
			System.out.println("类中有属性或者类型为空");
			return null;
		}
		;
		String Methodname = "get" + GetTuoFeng(name);
		String format = String.format("    public %s %s(){\n\r", new Object[] { type, Methodname });
		format += String.format("        return this.%s;\r\n", new Object[] { name });
		format += "    }\r\n";
		return new StringBuffer(format);
	}

	// 将名称首字符大写
	private String GetTuoFeng(String name) {
		name = name.trim();
		if (name.length() > 1) {
			name = name.substring(0, 1).toUpperCase() + name.substring(1);
		} else {
			name = name.toUpperCase();
		}
		return name;
	}

	/*
	 * 获取字段的get方法字符串
	 */
	private Object getSetMethodString(String name, String type) {
		if (!check(name, type)) {
			System.out.println("类中有属性或者类型为空");
			return null;
		}
		;
		String Methodname = "set" + GetTuoFeng(name);
		String format = String.format("    public void %s(%s %s){\n\r", new Object[] { Methodname, type, name });
		format += String.format("        this.%s = %s;\r\n", new Object[] { name, name });
		format += "    }\r\n";
		return new StringBuffer(format);
	}

//	public static void main(String[] args) {
//    	TestGetBean bean = new TestGetBean();  
//        System.err.println(bean.getClassStr());  
//    	JSONObject param = new JSONObject();
//       Integer []aa= {22};
//       String []bb= {"19","20"};
//       param.put("ids",aa);//区域类型。1桥下，2桥后
//       param.put("priority", 1);
//       String paramData = JSONObject.toJSONString(param);
//       System.out.println("绘制地图区域保存请求发送------"+ paramData);
//       String result = RestTemplateUtil.post("http://10.11.10.1:8030/vehicleBuffer/priority" , paramData, null);
//       System.out.print(String.format("绘制地图区域保存返回结果:----%s", result));

//       JSONObject param = new JSONObject();
//       String tempIds="19,2";
//      
//      List<Integer> tempId = new ArrayList<>();
//       
//      String[] ids = tempIds.split(",");
//      for (String id : ids){
//     	 tempId.add(Integer.parseInt(id));
//     	
//      }
//
//      String paramData = JSONObject.toJSONString(tempId);
//    System.out.println("绘制地图区域保存请求发送------"+ paramData);
//    String result = RestTemplateUtil.post("http://10.11.10.1:8030/vehicleBuffer/delete" , paramData, null);
//    System.out.print(String.format("绘制地图区域保存返回结果:----%s", result));
//     System.out.println(StringUtils.isNumeric("12,"));
//		String Str1 = "P1156756";
//		List t = new ArrayList();
//		System.out.println(t.size() < 0);
////    	VmsShipNcl t=new VmsShipNcl();
//		String arg = "";
//		System.out.println(JsonUtil.jsonToMap(arg));
//        System.out.println();
//       param.put("seq",456);//编号
//       param.put("lng1",11.11);
//       param.put("lat1",12.23);
//       param.put("lng2",23.23);
//       param.put("lat2",23.2);
//       param.put("lng3",23.3);
//       param.put("lat3",23.7);
//       param.put("lng4",26.2);
//       param.put("lat4",24.5);
//       param.put("field","F");//场区（E/F）
//       param.put("placeType",2);//区域类型。1桥下，2桥后
//       param.put("id",19);//区域类型。1桥下，2桥后
//       param.put("name","2223");//名称
//       param.put("type",1);//类型。1缓冲区；2停车区;3:充电区
//       param.put("state",1);//状态。0可用；1不可用（初始状态）;2已计划;3有车
//
//       String paramData = JSONObject.toJSONString(param);
//       System.out.print(String.format("绘制地图区域保存请求发送:----%s", paramData));
//       String result = RestTemplateUtil.post("http://10.11.10.1:8030/vehicleBuffer/edit" , paramData, null);
////       String result = RestTemplateUtil.post(String.format("%s%s", "http://10.11.10.1:8030/vehicleBuffer/edit", URL.MAP_EDIT_URL), paramData, null);
//       System.out.print("绘制地图区域保存返回结果:------------"+result);

//	}

	public void testkafa(VmsTosOrdersDto dto) {
//    	KafkaTemplate<String, String> kafkaTemplate =new KafkaTemplate<String, String>( );
		JSONObject param = new JSONObject();
		Date date = new Date();
		param.put("taskNo", UUID.randomUUID().toString().replace("-", ""));// 任务编号
		param.put("seq", UUID.randomUUID().toString().replace("-", ""));// 序号
		param.put("taskAssociation", "");// 任务关联
		param.put("vin", dto.getVin());// 车辆编号
		param.put("taskLocationType", dto.getTaskLocationType());// 任务类型 作业位置类型
																	// 1-去堆场（装箱或卸箱）;2-去停车点（上扭锁，解扭锁，停车）;3-去固定停车区;4-去临时停车区;5-去桥吊（装箱或卸箱）；6-去充电
		param.put("taskType", dto.getTaskType());// 作业类型 1-装箱，2-卸箱
		param.put("vehicleTaskType", dto.getVehicleTaskType());// 车辆任务类型 对应着前台 集装箱类型
		param.put("portCode", dto.getPortCode());// 港机编码
		if (dto.getPortCode().substring(0, 1).equals("1")) {
			param.put("portType", "1");// 港机类型
		} else {
			param.put("portType", "2");// 港机类型
		}
		param.put("vehicleLocation", dto.getVehicleLocation());// 车辆任务目标地点 对应前台 堆场贝位
		param.put("cartonConditon", "0");// 辆当前装箱状态
		param.put("containerId", dto.getContainerId());// 集装箱ID
		if (dto.getVehicleTaskType().equals("1")) {
			param.put("containerType", "40");// 集装箱类型
		} else {
			param.put("containerType", "20");// 集装箱类型
		}

		param.put("containerWeight", "1");// 集装箱重量

//          param.put("containerPosition","");//集装箱车上位置
//          param.put("overSign","");// 作业完成信号
		param.put("collectTime", date);// 作业时间
//          param.put("voyuageNo","");//艘次编号
		param.put("lockLabel", dto.getLockLabel());// 扭锁标签
		if (dto.getTaskLocationType().equals("1")) {
			param.put("containerLabel", "1");
		} else {
			param.put("containerLabel", "2");
		}

		String paramData = JSONObject.toJSONString(param);
//          log.info(String.format("绘制地图区域保存请求发送:----%s", paramData));
//          this.kafkaTemplate.send(topic, key, data);
	}
	public static void main(String[] args) {
		String mapdata="P1223456780";
		System.out.println(Integer.valueOf(mapdata.substring(1)));
//		String path="D:\\code/lsz.geojson";
////		String path = JsonTest.class.getClassLoader().getResource("students.json").getPath();
//        String s = readJsonFile(path);
//        JSONObject jobj = JSON.parseObject(s);
//        JSONArray student = jobj.getJSONArray("features");//构建JSONArray数组
//        for (int i = 0 ; i < student.size();i++){
//            JSONObject key = (JSONObject)student.get(i);
//            int stuId= (Integer)key.get("id");
//            Object stuName= (Object)key.get("geometry");
////            int stuAge= (Integer)key.get("stuAge");
//            JSONObject jsonObject = JSONObject.parseObject(stuName.toString());
//            
//            for(String str:jsonObject.keySet()) {
//           	 if(str.equals("coordinates")) {
////           		jsonObject.get(str);
//           	   System.out.println(stuId+"----"+jsonObject.get(str));
//           	 }
//            }
// 
//        }
//		System.out.println(readJsonFile("D:\\code/lsz.geojson"));
	}
	public static String readJsonFile(String fileName) {
		String jsonStr = "";
		try {
			File jsonFile = new File(fileName);
			FileReader fileReader = new FileReader(jsonFile);
			Reader reader = new InputStreamReader(new FileInputStream(jsonFile), "utf-8");
			int ch = 0;
			StringBuffer sb = new StringBuffer();
			while ((ch = reader.read()) != -1) {
				sb.append((char) ch);
			}
			fileReader.close();
			reader.close();
			jsonStr = sb.toString();
			return jsonStr;
		} catch (IOException e) {
			e.printStackTrace();
			return null;
		}
	}

}