package com.ssi.utils.grid;

import java.io.Serializable;

/**
 * 网格标识点对象：
 *       x,y 为 墨卡托坐标
 */
public class MercatorPoint implements Serializable {

    private double x;
    private double y;

    public MercatorPoint(double x, double y){
        assert Coordtransform.outOfChinaByMercator(x, y): "坐标点位必须在中国国内。";
        this.x = x;
        this.y = y;
    }

    public double getX() {
        return x;
    }

    public double getY() {
        return y;
    }

    public MercatorPoint clone(){
        return new MercatorPoint(x, y);
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        MercatorPoint that = (MercatorPoint) o;

        if (Double.compare(that.x, x) != 0) return false;
        return Double.compare(that.y, y) == 0;
    }

    @Override
    public int hashCode() {
        int result;
        long temp;
        temp = Double.doubleToLongBits(x);
        result = (int) (temp ^ (temp >>> 32));
        temp = Double.doubleToLongBits(y);
        result = 31 * result + (int) (temp ^ (temp >>> 32));
        return result;
    }

    @Override
    public String toString() {
        final StringBuffer sb = new StringBuffer("[");
        sb.append("x=").append(x);
        sb.append(", y=").append(y);
        sb.append(']');
        return sb.toString();
    }

}
