package com.ssi.websocket.push.task;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.ssi.entity.CraneInfo;
import com.ssi.entity.VmsVehicle;
import com.ssi.mapper.VmsVehicleMapper;
import com.ssi.model.RedisDataModel;
import com.ssi.service.CraneInfoService;
import com.ssi.websocket.CraneInfoWebSocketServer;
import com.ssi.websocket.ReplaySocketServer;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.collections.MapUtils;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;
import java.util.Queue;
import java.util.concurrent.CopyOnWriteArraySet;
import java.util.concurrent.LinkedBlockingQueue;
import java.util.stream.Collectors;

/**
 * 推送吊具实时信息定时任务
 */
@Component
@EnableScheduling
public class ReplayTask {

    private static Logger log = LoggerFactory.getLogger(ReplayTask.class);

    private static Queue<Map<String, Object>> replayCache = new LinkedBlockingQueue<>();

    public static Queue<Map<String, Object>> getReplayCache() {
        return replayCache;
    }

    public static void setReplayCache(List<Map<String, Object>> replayCaches) {
        replayCache.clear();
        replayCache.addAll(replayCaches);
    }

    @Scheduled(cron = "0/1 * * * * ? ")
    public void getCraneInfo() throws Exception {

        Queue<Map<String, Object>> replayCache = getReplayCache();
        if(replayCache.size()>1){
            Map<String, Object> poll = replayCache.poll();
            ReplaySocketServer.messageBroadcast(JSON.toJSONString(poll));
        }else{
            ReplaySocketServer.messageBroadcast(null);
        }

    }

}
