package com.ssi.websocket.push.task;

import com.alibaba.fastjson.JSONArray;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.ssi.entity.VmsTrafficLightInfo;
import com.ssi.mapper.VmsTrafficLightInfoMapper;
import com.ssi.model.RedisDataModel;
import com.ssi.websocket.TrafficLampInfoWebSocketServer;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.collections.MapUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;

/**
 * @author SunnyHotz
 * @PackageName:com.ssi.websocket.push.task
 * @ClassName:SyncTrafficLampInfo
 * @Description:
 * @date 2022/9/28 13:21
 */
@Component
public class SyncTrafficLampInfo {

    @Autowired
    private RedisDataModel redisDataModel;

    @Autowired
    private VmsTrafficLightInfoMapper vmsTrafficLightInfoMapper;

    @Scheduled(cron = "0/1 * * * * ?")
    public void syncSchedule(){

        List<VmsTrafficLightInfo> vmsTrafficLightInfos = vmsTrafficLightInfoMapper.selectList(new LambdaQueryWrapper<>());
        if(CollectionUtils.isEmpty(vmsTrafficLightInfos)){
            return;
        }
        JSONArray objects = new JSONArray();
        vmsTrafficLightInfos.stream().forEach(lamp ->{
            Map<String, Object> map = redisDataModel.hgetJson2Map("ivccs:vms:traffic:light", lamp.getCrossId());
            if(MapUtils.isEmpty(map)){
                return;
            }
            map.put("crossId",lamp.getCrossId());
            objects.add(map);
        });

        TrafficLampInfoWebSocketServer.messageBroadcast(objects.toJSONString());

    }

}
