package com.ssi.websocket.push.task;

import com.alibaba.fastjson.JSONObject;
import com.ssi.entity.VmsCranePadBind;
import com.ssi.entity.VmsVehicle;
import com.ssi.response.SSIResponse;
import com.ssi.service.VmsCranePadBindService;
import com.ssi.service.VmsTosOrdersService;
import com.ssi.service.VmsVehicleService;
import com.ssi.websocket.WebSocketServiceForVideoList;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.io.IOException;
import java.util.List;
import java.util.Map;
import java.util.concurrent.CopyOnWriteArraySet;
import java.util.function.Function;
import java.util.stream.Collectors;

/**
 * 吊具APP任务推送任务
 * @author ZhangLiYao
 * @version 1.0
 * @date 2020/8/6 10:00
 */
@Component
@EnableScheduling
public class VideoStatusListTask {

    @Autowired
    private VmsTosOrdersService vmsTosOrdersService;
    @Autowired
    private VmsVehicleService vmsVehicleService;
    @Autowired
    private VmsCranePadBindService vmsCranePadBindService;

    @Scheduled(fixedRateString = "10000")
    private void getOrdersOfTask() {

        if(!WebSocketServiceForVideoList.hasWebSocketSession()){
            return;
        }
        List<VmsVehicle> vehicleList = vmsVehicleService.getNormalVehicle();
        SSIResponse ssiResponse = vmsVehicleService.listForMonitor(vehicleList);
        //群发消息
        WebSocketServiceForVideoList.messageBroadcast(JSONObject.toJSONString(ssiResponse.getData()));
    }
}
